
#include <iostream>
#include <string>
#include <fstream>
#include "CLODDC.h"
#include "oformat.h"
using namespace std;




int main()	{
	cout << "\n\tThis is the Campaign Creation Tool!\n\n"
		 << "It creates the files necessary to initialize a\n"
		 << "Self Inflicted Dynamic Campaign for the\n"
		 << "IL- 2 Cliffs of Dover desktop flight simulator\n"
		 << "out of a .mis file built in the Full Mission Builder.\n"
		 << "It is also possible to roll back a backup of an"
		 << "old campaign.\n\n";
	ifstream in("SIDCMission.state");
	if(in)	{
		cout << "\nRemoving the old campaign. The \"DataBackup\" folder\n"
			 << "will not be removed yet in case You feel the need to fly that\n"
			 << "campaign again. It is up to You to rename that folder manually\n"
			 << "or to move the folder and the corresponding .mis file\n"
			 << "somewhere safe. Come back to this screen and continue after\n"
			 << "You\' ve done that...\n\n";
		pressc();
		cout << "\n\nRemoving the \"DataBackup\" folder now...\n";
		system("del /Q \"DataBackup\\*.*\"");
		system("rmdir DataBackup");
		in.close();
		cleanup();
		cout << "\nDone cleaning up!\n\n";
		cin.ignore(256, '\n');
	}
	in.close();
	char choice = 'a';
	cout << "Do You wish to:\n"
		 << "1. Create a new campaign from a .mis file\n"
		 << "You created in the Full Mission Builder, or\n"
		 << "\n2. Roll back the backup of an old campaign\n"
		 << "from a backup folder?\n\n"
		 << "Type \'1\' or \'2\' and press ENTER!\n\n\n";
	while((choice != '1') && (choice != '2'))	{
		cin >> choice;
		if((choice != '1') && (choice != '2'))
			cout << "\n\nPlease select 1 or 2!\n\n";
		cin.ignore(256, '\n');
	}
	if(choice == '1')	{
		cout << "\nPlease enter the name of the .mis file You built\n"
			 << "in the Full Mission Builder:\n\n";
		std::string missfilename;
		getline(cin, missfilename, '\n');
		{																
			ifstream in1(missfilename);
			seArray<string, 70> missF;
			string line;
			bool isIn = false;
			while(getline(in1, line))
				missF.add(line);
			for(int i = 0; i < missF.getSize(); i++)
				if(missF[i].find("player") != -1)	{
					isIn = true;
					break;
				}
			if(!isIn)	{
				cout << "\n\nThe .mis file You specified doesn\' t contain\n"
					 << "a line specifying a pilot. Please go back to the\n"
					 << "Full Mission Builder, load your .mis file, select\n"
					 << "one of the air groups and tick a \"player\" checkbox\n"
					 << "for one of the planes. Then restart this application.\n\n\n";
				pressc();
				exit(1);	 
			}
		}
		{
			{
				checkBlitz cB;								
				cB.save();
			}
			cout << "\nType altitude and range in meters when prompted!\n\n";
			modeSetter ms;
			ms.setMode(true);
			mainTables mt(missfilename);
			pattern pat(missfilename);
			copyPaths(mt, pat);
			timeFlow tf;
			ifstream pin("pilotLogBook");
			if(pin)	{
				planesData pdata;
				pdata.load(missfilename);
				pilotLog plog;
				plog.load(missfilename);
				string currGroup = plog.getGroupID(missfilename);
				for(int i = 0; i < pdata.Airgroups.getSize(); i++)
					if(currGroup == pdata.Airgroups[i])
						if(plog.getSide() != pdata.side[i])	{
							cout << "\n\nThe side You flew for during Your previous campaign\n"
								 << "doesn\' t match the side You chose to fly for in Your new\n"
								 << "campaign. You now need to select the country which corresponds\n"
								 << "to the country and side set in the new .mis file...\n\n";
							system("del ranks");
							plog.switchSide();
							plog.askRank();
							if(plog.getSide() != pdata.side[i])	{
								cout << "\nThe country You chose isn\' t on the proper side. Please reconsider.\n";
								plog.askRank();
							}
							break;
						}
				plog.setGNameFF(missfilename);
				plog.checkAirGroup(missfilename);
				plog.save();
			}
			if(!pin)	{
				pilotLog plog;
				plog.load(missfilename);
				plog.setGNameFF(missfilename);
				plog.checkAirGroup(missfilename);
				plog.save();
			}
			pin.close();
			save(mt, pat, ms);
			ms.setMode(false);
			ms.save();
			backup();
			cout << "\nSaved the first state file!\n\n";
			pressc();	
		}
		{
			cout << "\n\nChecking if errors were made while editing the .dat\n"
				 << "files if those were edited. Keep in mind that everything will\n"
				 << "work with the default values...\n\n";
			mainTables mt(missfilename);
			cout << "\nAparently, everything is OK!\n\n";
			pressc();
		}
		{
			cout << "\nAbout to save the first .mis file...\n\n";
			modeSetter ms;
			mainTables mt("SIDCMission.state");
			pattern pat("SIDCMission.state");
			copyPaths(mt, pat);
			denyFlight(mt, pat);
			pilotLog plog;
			plog.load("SIDCMission.state");
			plog.checkAirGroup(missfilename);
			plog.MPLine();																					
			planMissions(mt, plog);
			save(mt, pat, ms);
			missionCount mc;
			mc.set();
			mc.save();
			saveBriefings(mt, mc.get());
			plog.resetBALine();									
			plog.save();
			markFront(mt, pat, ms);
			ms.setMode(true);
			ms.save();
			cout << "\nSaved the first .mis file!\n"
				 << "Now, start the simulator up, select\n"
				 << "\"Single player\" in the main menu,\n"
				 << "select \"Single missions\", then \"SIDC\",\n"
				 << "and finally select\n"
				 << "\"Self Induced Dynamic Campaign Mission No. 1\"\n\n\n";
			pressc();
		}
	}
	if(choice == '2')	{
		std::string folderPath;
		cout << "\nPlease enter the path to the folder containing\n"
			 << "the backup:\n\n";
		getline(cin, folderPath, '\n');
		if(copyFromBackup(folderPath))	{
			{
				{
					checkBlitz cb;
				}
				planesData pdata;
				pdata.load("SIDCMission.state");
				pilotLog plog;
				plog.load("SIDCMission.state");
				string currGroup = plog.getGroupID("SIDCMission.state");
				for(int i = 0; i < pdata.Airgroups.getSize(); i++)
					if(currGroup == pdata.Airgroups[i])
						if(plog.getSide() != pdata.side[i])	{
							cout << "\n\nThe side You flew for during Your previous campaign\n"
								 << "doesn\' t match the side You chose to fly for in Your new\n"
								 << "campaign. You now need to select the country which corresponds\n"
								 << "to the country and side set in the new .mis file...\n\n";
							system("del ranks");
							plog.switchSide();
							plog.askRank();
							if(plog.getSide() != pdata.side[i])	{
								cout << "\nThe country You chose isn\' t on the proper side. Please reconsider.\n";
								plog.askRank();
							}
							break;
						}
				plog.setGNameFF("SIDCMission.state");
				plog.checkAirGroup("SIDCMission.state");
				plog.save();
			}
			backup();
			{
				cout << "\nAbout to save the first .mis file...\n\n";
				modeSetter ms;
				mainTables mt("SIDCMission.state");
				pattern pat("SIDCMission.state");
				copyPaths(mt, pat);
				denyFlight(mt, pat);
				pilotLog plog;
				plog.load("SIDCMission.state");
				plog.checkAirGroup("SIDCMission.state");
				plog.MPLine();																			
				planMissions(mt, plog);
				save(mt, pat, ms);
				missionCount mc;
				mc.set();
				mc.save();
				saveBriefings(mt, mc.get());
				plog.resetBALine();										
				plog.save();
				markFront(mt, pat, ms);
				ms.setMode(true);
				ms.save();
				cout << "\nSaved the first .mis file!\n"
					 << "Now, start the simulator up, select\n"
					 << "\"Single player\" in the main menu,\n"
					 << "select \"Single missions\", then \"SIDC\",\n"
					 << "and finally select\n"
					 << "\"Self Induced Dynamic Campaign Mission No. 1\"\n\n\n";
				pressc();
			}
		}
	}
}


