﻿using System;
using System.IO;
using maddox.game;
using maddox.game.world;
using maddox.GP;
using System.Collections.Generic;
using System.Globalization;

public class Mission : AMission	{
    DateTime missionStart;
	public override void OnBattleStarted()	{
		base.OnBattleStarted();
        missionStart = DateTime.Now;
		MissionNumberListener = -1;
        string logPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\1C SoftClub\\il-2 sturmovik cliffs of dover\\missions\\Single\\SIDC\\kill.log";
        if (File.Exists(logPath))
            File.Delete(logPath);
    }
	public override void OnActorDead(int missionNumber, string shortName, AiActor actor, List<DamagerScore> initiatorList)	{
		base.OnActorDead(missionNumber, shortName, actor, initiatorList);
        string logPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\1C SoftClub\\il-2 sturmovik cliffs of dover\\missions\\Single\\SIDC";
        using (StreamWriter sw = new StreamWriter(Path.Combine(logPath, "kill.log"), true))    {
            if (actor is AiGroundActor) 
                sw.WriteLine("Name: [" + actor.Name() + "], position: " + actor.Pos().x.ToString() + ", " + actor.Pos().y.ToString());
            if (actor is AiActor)   {
                sw.WriteLine("Name: [" + actor.Name() + "], position: " + actor.Pos().x.ToString() + ", " + actor.Pos().y.ToString());
                if (!GamePlay.gpPlayer().Place().IsAlive())
                    sw.WriteLine("DeadPilot");
                if (actor != null && initiatorList.Count > 0)
                {
                    foreach (DamagerScore d in initiatorList)
                    {
                        if (d.score > .5 && d.initiator.Player != null)
                            sw.WriteLine("KilledByPilot");
                    }
                }
            }
        }
	}
	public override void OnStationaryKilled(int missionNumber, GroundStationary gs, AiDamageInitiator initiator, int eventArgInt)	{
        base.OnStationaryKilled(missionNumber, gs, initiator, eventArgInt);
        string logPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\1C SoftClub\\il-2 sturmovik cliffs of dover\\missions\\Single\\SIDC";
        using (StreamWriter sw1 = new StreamWriter(Path.Combine(logPath, "kill.log"), true))    {
            sw1.WriteLine("Name: [" + gs.Name + "], position: " + gs.pos.x.ToString() + ", " + gs.pos.y.ToString());
		}
	}
    public override void OnAircraftLanded(int missionNumber, string shortName, AiAircraft aircraft) {
        base.OnAircraftLanded(missionNumber, shortName, aircraft);
        string logPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\1C SoftClub\\il-2 sturmovik cliffs of dover\\missions\\Single\\SIDC";
        using (StreamWriter sw3 = new StreamWriter(Path.Combine(logPath, "kill.log"), true))
            sw3.WriteLine(shortName + " Landed");
    }
    public override void OnBattleStoped()   {
           {
                    TimeSpan interval = DateTime.Now - missionStart;
                    int duration = (int)interval.TotalMinutes;
                    string logPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\1C SoftClub\\il-2 sturmovik cliffs of dover\\missions\\Single\\SIDC";
                    using (StreamWriter sw2 = new StreamWriter(Path.Combine(logPath, "kill.log"), true))
                          sw2.WriteLine("Mission duration: [" + duration.ToString() + "]");
            }
// Auto Run here...
        string argument = "/C SIDC.exe";
        string directory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\1C SoftClub\\il-2 sturmovik cliffs of dover\\missions\\Single\\SIDC";
        System.Diagnostics.Process process = new System.Diagnostics.Process(); 
        System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo();
//        startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
        startInfo.FileName = "cmd.exe";
        startInfo.Arguments = argument;
        startInfo.WorkingDirectory = directory;
        startInfo.UseShellExecute = false;
        process.StartInfo = startInfo;
        process.Start();
        base.OnBattleStoped();
    }
}