
#include "CLODDC.h"
#include <fstream>
#include <string>




std::string makeMapLine(pattern& ppat)	{
	std::string winterMap, autumnMap, summerMap, springMap;
	for(int i = 0; i < ppat.missionMis.getSize(); i++)
		if(ppat.missionMis[i].find("MAP") != -1)	{
			winterMap = ppat.missionMis[i];
			autumnMap = ppat.missionMis[i];
			summerMap = ppat.missionMis[i];
			springMap = ppat.missionMis[i];
			break;
		}
	timeFlow tf;
	checkBlitz cb;
	if(cb.get())	{
		if(tf.getSeason() == "summer")	{
			summerMap = "  MAP Land$English_Channel_1940";
			return summerMap;
		}
		if(tf.getSeason() == "spring")	{
			springMap = "  MAP Land$English_Channel_1940";
			return springMap;
		}
		if(tf.getSeason() == "autumn")	{
			autumnMap = "  MAP Land$English_Channel_1940_Autumn";
			return autumnMap;
		}
		if(tf.getSeason() == "winter")	{
			winterMap = "  MAP Land$English_Channel_1940_Winter";
			return winterMap;
		}
	}
	if(!cb.get())	{
		return winterMap;
	}
}



std::string makeTime()	{
	timeFlow tf;
	return "  TIME " + std::to_string(tf.getMissionTime());
}




void missionCount::load()	{
	std::ifstream instr("MissionCount");
	std::string line;
	std::size_t sz;
	if(instr)	{
		getline(instr, line);
		missionNo = std::stoi(line, &sz);
	}
	if(!instr)
		save();
}

void missionCount::save()	{
	std::ofstream ostr("MissionCount");
	ostr << std::to_string(missionNo);
}



void timeFlow::setMissionDuration()	{
	std::ifstream klin("kill.log");
	if(!klin)
		return;
	seArray<std::string, 20> killLog;
	std::string kline;
	std::size_t firstBracket, secondBracket, sz;
	while(getline(klin, kline))
		killLog.add(kline);
	for(int i = 0; i < killLog.getSize(); i++)
		if(killLog[i].find("duration") != -1)	{
			kline = killLog[i];
			break;
		}
	firstBracket = kline.find('[');
	secondBracket = kline.find(']');
	kline = kline.substr(firstBracket + 1, secondBracket - firstBracket - 1);
	missionDuration = std::stoi(kline, &sz);
}

void timeFlow::save()	{
	std::ofstream ofs("campaignTime");
	long long ct;
	ct = mktime(currTime);
	ofs << std::to_string(ct) << '\n' << std::to_string(startTime) << '\n' << std::to_string(before70) << '\n' << std::to_string(prevMissionStart) << '\n' << std::to_string(prevMissionDay) << '\n' << std::to_string(prevMissionYear) << '\n';
}

void timeFlow::load()	{
	std::ifstream sin("campaignTime");
	if(sin)	{
		std::string line;
		std::size_t sz;
		time_t ct, st;
		seArray<std::string, 2> times;
		while(getline(sin, line))
			times.add(line);
		if(times.getSize() != 6)	{
			std::cout << std::endl << std::endl << "campaignTime file corrupt!" << std::endl << std::endl
			          << "Please delete it and run the application again.\n\n"
			          << "Press 'c' and then ENTER to continue.\n\n\n";
			char c;
			while(c != 'c')
				std::cin >> c;
			exit(1);
		}
		ct = std::stoll(times[0], &sz);
		st = std::stoll(times[1], &sz);
		before70 = std::stoi(times[2], &sz);
		prevMissionStart = std::stoi(times[3], &sz);
		prevMissionDay = std::stoi(times[4], &sz);
		prevMissionYear = std::stoi(times[5], &sz);
		currTime = localtime(&ct);
		startTime = st;
		mktime(currTime);
		chkTime();
	} else	{
		sin.close();
		int day, month, year;
		time_t rawtime;
		struct tm* stime;
		std::cout << "\n\nWhen will this Self Inflicted Dynamic Campaign start?\n"
		          << "Type the year: ";
		std::cin >> year;
		std::cout << "\nType month (1 - 12): ";
		std::cin >> month;
		if((month < 1) || (month > 12))	{
			std::cout << "\n\nNot a month of a year, setting the value to January!\n\n";
			month = 1;
		}
		std::cout << "\nType the day of the month (1 - 31): ";
		std::cin >> day;
		if((day < 1) || (day > 31))	{
			std::cout << "\n\nToo many days for a month, setting the value to the 1st!\n\n";
			day = 1;
		}
		time(&rawtime);
		stime = localtime(&rawtime);
		if(year < 1970)	{
			stime->tm_year = year - 1848;
			before70 = true;
		}
		if(year >= 1970)	{
			stime->tm_year = year - 1900;
			before70 = false;
		}
		stime->tm_mon = month - 1;
		stime->tm_mday = day;
		stime->tm_hour = 8;
		stime->tm_min = 0;
		startTime = mktime(stime);
		assigntm(currTime, stime);
		mktime(currTime);
		chkTime();
		prevMissionDay = currTime->tm_yday;
		prevMissionYear = currTime->tm_year;
		std::cout << "\n\nThis Self Inflicted Dynamic Campaign will start on: " << getTime() << std::endl << std::endl << std::endl;
		save();
	}
}



void moveVehicles(int pminutes)   {
	chiefsData cdata;
	cdata.load("SIDCMission.state");
	double shipSpeed = 10;
	double vehicleSpeed = 38.4;
	double min = static_cast<double>(pminutes);
	double time = min / 60;
	for(int i = 0; i < cdata.paths.getSize(); i++)   {
		if(cdata.justReversed[i])	{
			for(int l = 0; l <= cdata.paths[i].getLimit(); l++)	{
				bool value = cdata.paths[i].wpoints[l].passed;
				cdata.paths.mod(i)->wpoints[l].passed = !value;
			}
			*(cdata.justReversed.mod(i)) = false;
		}
		if(!cdata.reverse[i])	{
			int VMoveStart = 0;
			int VMoveEnd = 0;
			double WPDistance = 0;
			double FLWPDistance = 0;
			for(int ii = 0; ii < cdata.paths[i].getLimit(); ii++)
				FLWPDistance += distance(cdata.paths[i].wpoints[ii], cdata.paths[i].wpoints[ii + 1]);
			if(cdata.classid[i] != "ship")	{
				double distToTravel = time * vehicleSpeed * 1000;
				for(int j = 0; j <= cdata.paths[i].getLimit(); j++)   {
					if(j == cdata.paths[i].getLimit() || FLWPDistance <= distToTravel)    {
						VMoveEnd = cdata.paths[i].getLimit();
						break;
					}
					if(!cdata.paths[i].wpoints[j].passed)   {
						VMoveStart = j;
						double distToEnd = 0;
						for(int jj = VMoveStart; jj < cdata.paths[i].getLimit(); jj++)
							distToEnd += distance(cdata.paths[i].wpoints[jj], cdata.paths[i].wpoints[jj + 1]);
						if(distToEnd <= distToTravel)	{
							VMoveEnd = cdata.paths[i].getLimit();
							break;
						}
						for(int k = j; k < cdata.paths[i].getLimit(); k++)   {
							WPDistance += distance(cdata.paths[i].wpoints[k], cdata.paths[i].wpoints[k + 1]);
							if(WPDistance > distToTravel)   {
								VMoveEnd = k + 1;
								break;
							}
						}
						break;
					}
				}
			}
			if(cdata.classid[i] == "ship")	{
				double distToTravel = time * shipSpeed * 1000;
				for(int j = 0; j <= cdata.paths[i].getLimit(); j++)   {
					if(j == cdata.paths[i].getLimit() || FLWPDistance <= distToTravel)    {
						VMoveEnd = cdata.paths[i].getLimit();
						break;
					}
					if(!cdata.paths[i].wpoints[j].passed)   {
						VMoveStart = j;
						double distToEnd = 0;
						for(int jj = VMoveStart; jj < cdata.paths[i].getLimit(); jj++)
							distToEnd += distance(cdata.paths[i].wpoints[jj], cdata.paths[i].wpoints[jj + 1]);
						if(distToEnd <= distToTravel)	{
							VMoveEnd = cdata.paths[i].getLimit();
							break;
						}
						for(int k = j; k < cdata.paths[i].getLimit(); k++)   {
							WPDistance += distance(cdata.paths[i].wpoints[k], cdata.paths[i].wpoints[k + 1]);
							if(WPDistance > distToTravel)   {
								VMoveEnd = k + 1;
								break;
							}
						}
						break;
					}
				}
			}
			for(int l = VMoveStart; l <= VMoveEnd; l++)   {
				cdata.paths.mod(i)->wpoints[l].passed = true;
			}
		}
		if(cdata.reverse[i])	{
			int VMoveStart = cdata.paths[i].getLimit();
			int VMoveEnd = 0;
			double WPDistance = 0;
			double FLWPDistance = 0;
			for(int ii = 0; ii < cdata.paths[i].getLimit(); ii++)
				FLWPDistance += distance(cdata.paths[i].wpoints[ii], cdata.paths[i].wpoints[ii + 1]);
			if(cdata.classid[i] != "ship")	{
				double distToTravel = time * vehicleSpeed * 1000;
				for(int j = cdata.paths[i].getLimit(); j >= 0; j--)   {
					if(j == 0 || FLWPDistance <= distToTravel)    {
						VMoveEnd = 0;
						break;
					}
					if(!cdata.paths[i].wpoints[j].passed)   {
						VMoveStart = j;
						double distToEnd = 0;
						for(int jj = VMoveStart; jj > 0; jj--)
							distToEnd += distance(cdata.paths[i].wpoints[jj], cdata.paths[i].wpoints[jj - 1]);
						if(distToEnd <= distToTravel)	{
							VMoveEnd = 0;
							break;
						}
						for(int k = j; k > 0; k--)   {
							WPDistance += distance(cdata.paths[i].wpoints[k], cdata.paths[i].wpoints[k - 1]);
							if(WPDistance > distToTravel)   {
								VMoveEnd = k - 1;
								break;
							}
						}
						break;
					}
				}
			}
			if(cdata.classid[i] == "ship")	{
				double distToTravel = time * shipSpeed * 1000;
				for(int j = cdata.paths[i].getLimit(); j >= 0; j--)   {
					if(j == 0 || FLWPDistance <= distToTravel)    {
						VMoveEnd = 0;
						break;
					}
					if(!cdata.paths[i].wpoints[j].passed)   {
						VMoveStart = j;
						double distToEnd = 0;
						for(int jj = VMoveStart; jj > 0; jj--)
							distToEnd += distance(cdata.paths[i].wpoints[jj], cdata.paths[i].wpoints[jj - 1]);
						if(distToEnd <= distToTravel)	{
							VMoveEnd = 0;
							break;
						}
						for(int k = j; k > 0; k--)   {
							WPDistance += distance(cdata.paths[i].wpoints[k], cdata.paths[i].wpoints[k - 1]);
							if(WPDistance > distToTravel)   {
								VMoveEnd = k - 1;
								break;
							}
						}
						break;
					}
				}
			}
			for(int l = VMoveStart; l >= VMoveEnd; l--)   {
				cdata.paths.mod(i)->wpoints[l].passed = true;
			}
		}
	}
	cdata.save();
}



std::string makeMainBriefingLine(mainTables& pmt)	{
	std::string bline;
	factoriesData fdata;
	fdata.load("SIDCMission.state");
	timeFlow tf;
	if(assesResult != "NoString")
		bline  = assesResult;
	bline = bline + "Campaign time:\t" + tf.getTime() + "\nCampaign has lasted:\t" + std::to_string(tf.getCampaignDuration()) + " days." + "\n\nBalance \nof power:\t\t\tRed:\t\tBlue:\n";
	bline = bline + "Armor:\t\t\t\t" + std::to_string(pmt.tanksRed.getSize()) + "\t\t" + std::to_string(pmt.tanksBlue.getSize()) + '\n';
	bline = bline + "Artillery:\t\t\t\t" + std::to_string(pmt.gunsRed.getSize()) + "\t\t" + std::to_string(pmt.gunsBlue.getSize()) + '\n';
	bline = bline + "Radars:\t\t\t\t" + std::to_string(pmt.radarsRed.getSize()) + "\t\t" + std::to_string(pmt.radarsBlue.getSize()) + '\n';
	bline = bline + "Vehicles:\t\t\t\t" + std::to_string(pmt.vehiclesctRed.getSize()) + "\t\t" + std::to_string(pmt.vehiclesctBlue.getSize()) + '\n';
	bline = bline + "Ships:\t\t\t\t" + std::to_string(pmt.shipsRed.getSize()) + "\t\t" + std::to_string(pmt.shipsBlue.getSize()) + '\n';
	bline = bline + "Airfields:\t\t\t\t" + std::to_string(pmt.airfieldTargetsRed.getSize()) + "\t\t" + std::to_string(pmt.airfieldTargetsBlue.getSize()) + '\n';
	bline = bline + "Ports:\t\t\t\t" + std::to_string(pmt.portTargetsRed.getSize()) + "\t\t" + std::to_string(pmt.portTargetsBlue.getSize()) + '\n';
	bline = bline + "Factories:\t\t\t" + std::to_string(pmt.factoryTargetsRed.getSize() + pmt.subcontractorTargetsRed.getSize()) + "\t\t" + std::to_string(pmt.factoryTargetsBlue.getSize() + pmt.subcontractorTargetsBlue.getSize()) + '\n';
	bline = bline + "\n\n";
	bline = bline + "Red factories condition:" + '\n';
	for(int i = 0; i < fdata.factories.getSize(); i++)
		if(fdata.factories[i].side == "red")
			bline = bline + removeUnderscores(fdata.factories[i].name) + tabs(fdata.factories[i].name) + std::to_string(int(fdata.factories[i].bicycleNo() * 100)) + "%\n";
	for(int i = 0; i < fdata.subcontractors.getSize(); i++)
		if(fdata.subcontractors[i].side == "red")
			bline = bline + removeUnderscores(fdata.subcontractors[i].name) + tabs(fdata.factories[i].name) + std::to_string(int(fdata.subcontractors[i].bicycleNo() * 100)) + "%\n";
	bline = bline + "\n\nBlue factories condition:" + '\n';
	for(int i = 0; i < fdata.factories.getSize(); i++)
		if(fdata.factories[i].side == "blue")
			bline = bline + removeUnderscores(fdata.factories[i].name) + tabs(fdata.factories[i].name) + std::to_string(int(fdata.factories[i].bicycleNo() * 100)) + "%\n";
	for(int i = 0; i < fdata.subcontractors.getSize(); i++)
		if(fdata.subcontractors[i].side == "blue")
			bline = bline + removeUnderscores(fdata.subcontractors[i].name) + tabs(fdata.factories[i].name) + std::to_string(int(fdata.subcontractors[i].bicycleNo() * 100)) + "%\n";
	return bline;
}



const std::string tabs(std::string pname)	{
	int maxTabs = 4;
	std::string result = "";
	double slen = pname.length();
	double intTabNo = slen / 11;
	int tabNo = (int)intTabNo;
	for(int i = tabNo; i <= maxTabs; i++)
		result = result + "\t";
	return result;
}



void runAway(pattern& ppat)	{
	chiefsData cdata;
	cdata.load(ppat.getFileName());
	staticData sdata;
	sdata.load(ppat.getFileName());
	int redCount;
	int blueCount;
	const int relDistance = 5000;
	position relPosit;
	for(int i = 0; i < cdata.chiefname.getSize(); i++)	{
		redCount = 0;
		blueCount = 0;
		int pathIndex = 0;
		if((cdata.side[i] == "red") && (cdata.vehiclesNo[i] > 0) && (!cdata.reverse[i]) && ((cdata.classid[i] == "tank") || ((cdata.classid[i] == "ship") && (cdata.type[i].find("Tanker") == -1) && (cdata.type[i].find("Barge") == -1))))	{
			for(int j = 0; j <= cdata.paths[i].getLimit(); j++)	{
				if(j == cdata.paths[i].getLimit())
					pathIndex = cdata.paths[i].getLimit();
				if(!cdata.paths[i].wpoints[j].passed)	{
					pathIndex = j - 1;
					break;
				}
			}
			relPosit.positionX = cdata.paths[i].wpoints[pathIndex].positionX;
			relPosit.positionY = cdata.paths[i].wpoints[pathIndex].positionY;
			for(int k = 0; k < cdata.chiefname.getSize(); k++)	{
				int otherPathIndex = 0;
				if((cdata.side[k] == "blue") && (cdata.vehiclesNo[k] > 0) && ((cdata.classid[k] == "tank") || ((cdata.classid[k] == "ship") && (cdata.type[k].find("Tanker") == -1) && (cdata.type[k].find("Barge") == -1))))	{
					if(!cdata.reverse[k])
						for(int l = 0; l <= cdata.paths[k].getLimit(); l++)	{
							if(l == cdata.paths[k].getLimit())
								otherPathIndex = l;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l - 1;
								break;
							}
						}
					if(cdata.reverse[k])
						for(int l = cdata.paths[k].getLimit(); l >= 0; l--)	{
							if(l == 0)
								otherPathIndex = 0;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l + 1;
								break;
							}
						}
					if(distance(cdata.paths[i].wpoints[pathIndex], cdata.paths[k].wpoints[otherPathIndex]) < relDistance)	{
						if(cdata.classid[k] == "tank")
							blueCount += cdata.vehiclesNo[k] * blueTankStrength;
						if(cdata.classid[k] == "ship")
							blueCount += cdata.vehiclesNo[k] * shipStrength;
					}
				}
			}
			for(int k = 0; k < sdata.guns.getSize(); k++)
				if(sdata.guns[k].side == "blue" && (distance(sdata.guns[k].makePosit(), relPosit) < relDistance) && (!sdata.guns[k].destroyed))
					blueCount += artyStrength;
			for(int k = 0; k < cdata.chiefname.getSize(); k++)	{
				int otherPathIndex = 0;
				if((cdata.side[k] == "red") && (cdata.vehiclesNo[k] > 0) && ((cdata.classid[k] == "tank") || ((cdata.classid[k] == "ship") && (cdata.type[k].find("Tanker") == -1) && (cdata.type[k].find("Barge") == -1))))	{
					if(!cdata.reverse[k])
						for(int l = 0; l <= cdata.paths[k].getLimit(); l++)	{
							if(l == cdata.paths[k].getLimit())
								otherPathIndex = l;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l - 1;
								break;
							}
						}
					if(cdata.reverse[k])
						for(int l = cdata.paths[k].getLimit(); l >= 0; l--)	{
							if(l == 0)
								otherPathIndex = 0;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l + 1;
								break;
							}
						}
					if(distance(cdata.paths[i].wpoints[pathIndex], cdata.paths[k].wpoints[otherPathIndex]) < relDistance)	{
						if(cdata.classid[k] == "tank")
							redCount += cdata.vehiclesNo[k] * redTankStrength;
						if(cdata.classid[k] == "ship")
							redCount += cdata.vehiclesNo[k] * shipStrength;
					}
				}
			}
			for(int k = 0; k < sdata.guns.getSize(); k++)
				if(sdata.guns[k].side == "red" && (distance(sdata.guns[k].makePosit(), relPosit) < relDistance) && (!sdata.guns[k].destroyed))
					redCount += artyStrength;
			if(redCount < 0.2 * blueCount)	{
				*(cdata.reverse.mod(i)) = true;
				*(cdata.justReversed.mod(i)) = true;
			}
		}
		if((cdata.side[i] == "blue") && (cdata.vehiclesNo[i] > 0) && (!cdata.reverse[i]) && ((cdata.classid[i] == "tank") || ((cdata.classid[i] == "ship") && (cdata.type[i].find("Tanker") == -1) && (cdata.type[i].find("Barge") == -1))))	{
			for(int j = 0; j <= cdata.paths[i].getLimit(); j++)	{
				if(j == cdata.paths[i].getLimit())
					pathIndex = cdata.paths[i].getLimit();
				if(!cdata.paths[i].wpoints[j].passed)	{
					pathIndex = j - 1;
					break;
				}
			}
			relPosit.positionX = cdata.paths[i].wpoints[pathIndex].positionX;
			relPosit.positionY = cdata.paths[i].wpoints[pathIndex].positionY;
			for(int k = 0; k < cdata.chiefname.getSize(); k++)	{
				int otherPathIndex = 0;
				if((cdata.side[k] == "red") && (cdata.vehiclesNo[k] > 0) && ((cdata.classid[k] == "tank") || ((cdata.classid[k] == "ship") && (cdata.type[k].find("Tanker") == -1) && (cdata.type[k].find("Barge") == -1))))	{
					if(!cdata.reverse[k])
						for(int l = 0; l <= cdata.paths[k].getLimit(); l++)	{
							if(l == cdata.paths[k].getLimit())
								otherPathIndex = l;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l - 1;
								break;
							}
						}
					if(cdata.reverse[k])
						for(int l = cdata.paths[k].getLimit(); l >= 0; l--)	{
							if(l == 0)
								otherPathIndex = 0;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l + 1;
								break;
							}
						}
					if(distance(cdata.paths[i].wpoints[pathIndex], cdata.paths[k].wpoints[otherPathIndex]) < relDistance)	{
						if(cdata.classid[k] == "tank")
							redCount += cdata.vehiclesNo[k] * redTankStrength;
						if(cdata.classid[k] == "ship")
							redCount += cdata.vehiclesNo[k] * shipStrength;
					}
				}
			}
			for(int k = 0; k < sdata.guns.getSize(); k++)
				if(sdata.guns[k].side == "red" && (distance(sdata.guns[k].makePosit(), relPosit) < relDistance) && (!sdata.guns[k].destroyed))
					redCount += artyStrength;
			for(int k = 0; k < cdata.chiefname.getSize(); k++)	{
				int otherPathIndex = 0;
				if((cdata.side[k] == "blue") && (cdata.vehiclesNo[k] > 0) && ((cdata.classid[k] == "tank") || ((cdata.classid[k] == "ship") && (cdata.type[k].find("Tanker") == -1) && (cdata.type[k].find("Barge") == -1))))	{
					if(!cdata.reverse[k])
						for(int l = 0; l <= cdata.paths[k].getLimit(); l++)	{
							if(l == cdata.paths[k].getLimit())
								otherPathIndex = l;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l - 1;
								break;
							}
						}
					if(cdata.reverse[k])
						for(int l = cdata.paths[k].getLimit(); l >= 0; l--)	{
							if(l == 0)
								otherPathIndex = 0;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l + 1;
								break;
							}
						}
					if(distance(cdata.paths[i].wpoints[pathIndex], cdata.paths[k].wpoints[otherPathIndex]) < relDistance)	{
						if(cdata.classid[k] == "tank")
							blueCount += cdata.vehiclesNo[k] * blueTankStrength;
						if(cdata.classid[k] == "ship")
							blueCount += cdata.vehiclesNo[k] * shipStrength;
					}
				}
			}
			for(int k = 0; k < sdata.guns.getSize(); k++)
				if((sdata.guns[k].side == "blue") && (distance(sdata.guns[k].makePosit(), relPosit) < relDistance) && (!sdata.guns[k].destroyed))
					blueCount += artyStrength;
			if(blueCount < 0.2 * redCount)	{
				*(cdata.reverse.mod(i)) = true;
				*(cdata.justReversed.mod(i)) = true;
			}
		}
		if((cdata.side[i] == "red") && (cdata.classid[i] == "ship") && ((cdata.type[i].find("Tanker") != -1) || (cdata.type[i].find("Barge") != -1)) && (cdata.vehiclesNo[i] > 0))	{					// Getting the barges and tankers to run as soon as they encounter battleships of the oposing side...
			for(int j = 0; j <= cdata.paths[i].getLimit(); j++)	{
				if(j == cdata.paths[i].getLimit())
					pathIndex = cdata.paths[i].getLimit();
				if(!cdata.paths[i].wpoints[j].passed)	{
					pathIndex = j - 1;
					break;
				}
			}
			for(int k = 0; k < cdata.chiefname.getSize(); k++)	{
				int otherPathIndex = 0;
				if((cdata.side[k] == "blue") && (cdata.classid[k] == "ship") && (cdata.type[k].find("Tanker") == -1) && (cdata.type[k].find("Barge") == -1) && (cdata.vehiclesNo[k] > 0))	{
					if(!cdata.reverse[k])
						for(int l = 0; l <= cdata.paths[k].getLimit(); l++)	{
							if(l == cdata.paths[k].getLimit())
								otherPathIndex = l;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l - 1;
								break;
							}
						}
					if(cdata.reverse[k])
						for(int l = cdata.paths[k].getLimit(); l >= 0; l--)	{
							if(l == 0)
								otherPathIndex = 0;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l + 1;
								break;
							}
						}
				}
				if(distance(cdata.paths[i].wpoints[pathIndex], cdata.paths[k].wpoints[otherPathIndex]) < relDistance)	{
					*(cdata.reverse.mod(i)) = true;
					*(cdata.justReversed.mod(i)) = true;
				}
			}
		}
		if((cdata.side[i] == "blue") && (cdata.classid[i] == "ship") && ((cdata.type[i].find("Tanker") != -1) || (cdata.type[i].find("Barge") != -1)) && (cdata.vehiclesNo[i] > 0))	{					// Getting the barges and tankers to run as soon as they encounter battleships of the oposing side...
			for(int j = 0; j <= cdata.paths[i].getLimit(); j++)	{
				if(j == cdata.paths[i].getLimit())
					pathIndex = cdata.paths[i].getLimit();
				if(!cdata.paths[i].wpoints[j].passed)	{
					pathIndex = j - 1;
					break;
				}
			}
			for(int k = 0; k < cdata.chiefname.getSize(); k++)	{
				int otherPathIndex = 0;
				if((cdata.side[k] == "red") && (cdata.classid[k] == "ship") && (cdata.type[k].find("Tanker") == -1) && (cdata.type[k].find("Barge") == -1) && (cdata.vehiclesNo[k] > 0))	{
					if(!cdata.reverse[k])
						for(int l = 0; l <= cdata.paths[k].getLimit(); l++)	{
							if(l == cdata.paths[k].getLimit())
								otherPathIndex = l;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l - 1;
								break;
							}
						}
					if(cdata.reverse[k])
						for(int l = cdata.paths[k].getLimit(); l >= 0; l--)	{
							if(l == 0)
								otherPathIndex = 0;
							if(!cdata.paths[k].wpoints[l].passed)	{
								otherPathIndex = l + 1;
								break;
							}
						}
				}
				if(distance(cdata.paths[i].wpoints[pathIndex], cdata.paths[k].wpoints[otherPathIndex]) < relDistance)	{
					*(cdata.reverse.mod(i)) = true;
					*(cdata.justReversed.mod(i)) = true;
				}
			}
		}
	}
	cdata.save();
}



void reverseCourse(pattern& ppat)	{
	chiefsData cdata;
	cdata.load(ppat.getFileName());
	for(int i = 0; i < cdata.chiefname.getSize(); i++)	{
		if(!cdata.reverse[i] && cdata.paths[i].wpoints[cdata.paths[i].getLimit()].passed && (cdata.classid[i] != "tank") && (cdata.classid[i] != "ship") && (cdata.vehiclesNo[i] > 0))	{
			*(cdata.reverse.mod(i)) = true;
			*(cdata.justReversed.mod(i)) = true;
			continue;
		}
		if(!cdata.reverse[i] && cdata.paths[i].wpoints[cdata.paths[i].getLimit()].passed && ((cdata.classid[i] == "ship") && ((cdata.type[i].find("Tanker") != -1) || (cdata.type[i].find("Barge") != -1))) && (cdata.vehiclesNo[i] > 0))	{
			*(cdata.reverse.mod(i)) = true;
			*(cdata.justReversed.mod(i)) = true;
			continue;
		}
		if(cdata.reverse[i] && cdata.paths[i].wpoints[0].passed && (cdata.classid[i] != "tank") && (cdata.classid[i] != "ship") && (cdata.vehiclesNo[i] > 0))	{
			*(cdata.reverse.mod(i)) = false;
			*(cdata.justReversed.mod(i)) = true;
			continue;
		}
		if(cdata.reverse[i] && cdata.paths[i].wpoints[0].passed && ((cdata.classid[i] == "ship") && ((cdata.type[i].find("Tanker") != -1) || (cdata.type[i].find("Barge") != -1))) && (cdata.vehiclesNo[i] > 0))	{
			*(cdata.reverse.mod(i)) = false;
			*(cdata.justReversed.mod(i)) = true;
			continue;
		}
	}
	cdata.save();
}



void produce(pattern& ppat, timeFlow& ptf)	{
	factoriesData fdata;
	fdata.load(ppat.getFileName());
	if(ptf.getMissionTime() == 8)	{
		for(int i = 0; i < fdata.factories.getSize(); i++)	{
			float increment = (fdata.factories[i].productivity() / (fdata.factories[i].productsNo() + 1));
			for(int j = 0; j <= fdata.factories[i].productsNo(); j++)	{
				if(fdata.factories[i].subassemblyNo() != -1)	{
					int minParts = fdata.factories[i].subassemblyStockpile[0];
					for(int k = 0; k <= fdata.factories[i].subassemblyNo(); k++)	{
						if(minParts >= fdata.factories[i].subassemblyStockpile[k])
							minParts = fdata.factories[i].subassemblyStockpile[k];
					}
					if((minParts >= increment) && (minParts > 0))	{
						fdata.factories.mod(i)->productStockpile[j] = fdata.factories[i].productStockpile[j] + increment;
						for(int l = 0; l <= fdata.factories[i].subassemblyNo(); l++)
							fdata.factories.mod(i)->subassemblyStockpile[l] = fdata.factories[i].subassemblyStockpile[l] - increment;
					}
					if((minParts < increment) && (minParts > 0))	{
						fdata.factories.mod(i)->productStockpile[j] = fdata.factories[i].productStockpile[j] + minParts;
						for(int l = 0; l <= fdata.factories[i].subassemblyNo(); l++)	{
							if((fdata.factories[i].subassemblyStockpile[l] - minParts) > 0)
								fdata.factories.mod(i)->subassemblyStockpile[l] = fdata.factories[i].subassemblyStockpile[l] - minParts;
							if((fdata.factories[i].subassemblyStockpile[l] - minParts) <= 0)
								fdata.factories.mod(i)->subassemblyStockpile[l] = 0;
						}
					}
				}
				if(fdata.factories[i].subassemblyNo() == -1)	{
					int newVal = fdata.factories[i].productStockpile[j] + increment;
					fdata.factories.mod(i)->productStockpile[j] = newVal;
				}
			}
		}
		for(int i = 0; i < fdata.subcontractors.getSize(); i++)	{
			int maxProd = 0;
			for(int ii = 0; ii <= fdata.subcontractors[i].mainfactoryNo(); ii++)
				for(int jj = 0; jj < fdata.factories.getSize(); jj++)
					if(fdata.subcontractors[i].mainfactoryName[ii] == fdata.factories[jj].name)
						maxProd += fdata.factories[jj].maxProductivity;
			maxProd = maxProd * 1.2;
			fdata.subcontractors.mod(i)->maxProductivity = maxProd;
			float increment = (fdata.subcontractors[i].productivity() / (fdata.subcontractors[i].mainfactoryNo() + 1));
			for(int j = 0; j <= fdata.subcontractors[i].mainfactoryNo(); j++)	{
				fdata.subcontractors.mod(i)->stockpile[j] = fdata.subcontractors[i].stockpile[j] + increment;
			}
		}
	}
	fdata.save();
}



void transport(pattern& ppat, timeFlow& ptf)	{
	chiefsData cdata;
	cdata.load(ppat.getFileName());
	factoriesData fdata;
	fdata.load(ppat.getFileName());
	if(ptf.getMissionTime() != 8)
		return;
	for(int i = 0; i < fdata.subcontractors.getSize(); i++)
		if(fdata.subcontractors[i].bicycleNo() > 0)
			for(int j = 0; j <= fdata.subcontractors[i].mainfactoryNo(); j++)
				for(int k = 0; k < fdata.factories.getSize(); k++)
					if((fdata.subcontractors[i].mainfactoryName[j] == fdata.factories[k].name) && (fdata.factories[k].bicycleNo() > 0))
						for(int l = 0; l < cdata.chiefname.getSize(); l++)
							if(cdata.vehiclesNo[l] > 0)	{
								position pathStart;
								pathStart.positionX = cdata.paths[l].wpoints[0].positionX;
								pathStart.positionY = cdata.paths[l].wpoints[0].positionY;
								position pathEnd;
								pathEnd.positionX = cdata.paths[l].wpoints[cdata.paths[l].getLimit()].positionX;
								pathEnd.positionY = cdata.paths[l].wpoints[cdata.paths[l].getLimit()].positionY;
								if((distance(pathStart, fdata.subcontractors[i].makePosit()) < 1000) && (distance(pathEnd, fdata.factories[k].makePosit()) < 1000))
									for(int ii = 0; ii <= fdata.subcontractors[i].mainfactoryNo(); ii++)
										if(fdata.subcontractors[i].product[ii].find(fdata.factories[k].name) != -1)
											for(int jj = 0; jj <= fdata.factories[k].subassemblyNo(); jj++)
												if(fdata.factories[k].subassemblies[jj] == fdata.subcontractors[i].product[ii])	{
													fdata.factories.mod(k)->subassemblyStockpile[jj] = fdata.factories[k].subassemblyStockpile[jj] + fdata.subcontractors[i].stockpile[ii];
													fdata.subcontractors.mod(i)->stockpile[ii] = 0;
												}
								if((distance(pathEnd, fdata.subcontractors[i].makePosit()) < 1000) && (distance(pathStart, fdata.factories[k].makePosit()) < 1000))
									for(int ii = 0; ii <= fdata.subcontractors[i].mainfactoryNo(); ii++)
										if(fdata.subcontractors[i].product[ii].find(fdata.factories[k].name) != -1)
											for(int jj = 0; jj <= fdata.factories[k].subassemblyNo(); jj++)
												if(fdata.factories[k].subassemblies[jj] == fdata.subcontractors[i].product[ii])	{
													fdata.factories.mod(k)->subassemblyStockpile[jj] = fdata.factories[k].subassemblyStockpile[jj] + fdata.subcontractors[i].stockpile[ii];
													fdata.subcontractors.mod(i)->stockpile[ii] = 0;
												}
							}
	fdata.save();
}



void reinforce(pattern& ppat, timeFlow& ptf)	{
	planesData pdata;
	pdata.load(ppat.getFileName());
	chiefsData cdata;
	cdata.load(ppat.getFileName());
	factoriesData fdata;
	fdata.load(ppat.getFileName());
	if(ptf.getMissionTime() != 8 || fdata.factories.getSize() == 0)
		return;
	for(int i = 0; i < pdata.Airgroups.getSize(); i++)
		if(!pdata.destroyed[i])	{
			int currPlanesNo = pdata.availablePlanesNo(i);
			if(currPlanesNo == pdata.planesNo[i])
				continue;
			for(int j = 0; j < fdata.factories.getSize(); j++)
				for(int k = 0; k <= fdata.factories[j].productsNo(); k++)
					if((pdata.type[i] == fdata.factories[j].product[k]) && (pdata.side[i] == fdata.factories[j].side) && (currPlanesNo < pdata.planesNo[i]))	{						// For a factory to deliver reinforcements, it will have to be on the same side as the airgroup, which will prevent reinforcements if the factory is conquered...
						if(fdata.factories[j].productStockpile[k] > 0)	{
							for(int jj = 0; jj <= pdata.flights[i].getflight0Limit(); jj++)
								if(pdata.flights[i].flight0destroyed[jj])	{
									pdata.flights.mod(i)->flight0destroyed[jj] = false;
									fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									currPlanesNo++;
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
								}
						}
						if(fdata.factories[j].productStockpile[k] > 0)	{
							for(int jj = 0; jj <= pdata.flights[i].getflight1Limit(); jj++)
								if(pdata.flights[i].flight1destroyed[jj])	{
									pdata.flights.mod(i)->flight1destroyed[jj] = false;
									fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									currPlanesNo++;
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
								}
						}
						if(fdata.factories[j].productStockpile[k] > 0)	{
							for(int jj = 0; jj <= pdata.flights[i].getflight2Limit(); jj++)
								if(pdata.flights[i].flight2destroyed[jj])	{
									pdata.flights.mod(i)->flight2destroyed[jj] = false;
									fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									currPlanesNo++;
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
								}
						}
						if(fdata.factories[j].productStockpile[k] > 0)	{
							for(int jj = 0; jj <= pdata.flights[i].getflight3Limit(); jj++)
								if(pdata.flights[i].flight3destroyed[jj])	{
									pdata.flights.mod(i)->flight3destroyed[jj] = false;
									fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									currPlanesNo++;
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
								}
						}
					}
		}
	for(int i = 0; i < cdata.chiefname.getSize(); i++)
		if((cdata.vehiclesNo[i] > 0) && (cdata.vehiclesNo[i] < 8) && (cdata.classid[i] != "train") && (cdata.classid[i] != "ship"))
			for(int j = 0; j < fdata.factories.getSize(); j++)
				for(int k = 0; k <= fdata.factories[j].productsNo(); k++)
					if((fdata.factories[j].product[k].find(cdata.type[i]) != -1) && (fdata.factories[j].productStockpile[k] > 0) && (fdata.factories[j].bicycleNo() > 0) && (fdata.factories[j].side == cdata.side[i]))	{
						if(fdata.factories[j].productStockpile[k] >= (8 - cdata.vehiclesNo[i]))	{
							int vehiclesLeft = fdata.factories[j].productStockpile[k] - 8 + cdata.vehiclesNo[i];
							fdata.factories.mod(j)->productStockpile[k] = vehiclesLeft;
							*(cdata.vehiclesNo.mod(i)) = 8;
							break;
						}
						if(fdata.factories[j].productStockpile[k] < (8 - cdata.vehiclesNo[i]))	{
							*(cdata.vehiclesNo.mod(i)) = cdata.vehiclesNo[i] + fdata.factories[j].productStockpile[k];
							fdata.factories.mod(i)->productStockpile[k] = 0;
							break;
						}
						break;
					}
	pdata.save();
	cdata.save();
	fdata.save();
}



void recreateAG(pattern& ppat, timeFlow& ptf)	{
	pattern protoPat("DataBackup/SIDCMission.state");
	planesData pdata;
	pdata.load(ppat.getFileName());
	factoriesData fdata;
	fdata.load(ppat.getFileName());
	if((fdata.factories.getSize() == 0) || (ptf.getMissionTime() != 8))
		return;
	for(int i = 0; i < pdata.Airgroups.getSize(); i++)
		if(pdata.destroyed[i])	{
			for(int j = 0; j < fdata.factories.getSize(); j++)
				if((fdata.factories[j].bicycleNo() > 0) && (pdata.side[i] == fdata.factories[j].side))	{
					for(int k = 0; k <= fdata.factories[j].productsNo(); k++)
						if(pdata.type[i] == fdata.factories[j].product[k])	{
							if(fdata.factories[j].productStockpile[k] > 0)	{
								for(int ii = 0; ii <= pdata.flights[i].getflight0Limit(); ii++)	{
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
									if(pdata.flights[i].flight0destroyed[ii])	{
										pdata.flights.mod(i)->flight0destroyed[ii] = false;
										fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									}
								}
								for(int ii = 0; ii <= pdata.flights[i].getflight1Limit(); ii++)	{
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
									if(pdata.flights[i].flight1destroyed[ii])	{
										pdata.flights.mod(i)->flight1destroyed[ii] = false;
										fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									}
								}
								for(int ii = 0; ii <= pdata.flights[i].getflight2Limit(); ii++)	{
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
									if(pdata.flights[i].flight2destroyed[ii])	{
										pdata.flights.mod(i)->flight2destroyed[ii] = false;
										fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									}
								}
								for(int ii = 0; ii <= pdata.flights[i].getflight3Limit(); ii++)	{
									if(fdata.factories[j].productStockpile[k] == 0)
										break;
									if(pdata.flights[i].flight3destroyed[ii])	{
										pdata.flights.mod(i)->flight3destroyed[ii] = false;
										fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
									}
								}
								if(pdata.planesNo[i] == pdata.availablePlanesNo(i))	{
									pdata.setAirgroupDestroyed(i);
									break;
								}
							}
						}
					if(pdata.planesNo[i] == pdata.availablePlanesNo(i))	{
						pdata.setAirgroupDestroyed(i);
						break;
					}
				}
			if(!pdata.destroyed[i])	{
				for(int iii = 0; iii < protoPat.uniqueid.getSize(); iii++)
					if((protoPat.uniqueid[iii] == pdata.Airgroups[i]) && protoPat.single[iii] && protoPat.start[iii])	{
						int insertionPoint = 0;
						int AGIndex = 0;
						for(int jjj = 0; jjj < ppat.missionMis.getSize(); jjj++)
							if(ppat.missionMis[jjj].find("[AirGroups]") != -1)	{
								AGIndex = jjj;
								break;
							}
						if(protoPat.uniqueid[iii - 1] == "player")
							insertionPoint = AGIndex;
						if(protoPat.uniqueid[iii - 1] != "player")	{
							bool groupsExist = false;
							int index = iii - 1;
							int sectionEnd = 0;
							for(int kkk = AGIndex + 1; kkk < ppat.missionMis.getSize(); kkk++)
								if(ppat.missionMis[kkk].find('[') != -1)	{
									sectionEnd = kkk -1;
									break;
								}
							while(protoPat.uniqueid[index] != "player")	{
								bool doneHere = false;
								for(int jjj = sectionEnd; jjj > AGIndex; jjj--)
									if(ppat.missionMis[jjj].find(protoPat.uniqueid[index]) != -1)	{
										groupsExist = true;
										insertionPoint = jjj;
										doneHere = true;
										break;
									}
								if(doneHere)
									break;
								index--;
							}
							if(!groupsExist)
								insertionPoint = AGIndex;
						}
						int singleInsertionPoint;
						ppat.missionMis.insert(insertionPoint, protoPat.missionMis[protoPat.LineIndex[iii]]);
						singleInsertionPoint = insertionPoint;
						insertionPoint++;
						int ssStart, ssEnd;
						int protosStart, protosEnd;
						for(int ij = AGIndex + 1; ij < ppat.missionMis.getSize(); ij++)
							if(ppat.missionMis[ij].find('[') != -1)	{
								ssEnd = ij - 1;
								break;
							}
						ssStart = AGIndex + 1;
						for(int ik = ssStart; ik <= ssEnd; ik++)	{
							if((ppat.missionMis[ik].find(protoPat.uniqueid[iii]) != -1) && (ik == ssStart))	{
								insertionPoint = ssEnd;
								for(int il = iii; il < protoPat.uniqueid.getSize(); il++)
									if((protoPat.uniqueid[il].find(protoPat.uniqueid[iii]) != -1) && protoPat.start[il] && !protoPat.single[il])	{
										protosStart = protoPat.LineIndex[il];
										protosEnd = protoPat.LineIndex[il + 1];
										break;
									}
								ppat.missionMis.insert(insertionPoint, '[' + protoPat.uniqueid[iii] + ']');
								insertionPoint++;
								for(int iia = protosStart; iia <= protosEnd; iia++)
									ppat.missionMis.insert(insertionPoint++, protoPat.missionMis[iia]);
								ppat.missionMis.insert(insertionPoint, '[' + protoPat.uniqueid[iii] + "_Way" + ']');
								insertionPoint++;
								std::string wayLine = "  TAKEOFF " + std::to_string(pdata.positionX[i]) + ' ' + std::to_string(pdata.positionY[i]) + " 0 0";
								ppat.missionMis.insert(insertionPoint++, wayLine);
								break;
							}
							if((ppat.missionMis[ik].find(protoPat.uniqueid[iii]) != -1) && (ik != ssStart))	{
								for(int iie = ssEnd + 1; iie < ppat.missionMis.getSize(); iie++)
									if((ppat.missionMis[iie].find(ppat.missionMis[singleInsertionPoint].substr(2)) != -1) && (ppat.missionMis[iie].find("Way") != -1))	{
										for(int iif = iie + 1; iif < ppat.missionMis.getSize(); iif++)	{
											if(ppat.missionMis[iif].find('[') != -1)	{
												insertionPoint = iif - 1;
												break;
											}
										}
										break;
									}
								for(int il = iii; il < protoPat.uniqueid.getSize(); il++)
									if((protoPat.uniqueid[il].find(protoPat.uniqueid[iii]) != -1) && protoPat.start[il] && !protoPat.single[il])	{
										protosStart = protoPat.LineIndex[il];
										protosEnd = protoPat.LineIndex[il + 1];
										break;
									}
								ppat.missionMis.insert(insertionPoint, '[' + protoPat.uniqueid[iii] + ']');
								insertionPoint++;
								for(int iia = protosStart; iia <= protosEnd; iia++)
									ppat.missionMis.insert(insertionPoint++, protoPat.missionMis[iia]);
								ppat.missionMis.insert(insertionPoint, '[' + protoPat.uniqueid[iii] + "_Way" + ']');
								insertionPoint++;
								std::string wayLine = "  TAKEOFF " + std::to_string(pdata.positionX[i]) + ' ' + std::to_string(pdata.positionY[i]) + " 0 0";
								ppat.missionMis.insert(insertionPoint++, wayLine);
								break;
							}
						}
					}
			}
		}
	pdata.save();
	fdata.save();
	std::ofstream o("SIDCMission.state");
	for(int zz = 0; zz < ppat.missionMis.getSize(); zz++)
		o << ppat.missionMis[zz] + '\n';
}



void recreateC(pattern& ppat, timeFlow& ptf)	{
	pattern protoPat("DataBackup/SIDCMission.state");
	chiefsData cdata;
	cdata.load(ppat.getFileName());
	factoriesData fdata;
	fdata.load(ppat.getFileName());
	if((fdata.factories.getSize() == 0) || (ptf.getMissionTime() != 8))
		return;
	for(int i = 0; i < cdata.chiefname.getSize(); i++)
		if(cdata.vehiclesNo[i] == 0)	{
			for(int j = 0; j < fdata.factories.getSize(); j++)
				if((fdata.factories[j].bicycleNo() > 0) && (fdata.factories[j].side == cdata.side[i]))	{
					for(int k = 0; k <= fdata.factories[j].productsNo(); k++)
						if((fdata.factories[j].product[k].find(cdata.type[i]) != -1) && (fdata.factories[j].productStockpile[k] > 0))
							if((cdata.classid[i] != "ship") && (cdata.classid[i] != "train"))	{
								if(fdata.factories[j].productStockpile[k] >= 8)	{
									*(cdata.vehiclesNo.mod(i)) = 8;
									fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 8;
									break;
								}
								if(fdata.factories[j].productStockpile[k] < 8)	{
									*(cdata.vehiclesNo.mod(i)) = fdata.factories[j].productStockpile[k];
									fdata.factories.mod(j)->productStockpile[k] = 0;
									break;
								}
							}
				}
			if(cdata.vehiclesNo[i] > 0)	{
				for(int iii = 0; iii < protoPat.uniqueid.getSize(); iii++)
					if((protoPat.uniqueid[iii] == cdata.chiefname[i]) && protoPat.single[iii] && protoPat.start[iii])	{
						int insertionPoint = 0;
						int chiefIndex = 0;
						int singleIndex = 0;
						for(int jjj = 0; jjj < ppat.missionMis.getSize(); jjj++)
							if(ppat.missionMis[jjj].find("[Chiefs]") != -1)	{
								chiefIndex = jjj;
								break;
							}
						if(protoPat.uniqueid[iii - 1].find("Chief") == -1)
							insertionPoint  = chiefIndex;
						if(protoPat.uniqueid[iii - 1].find("Chief") != -1)	{
							bool chiefsExist = false;
							int index = iii -1;
							int sectionEnd = 0;
							for(int kkk = chiefIndex + 1; kkk < ppat.missionMis.getSize(); kkk++)
								if(ppat.missionMis[kkk].find('[') != -1)	{
									sectionEnd = kkk -1;
									break;
								}
							while(protoPat.uniqueid[index].find("Chief") != -1)	{
								bool doneHere = false;
								for(int jjj = sectionEnd; jjj > chiefIndex; jjj--)
									if(ppat.missionMis[jjj].find(protoPat.uniqueid[index]) != -1)	{
										doneHere = true;
										chiefsExist = true;
										insertionPoint  = jjj;
										singleIndex = index;
										break;
									}
								if(doneHere)
									break;
								index--;
							}
							if(!chiefsExist)
								insertionPoint = chiefIndex;
						}
						int singleInsertionPoint = insertionPoint;
						ppat.missionMis.insert(insertionPoint, protoPat.missionMis[protoPat.LineIndex[iii]]);
						insertionPoint++;
						int ssStart, ssEnd, protosStart, protosEnd;
						for(int ij = chiefIndex + 1; ij < ppat.missionMis.getSize(); ij++)
							if(ppat.missionMis[ij].find('[') != -1)	{
								ssEnd = ij - 1;
								break;
							}
						ssStart = chiefIndex + 1;
						for(int ik = ssStart; ik <= ssEnd; ik++)	{
							if((ppat.missionMis[ik].find(protoPat.uniqueid[iii]) != -1) && (ik == ssStart))	{
								insertionPoint = ssEnd;
								for(int  il = iii; il < protoPat.uniqueid.getSize(); il++)
									if((protoPat.uniqueid[il].find(protoPat.uniqueid[iii])) && protoPat.start[il] && !protoPat.single[il])	{
										protosStart = protoPat.LineIndex[il];
										protosEnd = protoPat.LineIndex[il + 1];
										break;
									}
								ppat.missionMis.insert(insertionPoint, '[' + protoPat.uniqueid[iii] + "_Road" + ']');
								insertionPoint++;
								for(int iia = protosStart; iia <= protosEnd; iia++)
									ppat.missionMis.insert(insertionPoint++, protoPat.missionMis[iia]);
								break;
							}
							if((ppat.missionMis[ik].find(protoPat.uniqueid[iii]) != -1) && (ik != ssStart))	{
								for(int iie = ssEnd + 1; iie < ppat.missionMis.getSize(); iie++)
									if((ppat.missionMis[iie].find(protoPat.uniqueid[singleIndex]) != -1) && (ppat.missionMis[iie].find("Road") != -1))	{
										for(int iif = iie + 1; iie < ppat.missionMis.getSize(); iif++)
											if(ppat.missionMis[iif].find('[') != -1)	{
												insertionPoint = iif - 1;
												break;
											}
										break;
									}
								for(int il = iii; il < protoPat.uniqueid.getSize(); il++)
									if((protoPat.uniqueid[il].find(protoPat.uniqueid[iii]) != -1) && protoPat.start[il] && !protoPat.single[il])	{
										protosStart = protoPat.LineIndex[il];
										protosEnd = protoPat.LineIndex[il + 1];
										break;
									}
								ppat.missionMis.insert(insertionPoint, '[' + protoPat.uniqueid[iii] + "_Road" + ']');
								insertionPoint++;
								for(int iia = protosStart; iia <= protosEnd; iia++)
									ppat.missionMis.insert(insertionPoint++, protoPat.missionMis[iia]);
								break;
							}
						}
					}
			}
		}
	cdata.save();
	fdata.save();
	std::ofstream o("SIDCMission.state");
	for(int zz = 0; zz < ppat.missionMis.getSize(); zz++)
		o << ppat.missionMis[zz] + '\n';
}



void recreateS(pattern& ppat, timeFlow& ptf)	{
	pattern protoPat("DataBackup/SIDCMission.state");
	staticData sdata;
	sdata.load(ppat.getFileName());
	factoriesData fdata;
	fdata.load(ppat.getFileName());
	if((fdata.factories.getSize() == 0) || (ptf.getMissionTime() != 8))
		return;
	for(int i = 0; i < sdata.guns.getSize(); i++)
		if(sdata.guns[i].destroyed)	{
			for(int j = 0; j < fdata.factories.getSize(); j++)
				if((fdata.factories[j].bicycleNo() > 0) && (fdata.factories[j].side == sdata.guns[i].side))	{
					for(int k = 0; k <= fdata.factories[j].productsNo(); k++)
						if((fdata.factories[j].product[k].find(sdata.guns[i].type) != -1) && (fdata.factories[j].productStockpile[k] > 0))	{
							sdata.guns.mod(i)->destroyed = false;
							fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
							break;
						}
				}
			if(!sdata.guns[i].destroyed)	{
				for(int iii = 0; iii < protoPat.uniqueid.getSize(); iii++)
					if((protoPat.uniqueid[iii] == sdata.guns[i].staticid) && protoPat.single[iii] && protoPat.start[iii])	{
						int insertionPoint = 0;
						int stationaryIndex = 0;
						for(int iff = 0; iff < ppat.missionMis.getSize(); iff++)
							if(ppat.missionMis[iff].find("[Stationary]") != -1)	{
								stationaryIndex = iff;
								break;
							}
						if(protoPat.uniqueid[iii - 1].find("Static") == -1)
							insertionPoint = stationaryIndex;
						if(protoPat.uniqueid[iii - 1].find("Static") != -1)	{
							bool staticsExist = false;
							int index = iii - 1;
							int sectionEnd = 0;
							for(int kkk = stationaryIndex + 1; kkk < ppat.missionMis.getSize(); kkk++)
								if(ppat.missionMis[kkk].find('[') != -1)	{
									sectionEnd = kkk - 1;
									break;
								}
							while(protoPat.uniqueid[index].find("Static") != -1)	{
								bool doneHere = false;
								for(int jjj = sectionEnd; jjj > stationaryIndex; jjj--)
									if(ppat.missionMis[jjj].find(protoPat.uniqueid[index] + ' ') != -1)	{
										staticsExist = true;
										doneHere = true;
										insertionPoint = jjj;
										break;
									}
								if(doneHere)
									break;
								index--;
							}
							if(!staticsExist)
								insertionPoint = stationaryIndex;
						}
						ppat.missionMis.insert(insertionPoint, protoPat.missionMis[protoPat.LineIndex[iii]]);
					}
			}
		}
	for(int i = 0; i < sdata.radars.getSize(); i++)
		if(sdata.radars[i].destroyed)	{
			for(int j = 0; j < fdata.factories.getSize(); j++)
				if((fdata.factories[j].bicycleNo() > 0) && (fdata.factories[j].side == sdata.radars[i].side))	{
					for(int k = 0; k <= fdata.factories[j].productsNo(); k++)
						if((sdata.radars[i].type.find(fdata.factories[j].product[k]) != -1) && (fdata.factories[j].productStockpile[k] > 0))	{
							sdata.radars.mod(i)->destroyed = false;
							fdata.factories.mod(j)->productStockpile[k] = fdata.factories[j].productStockpile[k] - 1;
							break;
						}
				}
			if(!sdata.radars[i].destroyed)	{
				for(int iii = 0; iii < protoPat.uniqueid.getSize(); iii++)
					if((protoPat.uniqueid[iii] == sdata.radars[i].staticid) && protoPat.single[iii] && protoPat.start[iii])	{
						int insertionPoint = 0;
						int stationaryIndex = 0;
						for(int iff = 0; iff < ppat.missionMis.getSize(); iff++)
							if(ppat.missionMis[iff].find("[Stationary]") != -1)	{
								stationaryIndex = iff;
								break;
							}
						if(protoPat.uniqueid[iii - 1].find("Static") == -1)
							insertionPoint = stationaryIndex;
						if(protoPat.uniqueid[iii - 1].find("Static") != -1)	{
							bool staticsExist = false;
							int index = iii - 1;
							int sectionEnd = 0;
							for(int kkk = stationaryIndex + 1; kkk < ppat.missionMis.getSize(); kkk++)
								if(ppat.missionMis[kkk].find('[') != -1)	{
									sectionEnd = kkk - 1;
									break;
								}
							while(protoPat.uniqueid[index].find("Static") != -1)	{
								bool doneHere = false;
								for(int jjj = sectionEnd; jjj > stationaryIndex; jjj--)
									if(ppat.missionMis[jjj].find(protoPat.uniqueid[index] + ' ') != -1)	{
										staticsExist = true;
										doneHere = true;
										insertionPoint = jjj;
										break;
									}
								if(doneHere)
									break;
								index--;
							}
							if(!staticsExist)
								insertionPoint = stationaryIndex;
						}
						ppat.missionMis.insert(insertionPoint, protoPat.missionMis[protoPat.LineIndex[iii]]);
					}
			}
		}
	fdata.save();
	sdata.save();
	std::ofstream o("SIDCMission.state");
	for(int zz = 0; zz < ppat.missionMis.getSize(); zz++)
		o << ppat.missionMis[zz] + '\n';
}



void rebuild(pattern& ppat, timeFlow& ptf)	{
	pattern protoPat("DataBackup/SIDCMission.state");
	facilitiesData facdata;
	facdata.load(ppat.getFileName());
	for(int i = 0; i < facdata.airfields.getSize(); i++)
		for(int j = 0; j < 4; j++)
			if(facdata.airfields[i].ToTDestruction[j] != 0)	{
				bool tractorRebuilt = false;
				time_t timeOfDestruction = facdata.airfields[i].ToTDestruction[j];
				time_t currTime = ptf.getLongTime();
				float timeElapsed = difftime(currTime, timeOfDestruction) / (24 * 3600);
				if(facdata.airfields[i].tractorDestroyed[j] && timeElapsed > airfieldRebuildPeriod)	{
					facdata.airfields.mod(i)->tractorDestroyed[j] = false;
					facdata.airfields.mod(i)->ToTDestruction[j] = 0;
					tractorRebuilt = true;
				}
				if(tractorRebuilt)	{
					for(int iii = 0; iii < protoPat.uniqueid.getSize(); iii++)
						if((protoPat.uniqueid[iii] == facdata.airfields[i].staticid[j]) && protoPat.single[iii] && protoPat.start[iii])	{
							int insertionPoint = 0;
							int stationaryIndex = 0;
							for(int iff = 0; iff < ppat.missionMis.getSize(); iff++)
								if(ppat.missionMis[iff].find("[Stationary]") != -1)	{
									stationaryIndex = iff;
									break;
								}
							if(protoPat.uniqueid[iii - 1].find("Static") == -1)
								insertionPoint = stationaryIndex;
							if(protoPat.uniqueid[iii - 1].find("Static") != -1)	{
								bool staticsExist = false;
								int index = iii - 1;
								int sectionEnd = 0;
								for(int kkk = stationaryIndex + 1; kkk < ppat.missionMis.getSize(); kkk++)
									if(ppat.missionMis[kkk].find('[') != -1)	{
										sectionEnd = kkk - 1;
										break;
									}
								while(protoPat.uniqueid[index].find("Static") != -1)	{
									bool doneHere = false;
									for(int jjj = sectionEnd; jjj > stationaryIndex; jjj--)
										if(ppat.missionMis[jjj].find(protoPat.uniqueid[index] + ' ') != -1)	{
											staticsExist = true;
											doneHere = true;
											insertionPoint = jjj;
											break;
										}
									if(doneHere)
										break;
									index--;
								}
								if(!staticsExist)
									insertionPoint = stationaryIndex;
							}
							ppat.missionMis.insert(insertionPoint, protoPat.missionMis[protoPat.LineIndex[iii]]);
						}
				}
			}
	for(int i = 0; i < facdata.ports.getSize(); i++)
		for(int j = 0; j < 4; j++)
			if(facdata.ports[i].ToTDestruction[j] != 0)	{
				bool tractorRebuilt = false;
				time_t timeOfDestruction = facdata.ports[i].ToTDestruction[j];
				time_t currTime = ptf.getLongTime();
				float timeElapsed = difftime(currTime, timeOfDestruction) / (24 * 3600);
				if(facdata.ports[i].tractorDestroyed[j] && timeElapsed > portRebuildPeriod)	{
					facdata.ports.mod(i)->tractorDestroyed[j] = false;
					facdata.ports.mod(i)->ToTDestruction[j] = 0;
					tractorRebuilt = true;
				}
				if(tractorRebuilt)	{
					for(int iii = 0; iii < protoPat.uniqueid.getSize(); iii++)
						if((protoPat.uniqueid[iii] == facdata.ports[i].staticid[j]) && protoPat.single[iii] && protoPat.start[iii])	{
							int insertionPoint = 0;
							int stationaryIndex = 0;
							for(int iff = 0; iff < ppat.missionMis.getSize(); iff++)
								if(ppat.missionMis[iff].find("[Stationary]") != -1)	{
									stationaryIndex = iff;
									break;
								}
							if(protoPat.uniqueid[iii - 1].find("Static") == -1)
								insertionPoint = stationaryIndex;
							if(protoPat.uniqueid[iii - 1].find("Static") != -1)	{
								bool staticsExist = false;
								int index = iii - 1;
								int sectionEnd = 0;
								for(int kkk = stationaryIndex + 1; kkk < ppat.missionMis.getSize(); kkk++)
									if(ppat.missionMis[kkk].find('[') != -1)	{
										sectionEnd = kkk - 1;
										break;
									}
								while(protoPat.uniqueid[index].find("Static") != -1)	{
									bool doneHere = false;
									for(int jjj = sectionEnd; jjj > stationaryIndex; jjj--)
										if(ppat.missionMis[jjj].find(protoPat.uniqueid[index] + ' ') != -1)	{
											staticsExist = true;
											doneHere = true;
											insertionPoint = jjj;
											break;
										}
									if(doneHere)
										break;
									index--;
								}
								if(!staticsExist)
									insertionPoint = stationaryIndex;
							}
							ppat.missionMis.insert(insertionPoint, protoPat.missionMis[protoPat.LineIndex[iii]]);
						}
				}
			}
	facdata.save();
	std::ofstream o("SIDCMission.state");
	for(int zz = 0; zz < ppat.missionMis.getSize(); zz++)
		o << ppat.missionMis[zz] + '\n';
}



void denyFlight(mainTables& pmt, pattern& ppat)	{
	planesData pdata;
	pdata.load(ppat.getFileName());
	facilitiesData facdata;
	facdata.load(ppat.getFileName());
	for(int i = 0; i < facdata.airfields.getSize(); i++)	{
		if(facdata.airfields[i].destroyed())
			for(int j = 0; j < pdata.Airgroups.getSize(); j++)
				if((distance(pdata.makePosit(j), facdata.airfields[i].makePosit()) < 1000) && !pdata.destroyed[j])	{
					if(facdata.airfields[i].side == "red")
						for(int k = 0; k < pmt.fightersRed.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.fightersRed[k].groupname)
								pmt.fightersRed.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "blue")
						for(int k = 0; k < pmt.fightersBlue.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.fightersBlue[k].groupname)
								pmt.fightersBlue.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "red")
						for(int k = 0; k < pmt.bombersRed.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.bombersRed[k].groupname)
								pmt.bombersRed.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "blue")
						for(int k = 0; k < pmt.bombersBlue.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.bombersBlue[k].groupname)
								pmt.bombersBlue.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "red")
						for(int k = 0; k < pmt.jabosRed.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.jabosRed[k].groupname)
								pmt.jabosRed.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "blue")
						for(int k = 0; k < pmt.jabosBlue.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.jabosBlue[k].groupname)
								pmt.jabosBlue.mod(k)->available = false;
						}
				}
		if(!facdata.airfields[i].destroyed())
			for(int j = 0; j < pdata.Airgroups.getSize(); j++)
				if((distance(pdata.makePosit(j), facdata.airfields[i].makePosit()) < 1000) && !pdata.destroyed[j])	{
					if(facdata.airfields[i].side == "blue")
						for(int k = 0; k < pmt.fightersRed.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.fightersRed[k].groupname)
								pmt.fightersRed.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "red")
						for(int k = 0; k < pmt.fightersBlue.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.fightersBlue[k].groupname)
								pmt.fightersBlue.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "blue")
						for(int k = 0; k < pmt.bombersRed.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.bombersRed[k].groupname)
								pmt.bombersRed.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "red")
						for(int k = 0; k < pmt.bombersBlue.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.bombersBlue[k].groupname)
								pmt.bombersBlue.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "blue")
						for(int k = 0; k < pmt.jabosRed.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.jabosRed[k].groupname)
								pmt.jabosRed.mod(k)->available = false;
						}
					if(facdata.airfields[i].side == "red")
						for(int k = 0; k < pmt.jabosBlue.getSize(); k++)	{
							if(pdata.Airgroups[j] == pmt.jabosBlue[k].groupname)
								pmt.jabosBlue.mod(k)->available = false;
						}
				}
	}
}



void markFront(mainTables& pmt, pattern& ppat, modeSetter& pms)	{
	battleArea ba(ppat.getFileName());
	seArray<position, 10> redMarkers;
	seArray<position, 10> blueMarkers;
	double gridSize = 5000;
	for(double x = ba.getLV(); x <= ba.getLV() + ba.getW(); x += gridSize)
		for(double y = ba.getLH(); y <= ba.getLH() + ba.getH(); y += gridSize)	{
			double X = x + gridSize / 2;
			double Y = y + gridSize / 2;
			position sOwnPosit, ownPosit, enemyPosit, sEnemyPosit, currEnemyPosit;
			bool foundOne = false;
			double dist;
			if(pmt.tanksRed.getSize() > 0)	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{					// Getting a unit in the upper right quadrant
							sOwnPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
							sOwnPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X <= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) >= pmt.gunsRed[i].positionX) && (Y <= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) >= pmt.gunsRed[i].positionY))	{
						sOwnPosit.positionX = pmt.gunsRed[i].positionX;
						sOwnPosit.positionY = pmt.gunsRed[i].positionY;
						break;
					}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X <= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) >= pmt.gunsRed[i].positionX) && (Y <= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) >= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX < pmt.gunsRed[i].positionX) && (ownPosit.positionY > pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionY - Y) / (pmt.gunsBlue[i].positionX - X) < 1) && ((pmt.gunsBlue[i].positionX - X) > 0) && ((pmt.gunsBlue[i].positionY - Y) > 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionY - Y) / (pmt.gunsBlue[i].positionX - X) < 1) && ((pmt.gunsBlue[i].positionX - X) > 0) && ((pmt.gunsBlue[i].positionY - Y) > 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			foundOne = false;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X <= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) >= pmt.gunsRed[i].positionX) && (Y <= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) >= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX > pmt.gunsRed[i].positionX) && (ownPosit.positionY < pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionX - X) / (pmt.gunsBlue[i].positionY - Y) < 1) && ((pmt.gunsBlue[i].positionX - X) >= 0) && ((pmt.gunsBlue[i].positionY - Y) > 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionX - X) / (pmt.gunsBlue[i].positionY - Y) < 1) && ((pmt.gunsBlue[i].positionX - X) >= 0) && ((pmt.gunsBlue[i].positionY - Y) > 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			foundOne = false;
			sOwnPosit.positionX = 0;
			sOwnPosit.positionY = 0;
			if(pmt.tanksRed.getSize() > 0)	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{					// Getting a unit in the upper right quadrant
							sOwnPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
							sOwnPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X >= pmt.gunsRed[i].positionX) && ((X - gridSize / 2) <= pmt.gunsRed[i].positionX) && (Y <= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) >= pmt.gunsRed[i].positionY))	{					// Getting a vehicle in the upper right quadrant
						sOwnPosit.positionX = pmt.gunsRed[i].positionX;
						sOwnPosit.positionY = pmt.gunsRed[i].positionY;
						break;
					}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X >= pmt.gunsRed[i].positionX) && ((X - gridSize / 2) <= pmt.gunsRed[i].positionX) && (Y <= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) >= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX > pmt.gunsRed[i].positionX) && (ownPosit.positionY > pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) / (-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X)) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) >= 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) / (-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X)) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) >= 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionY - Y) / (-1 * (pmt.gunsBlue[i].positionX - X)) < 1) && ((pmt.gunsBlue[i].positionX - X) < 0) && ((pmt.gunsBlue[i].positionY - Y) >= 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) / (-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X)) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) >= 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) / (-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X)) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) >= 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionY - Y) / (-1 * (pmt.gunsBlue[i].positionX - X)) < 1) && ((pmt.gunsBlue[i].positionX - X) < 0) && ((pmt.gunsBlue[i].positionY - Y) >= 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			foundOne = false;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X >= pmt.gunsRed[i].positionX) && ((X - gridSize / 2) <= pmt.gunsRed[i].positionX) && (Y <= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) >= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX < pmt.gunsRed[i].positionX) && (ownPosit.positionY < pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X)) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X)) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((-1 * (pmt.gunsBlue[i].positionX - X)) / (pmt.gunsBlue[i].positionY - Y) < 1) && ((pmt.gunsBlue[i].positionX - X) <= 0) && ((pmt.gunsBlue[i].positionY - Y) > 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X)) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X)) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) > 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((-1 * (pmt.gunsBlue[i].positionX - X)) / (pmt.gunsBlue[i].positionY - Y) < 1) && ((pmt.gunsBlue[i].positionX - X) <= 0) && ((pmt.gunsBlue[i].positionY - Y) > 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			foundOne = false;
			sOwnPosit.positionX = 0;
			sOwnPosit.positionY = 0;
			if(pmt.tanksRed.getSize() > 0)	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{					// Getting a unit in the upper right quadrant
							sOwnPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
							sOwnPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X >= pmt.gunsRed[i].positionX) && ((X - gridSize / 2) <= pmt.gunsRed[i].positionX) && (Y >= pmt.gunsRed[i].positionY) && ((Y - gridSize / 2) <= pmt.gunsRed[i].positionY))	{
						sOwnPosit.positionX = pmt.gunsRed[i].positionX;
						sOwnPosit.positionY = pmt.gunsRed[i].positionY;
						break;
					}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X >= pmt.gunsRed[i].positionX) && ((X - gridSize / 2) <= pmt.gunsRed[i].positionX) && (Y >= pmt.gunsRed[i].positionY) && ((Y - gridSize / 2) <= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX > pmt.gunsRed[i].positionX) && (ownPosit.positionY < pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionY - Y) / (pmt.gunsBlue[i].positionX - X) < 1) && ((pmt.gunsBlue[i].positionX - X) < 0) && ((pmt.gunsBlue[i].positionY - Y) <= 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionY - Y) / (pmt.gunsBlue[i].positionX - X) < 1) && ((pmt.gunsBlue[i].positionX - X) < 0) && ((pmt.gunsBlue[i].positionY - Y) <= 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			foundOne = false;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X >= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) <= pmt.gunsRed[i].positionX) && (Y >= pmt.gunsRed[i].positionY) && ((Y + gridSize / 2) <= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX < pmt.gunsRed[i].positionX) && (ownPosit.positionY > pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionX - X) / (pmt.gunsBlue[i].positionY - Y) < 1) && ((pmt.gunsBlue[i].positionX - X) <= 0) && ((pmt.gunsBlue[i].positionY - Y) < 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) <= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionX - X) / (pmt.gunsBlue[i].positionY - Y) < 1) && ((pmt.gunsBlue[i].positionX - X) <= 0) && ((pmt.gunsBlue[i].positionY - Y) < 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			foundOne = false;
			sOwnPosit.positionX = 0;
			sOwnPosit.positionY = 0;
			if(pmt.tanksRed.getSize() > 0)	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{					// Getting a unit in the upper right quadrant
							sOwnPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
							sOwnPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
							sOwnPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							break;
						}
			}
			if((sOwnPosit.positionX == 0) && (sOwnPosit.positionY == 0) && (sOwnPosit.altitude == 0))	{
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X <= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) >= pmt.gunsRed[i].positionX) && (Y >= pmt.gunsRed[i].positionY) && ((Y - gridSize / 2) <= pmt.gunsRed[i].positionY))	{
						sOwnPosit.positionX = pmt.gunsRed[i].positionX;
						sOwnPosit.positionY = pmt.gunsRed[i].positionY;
						break;
					}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX < pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY < pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X <= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) >= pmt.gunsRed[i].positionX) && (Y >= pmt.gunsRed[i].positionY) && ((Y - gridSize / 2) <= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX < pmt.gunsRed[i].positionX) && (ownPosit.positionY < pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y)) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y)) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((-1 * (pmt.gunsBlue[i].positionY - Y)) / (pmt.gunsBlue[i].positionX - X) < 1) && ((pmt.gunsBlue[i].positionX - X) > 0) && ((pmt.gunsBlue[i].positionY - Y) <= 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y)) / (pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y)) / (pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) > 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) <= 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((-1 * (pmt.gunsBlue[i].positionY - Y)) / (pmt.gunsBlue[i].positionX - X) < 1) && ((pmt.gunsBlue[i].positionX - X) > 0) && ((pmt.gunsBlue[i].positionY - Y) <= 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
			if((sOwnPosit.positionX != 0) && (sOwnPosit.positionY != 0))
				ownPosit = sOwnPosit;
			foundOne = false;
			if((ownPosit.positionX != 0) && (ownPosit.positionY != 0))	{
				for(int i = 0; i < pmt.tanksRed.getSize(); i++)
					if(pmt.tanksRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.tanksRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.tanksRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.tanksRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.tanksRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.tanksRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.tanksRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.shipsRed.getSize(); i++)
					if(pmt.shipsRed[i].chiefPath.wpoints[0].isItSet())
						if((X <= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && ((X + gridSize / 2) >= pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (Y >= pmt.shipsRed[i].chiefPath.wpoints[0].positionY) && ((Y - gridSize / 2) <= pmt.shipsRed[i].chiefPath.wpoints[0].positionY))
							if((ownPosit.positionX > pmt.shipsRed[i].chiefPath.wpoints[0].positionX) && (ownPosit.positionY > pmt.shipsRed[i].chiefPath.wpoints[0].positionY))	{
								ownPosit.positionX = pmt.shipsRed[i].chiefPath.wpoints[0].positionX;
								ownPosit.positionY = pmt.shipsRed[i].chiefPath.wpoints[0].positionY;
							}
				for(int i = 0; i < pmt.gunsRed.getSize(); i++)
					if((X <= pmt.gunsRed[i].positionX) && ((X + gridSize / 2) >= pmt.gunsRed[i].positionX) && (Y >= pmt.gunsRed[i].positionY) && ((Y - gridSize / 2) <= pmt.gunsRed[i].positionY))
						if((ownPosit.positionX > pmt.gunsRed[i].positionX) && (ownPosit.positionY > pmt.gunsRed[i].positionY))	{
							ownPosit.positionX = pmt.gunsRed[i].positionX;
							ownPosit.positionY = pmt.gunsRed[i].positionY;
						}
				for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
					if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
						if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) / (-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y)) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
							sEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
							sEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(!foundOne)
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) / (-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y)) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
								sEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								sEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								enemyPosit = sEnemyPosit;
								foundOne = true;
								dist = distance(ownPosit, sEnemyPosit);
								break;
							}
				if(!foundOne)
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionX - X) / (-1 * (pmt.gunsBlue[i].positionY - Y) < 1)) && ((pmt.gunsBlue[i].positionX - X) >= 0) && ((pmt.gunsBlue[i].positionY - Y) < 0))	{
							sEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							sEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							enemyPosit = sEnemyPosit;
							foundOne = true;
							dist = distance(ownPosit, sEnemyPosit);
							break;
						}
				if(foundOne)	{
					for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
						if(pmt.tanksBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) / (-1 * (pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y)) < 1) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.tanksBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
								currEnemyPosit.positionX = pmt.tanksBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.tanksBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
						if(pmt.shipsBlue[i].chiefPath.wpoints[0].isItSet())
							if(((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) / (-1 * (pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y)) < 1) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionX - X) >= 0) && ((pmt.shipsBlue[i].chiefPath.wpoints[0].positionY - Y) < 0))	{
								currEnemyPosit.positionX = pmt.shipsBlue[i].chiefPath.wpoints[0].positionX;
								currEnemyPosit.positionY = pmt.shipsBlue[i].chiefPath.wpoints[0].positionY;
								if(dist > distance(ownPosit, currEnemyPosit))	{
									dist = distance(ownPosit, currEnemyPosit);
									enemyPosit = currEnemyPosit;
								}
							}
					for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
						if(((pmt.gunsBlue[i].positionX - X) / (-1 * (pmt.gunsBlue[i].positionY - Y) < 1)) && ((pmt.gunsBlue[i].positionX - X) >= 0) && ((pmt.gunsBlue[i].positionY - Y) < 0))	{
							currEnemyPosit.positionX = pmt.gunsBlue[i].positionX;
							currEnemyPosit.positionY = pmt.gunsBlue[i].positionY;
							if(dist > distance(ownPosit, currEnemyPosit))	{
								dist = distance(ownPosit, currEnemyPosit);
								enemyPosit = currEnemyPosit;
							}
						}
					double distToAdd = distance(ownPosit, enemyPosit);
					double fromFP = 0.1 * distToAdd;
					position toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					redMarkers.add(new position(toAdd));
					fromFP = 0.9 * distToAdd;
					toAdd = splitLine(ownPosit, enemyPosit, fromFP);
					blueMarkers.add(new position(toAdd));
				}
			}
		}
	{
		staticData sdata;
		sdata.load(ppat.getFileName());
		double distToCFM, distToCEM;
		for(int i = 0; i < sdata.radars.getSize(); i++)	{
			if(sdata.radars[i].side == "red")	{
				if(redMarkers.getSize() > 0)
					distToCFM = distance(redMarkers[0], sdata.radars[i].makePosit());
				if(blueMarkers.getSize() > 0)
					distToCEM = distance(blueMarkers[0], sdata.radars[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], sdata.radars[i].makePosit()) < distToCFM)
							distToCFM = distance(redMarkers[k], sdata.radars[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], sdata.radars[i].makePosit()) < distToCEM)
							distToCEM = distance(blueMarkers[k], sdata.radars[i].makePosit());
				if(distToCEM < distToCFM)
					sdata.radars.mod(i)->side = "blue";
			}
			if(sdata.radars[i].side == "blue")	{
				if(blueMarkers.getSize() > 0)
					distToCFM = distance(blueMarkers[0], sdata.radars[i].makePosit());
				if(redMarkers.getSize() > 0)
					distToCEM = distance(redMarkers[0], sdata.radars[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], sdata.radars[i].makePosit()) < distToCFM)
							distToCFM = distance(blueMarkers[k], sdata.radars[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], sdata.radars[i].makePosit()) < distToCEM)
							distToCEM = distance(redMarkers[k], sdata.radars[i].makePosit());
				if(distToCEM < distToCFM)
					sdata.radars.mod(i)->side = "red";
			}
		}
		sdata.save();
	}
	{
		factoriesData fdata;
		fdata.load(ppat.getFileName());
		double distToCFM, distToCEM;
		for(int i = 0; i < fdata.factories.getSize(); i++)	{
			if(fdata.factories[i].side == "red")	{
				if(redMarkers.getSize() > 0)
					distToCFM = distance(redMarkers[0], fdata.factories[i].makePosit());
				if(blueMarkers.getSize() > 0)
					distToCEM = distance(blueMarkers[0], fdata.factories[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], fdata.factories[i].makePosit()) < distToCFM)
							distToCFM = distance(redMarkers[k], fdata.factories[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], fdata.factories[i].makePosit()) < distToCEM)
							distToCEM = distance(blueMarkers[k], fdata.factories[i].makePosit());
				if(distToCEM < distToCFM)	{
					fdata.factories.mod(i)->side = "blue";
					for(int j = 0; j <= fdata.factories[i].productsNo(); j++)
						fdata.factories.mod(i)->productStockpile[j] = 0;
					for(int j = 0; j <= fdata.factories[i].subassemblyNo(); j++)
						fdata.factories.mod(i)->subassemblyStockpile[j] = 0;
				}
			}
			if(fdata.factories[i].side == "blue")	{
				if(blueMarkers.getSize() > 0)
					distToCFM = distance(blueMarkers[0], fdata.factories[i].makePosit());
				if(redMarkers.getSize() > 0)
					distToCEM = distance(redMarkers[0], fdata.factories[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], fdata.factories[i].makePosit()) < distToCFM)
							distToCFM = distance(blueMarkers[k], fdata.factories[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], fdata.factories[i].makePosit()) < distToCEM)
							distToCEM = distance(redMarkers[k], fdata.factories[i].makePosit());
				if(distToCEM < distToCFM)	{
					fdata.factories.mod(i)->side = "red";
					for(int j = 0; j <= fdata.factories[i].productsNo(); j++)
						fdata.factories.mod(i)->productStockpile[j] = 0;
					for(int j = 0; j <= fdata.factories[i].subassemblyNo(); j++)
						fdata.factories.mod(i)->subassemblyStockpile[j] = 0;
				}
			}
		}
		for(int i = 0; i < fdata.subcontractors.getSize(); i++)	{
			if(fdata.subcontractors[i].side == "red")	{
				if(redMarkers.getSize() > 0)
					distToCFM = distance(redMarkers[0], fdata.subcontractors[i].makePosit());
				if(blueMarkers.getSize() > 0)
					distToCEM = distance(blueMarkers[0], fdata.subcontractors[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], fdata.subcontractors[i].makePosit()) < distToCFM)
							distToCFM = distance(redMarkers[k], fdata.subcontractors[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], fdata.subcontractors[i].makePosit()) < distToCEM)
							distToCEM = distance(blueMarkers[k], fdata.subcontractors[i].makePosit());
				if(distToCEM < distToCFM)	{
					fdata.subcontractors.mod(i)->side = "blue";
					for(int j = 0; j <= fdata.subcontractors[i].mainfactoryNo(); j++)
						fdata.subcontractors.mod(i)->stockpile[j] = 0;
				}
			}
			if(fdata.subcontractors[i].side == "blue")	{
				if(blueMarkers.getSize() > 0)
					distToCFM = distance(blueMarkers[0], fdata.subcontractors[i].makePosit());
				if(redMarkers.getSize() > 0)
					distToCEM = distance(redMarkers[0], fdata.subcontractors[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], fdata.subcontractors[i].makePosit()) < distToCFM)
							distToCFM = distance(blueMarkers[k], fdata.subcontractors[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], fdata.subcontractors[i].makePosit()) < distToCEM)
							distToCEM = distance(redMarkers[k], fdata.subcontractors[i].makePosit());
				if(distToCEM < distToCFM)	{
					fdata.subcontractors.mod(i)->side = "red";
					for(int j = 0; j <= fdata.subcontractors[i].mainfactoryNo(); j++)
						fdata.subcontractors.mod(i)->stockpile[j] = 0;
				}
			}
		}
		fdata.save();
	}
	{
		facilitiesData facdata;
		facdata.load(ppat.getFileName());
		double distToCFM, distToCEM;
		for(int i = 0; i < facdata.airfields.getSize(); i++)	{
			if(facdata.airfields[i].side == "red")	{
				if(redMarkers.getSize() > 0)
					distToCFM = distance(redMarkers[0], facdata.airfields[i].makePosit());
				if(blueMarkers.getSize() > 0)
					distToCEM = distance(blueMarkers[0], facdata.airfields[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], facdata.airfields[i].makePosit()) < distToCFM)
							distToCFM = distance(redMarkers[k], facdata.airfields[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], facdata.airfields[i].makePosit()) < distToCEM)
							distToCEM = distance(blueMarkers[k], facdata.airfields[i].makePosit());
				if(distToCEM < distToCFM)
					facdata.airfields.mod(i)->side = "blue";
			}
			if(facdata.airfields[i].side == "blue")	{
				if(blueMarkers.getSize() > 0)
					distToCFM = distance(blueMarkers[0], facdata.airfields[i].makePosit());
				if(redMarkers.getSize() > 0)
					distToCEM = distance(redMarkers[0], facdata.airfields[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], facdata.airfields[i].makePosit()) < distToCFM)
							distToCFM = distance(blueMarkers[k], facdata.airfields[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], facdata.airfields[i].makePosit()) < distToCEM)
							distToCEM = distance(redMarkers[k], facdata.airfields[i].makePosit());
				if(distToCEM < distToCFM)
					facdata.airfields.mod(i)->side = "red";
			}
		}
		for(int i = 0; i < facdata.ports.getSize(); i++)	{
			if(facdata.ports[i].side == "red")	{
				if(redMarkers.getSize() > 0)
					distToCFM = distance(redMarkers[0], facdata.ports[i].makePosit());
				if(blueMarkers.getSize() > 0)
					distToCEM = distance(blueMarkers[0], facdata.ports[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], facdata.ports[i].makePosit()) < distToCFM)
							distToCFM = distance(redMarkers[k], facdata.ports[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], facdata.ports[i].makePosit()) < distToCEM)
							distToCEM = distance(blueMarkers[k], facdata.ports[i].makePosit());
				if(distToCEM < distToCFM)
					facdata.ports.mod(i)->side = "blue";
			}
			if(facdata.ports[i].side == "blue")	{
				if(blueMarkers.getSize() > 0)
					distToCFM = distance(blueMarkers[0], facdata.ports[i].makePosit());
				if(redMarkers.getSize() > 0)
					distToCEM = distance(redMarkers[0], facdata.ports[i].makePosit());
				if(blueMarkers.getSize() > 1)
					for(int k = 1; k < blueMarkers.getSize(); k++)
						if(distance(blueMarkers[k], facdata.ports[i].makePosit()) < distToCFM)
							distToCFM = distance(blueMarkers[k], facdata.ports[i].makePosit());
				if(redMarkers.getSize() > 1)
					for(int k = 1; k < redMarkers.getSize(); k++)
						if(distance(redMarkers[k], facdata.ports[i].makePosit()) < distToCEM)
							distToCEM = distance(redMarkers[k], facdata.ports[i].makePosit());
				if(distToCEM < distToCFM)
					facdata.ports.mod(i)->side = "red";
			}
		}
		facdata.save();
	}
	std::ifstream in("SIDCMission.mis");
	std::string line;
	seArray<std::string, 50> missFile;
	while(getline(in, line))
		missFile.add(line);
	in.close();
	int counter;
	missFile.add("[FrontMarker]");
	for(int i = 0; i < redMarkers.getSize(); i++)	{
		missFile.add("  FrontMarker" + std::to_string(i) + ' ' + std::to_string(redMarkers[i].positionX) + ' ' + std::to_string(redMarkers[i].positionY) + " 1");
		counter = i;
	}
	counter++;
	for(int i = 0; i < blueMarkers.getSize(); i++)
		missFile.add("  FrontMarker" + std::to_string(i + counter) + ' ' + std::to_string(blueMarkers[i].positionX) + ' ' + std::to_string(blueMarkers[i].positionY) + " 2");
	std::ofstream os("SIDCMission.mis");
	for(int i = 0; i < missFile.getSize(); i++)
		os << missFile[i] + '\n';
}











pilotLog::pilotLog() : name("NoString"), flightHours(0), AtAKills(0), alive(true), groupname("NoString"), rank(), currentRank(9), countryid("NoString"), side("NoString"), briefingApendLine("NoString"), baseName("NoString"), flightNumber(0), planeNumber(0)	{
	for(int i = 0; i < 10; i++)
		rank[i] = "NoString";
}

void pilotLog::askRank()	{
	bool quit = false;
	while(quit == false)	{
		std::cout << "\nPlease select the nation You will be flying for:\n\n"
		          << "1. Great Britain\n"
		          << "2. Germany\n"
		          << "3. Italy\n"
		          << "4. France\n"
		          << "5. United States of America\n"
		          << "6. Other country\n\n";
		int response;
		std::cin >> response;
		switch(response)	{
			case 1 :	{
				rank[0] = "Group Captain";
				rank[1] = "Wing Commander";
				rank[2] = "Squadron Leader";
				rank[3] = "Flight Liutenant";
				rank[4] = "Flying Officer";
				rank[5] = "Pilot Officer";
				rank[6] = "Flight Sergeant";
				countryid = "gb";
				side = "red";
				currentRank = 6;
				std::cout << "\nYou selected to fly for Great Britain\n"
				          << "and ara assigned the rank of: " << rank[6] << std::endl;
				quit  = true;
				break;
			}
			case 2 :	{
				rank[0] = "Oberst";
				rank[1] = "Oberstleutnant";
				rank[2] = "Major";
				rank[3] = "Hauptmann";
				rank[4] = "Oberleutnant";
				rank[5] = "Leutnant";
				rank[6] = "Oberfeldwebel";
				countryid = "de";
				side = "blue";
				currentRank = 6;
				std::cout << "\nYou selected to fly for Germany\n"
				          << "and are assigned the rank of: " << rank[6] << std::endl;
				quit = true;
				break;
			}
			case 3 :	{
				rank[0] = "Colonnello";
				rank[1] = "Tenente Colonnell";
				rank[2] = "Maggiore";
				rank[3] = "Primo capitano";
				rank[4] = "Capitano";
				rank[5] = "Tenente";
				rank[6] = "Sottotenente";
				countryid = "it";
				side = "blue";
				currentRank = 6;
				std::cout << "\nYou selected to fly for Italy\n"
				          << "and ara assigned the rank of: " << rank[6] << std::endl;
				quit  = true;
				break;
			}
			case 4 :	{
				rank[0] = "Colonel";
				rank[1] = "Lieutenant-Colonel";
				rank[2] = "Commandant";
				rank[3] = "Capitaine";
				rank[4] = "Lieutenant ";
				rank[5] = "Sous-Lieutenant";
				rank[6] = "Aspirant";
				countryid = "fr";
				side = "red";
				currentRank = 6;
				std::cout << "\nYou selected to fly for France\n"
				          << "and ara assigned the rank of: " << rank[6] << std::endl;
				quit  = true;
				break;
			}
			case 5 :	{
				rank[0] = "Colonel";
				rank[1] = "Lt. Colonel";
				rank[2] = "Major";
				rank[3] = "Captain";
				rank[4] = "1st Lieutenant";
				rank[5] = "2nd Lieutenant";
				rank[6] = "Flight Officer";
				countryid = "us";
				side = "red";
				currentRank = 6;
				std::cout << "\nYou selected to fly for the United States of America\n"
				          << "and ara assigned the rank of: " << rank[6] << std::endl;
				quit  = true;
				break;
			}
			case 6 :	{
				std::string countryName, countryAbbreviation;
				std::cout << "\nPlease enter the name of the country You wish to fly for:\n";
				std::cin.ignore(256, '\n');
				std::cout.flush();
				getline(std::cin, countryName, '\n');
				std::cout << "\nPlease enter the abberviation of the Country and the\n"
				          << "service, for instance \"ija\" for Imperial Japanese navy:\n";
				std::cin >> countryAbbreviation;
				countryid = countryAbbreviation;
				std::cout << "\nNow, You will need to enter the ranks successively\n"
				          << "from HIGHEST to LOWEST. You can only have 10 ranks!\n\n";
				bool done = false;
				char exit = 'n';
				int index = 0;
				while(!done)	{
					std::cin.ignore(256, '\n');
					std::cout.flush();
					std::string nRank;
					std::cout << "\nNext rank: ";
					getline(std::cin, nRank, '\n');
					rank[index] = nRank;
					index++;
					std::cout << "\nIs this the last rank?\n"
					          << "Type \'y\' for Yes or \'n\' for No and then hit ENTER!\n";
					std::cin >> exit;
					if(exit == 'y')	{
						done = true;
						currentRank = index - 1;
					}
					if(index == 9)	{
						break;
						currentRank = 9;
					}
				}
				int iside;
				std::cout << "\nWhich side will You be flying for?\n"
				          << "1. Red,\n"
				          << "2. Blue.\n";
				std::cin >> iside;
				if((iside != 1) && (iside != 2))
					side = "neutral";
				if(iside == 1)
					side = "red";
				if(iside == 2)
					side = "blue";
				std::cout.flush();
				std::cout << "\nYou have selected to fly for " << countryName << std::endl
				          << "which is participating on the " << side << " side\n"
				          << ", and will start with the rank of a : " << rank[currentRank] << std::endl
				          <<"\nThe ranks You entered are:\n";
				std::cout.flush();
				for(int i = 0; i <= currentRank; i++)
					std::cout << rank[i] << std::endl;
				exit = 'n';
				std::cout << "\nAre You happy with choices You made?\n"
				          << "Type \'y\' and then ENTER for Yes!\n";
				std::cin >> exit;
				if(exit == 'y')
					quit = true;
				break;
			}
			default :
				std::cout << "Please select 1, 2, 3, 4, 5 or 6!" << std::endl;
		}
	}
	std::cout << "\n\nYour ranks are saved in a file named \"ranks\" which\n"
	          << "can be editied in a text editor!\n";
}

std::string pilotLog::getGroupID(std::string pfilename)	{
	std::ifstream in(pfilename);
	std::string line, result;
	std::size_t posit;
	seArray<std::string, 50> missFile;
	while(getline(in, line))
		missFile.add(line);
	for(int i = 0; i < missFile.getSize(); i++)
		if(missFile[i].find("player") != -1)	{
			result = missFile[i].substr(9);
			posit = result.find('.');
			result = result.substr(0, posit);
			planesData pdata;
			pdata.load(pfilename);
			for(int j = 0; j < pdata.Airgroups.getSize(); j++)
				if(pdata.Airgroups[j].find(result) != -1)	{
					result = pdata.Airgroups[j];
					break;
				}
			return result;
		}
}

void pilotLog::load(std::string pfname)	{
	std::ifstream ranksin("ranks");
	if(ranksin)	{
		std::string line;
		seArray<std::string, 10> rankss;
		while(getline(ranksin, line))
			rankss.add(line);
		for(int i = 0; i < rankss.getSize(); i++)
			rank[i] = rankss[i];
	} else	{
		askRank();
	}
	ranksin.close();
	std::ifstream login("pilotLogBook");
	if(login)	{
		std::string line;
		std::size_t sz;
		seArray<std::string, 10> logbook;
		while(getline(login, line))
			logbook.add(line);
		if(logbook[10] != "@@!&@")	{
			std::cout << std::endl << std::endl << "pilotLogBook file corrupt!" << std::endl << std::endl
			          << "Please delete it and run the application again.\n\n"
			          << "Press 'c' and then ENTER to continue.\n\n\n";
			char c;
			while(c != 'c')
				std::cin >> c;
			exit(1);
		}
		name = logbook[0];
		flightHours = std::stod(logbook[1], &sz);
		AtAKills = std::stoi(logbook[2], &sz);
		alive = std::stoi(logbook[3], &sz);
		groupname = logbook[4];
		currentRank = std::stoi(logbook[5], &sz);
		countryid = logbook[6];
		side = logbook[7];
		briefingApendLine = logbook[8];
		baseName = logbook[9];
	} else	{
		askName();
		groupname = getGroupID(pfname);
		planesData pdata;
		pdata.load(pfname);
		facilitiesData facdata;
		facdata.load(pfname);
		checkBase(groupname, pdata, facdata);
		save();
	}
}

void pilotLog::save()	{
	std::ofstream os1("ranks");
	for(int i = 0; i < 10; i++)
		os1 << rank[i] + '\n';
	os1.close();
	std::ofstream os2("pilotLogBook");
	os2 << name + '\n' << std::to_string(flightHours) + '\n' << std::to_string(AtAKills) + '\n' << std::to_string(alive) + '\n' << groupname + '\n' << std::to_string(currentRank) + '\n' << countryid + '\n' << side + '\n'<< briefingApendLine + '\n' << baseName + '\n';
	os2 << "@@!&@";
	os2.close();
}

int pilotLog::getRankLimit()	{
	for(int i = 0; i < 10; i++)	{
		if(rank[i] == "NoString")
			return i - 1;
		if(i == 9)
			return 9;
	}
}

bool pilotLog::checkBase(std::string pgroupname, planesData& ppdata, facilitiesData& pfacdata)	{
	bool baseExists = true;
	bool doneHere = false;
	baseName = "Improvised airfield";
	for(int ii = 0; ii < pfacdata.airfields.getSize(); ii++)	{
		for(int jj = 0; jj < ppdata.Airgroups.getSize(); jj++)
			if((distance(ppdata.makePosit(jj), pfacdata.airfields[ii].makePosit()) < 2000) && (pgroupname == ppdata.Airgroups[jj]))	{
				doneHere = true;
				baseName = pfacdata.airfields[ii].name;
				if(pfacdata.airfields[ii].destroyed())
					baseExists = false;
				break;
			}
		if(doneHere)
			break;
	}
	return baseExists;
}

bool pilotLog::checkPlanes(std::string pgroupname, planesData& ppdata)	{
	for(int i = 0; i < ppdata.Airgroups.getSize(); i++)
		if(ppdata.Airgroups[i] == pgroupname)	{
			if(ppdata.destroyed[i])
				return false;
			if(!ppdata.destroyed[i])
				return true;
		}
}

std::string pilotLog::findAirGroup(std::string pgroupname, planesData& ppdata, facilitiesData& pfacdata)	{
	std::string currType, currSide;
	std::string result = "NoGroup";
	for(int i = 0; i < ppdata.Airgroups.getSize(); i++)
		if(ppdata.Airgroups[i] == pgroupname)	{
			currType = ppdata.type[i];
			currSide = ppdata.side[i];
			break;
		}
	for(int i = 0; i < ppdata.Airgroups.getSize(); i++)
		if((ppdata.type[i] == currType) && (ppdata.side[i] == currSide) && (ppdata.Airgroups[i] != pgroupname) && checkBase(ppdata.Airgroups[i], ppdata, pfacdata) && checkPlanes(ppdata.Airgroups[i], ppdata))	{
			result = ppdata.Airgroups[i];
			break;
		}
	return result;
}

void pilotLog::checkAirGroup(std::string mfilename)	{
	std::ifstream in("SIDCMission.mis");
	if(!in)
		return;
	in.close();
	planesData pdata;
	pdata.load("SIDCMission.state");
	std::string currGroup = getGroupID("SIDCMission.mis");
	facilitiesData facdata;
	facdata.load("SIDCMission.state");
	bool baseExists = true;
	bool doneHere = false;
	for(int i = 0; i < pdata.Airgroups.getSize(); i++)	{
		if((pdata.Airgroups[i] == currGroup) && (side != pdata.side[i]))	{
			std::ifstream statein("DataBackup/SIDCMission.state");
			if(!statein)
				groupname = getGroupID(mfilename);
			if(statein)
				groupname = getGroupID("DataBackup/SIDCMission.state");
			statein.close();
			if(checkBase(groupname, pdata, facdata) && checkPlanes(groupname, pdata))	{
				briefingApendLine = "You have relocated to a squadron of the opposing side. Returning You to Your initial squadron! ";
				return;
			}
			if(!checkBase(groupname, pdata, facdata) || !checkPlanes(groupname, pdata))	{
				std::string newGroup = findAirGroup(groupname, pdata, facdata);
				if(newGroup != "NoGroup")	{
					groupname = newGroup;
					briefingApendLine = "You have relocated to an enemy squadron. You will now be relocated to a friendly squadron! ";
					return;
				}
				if(newGroup == "NoGroup")	{
					groupname = "NoString";
					briefingApendLine = "No planes or no airfields left. ";
					return;
				}
			}
		}
		if((groupname != currGroup) && (currGroup == pdata.Airgroups[i]) && (side == pdata.side[i]))	{
			groupname = currGroup;
			if(checkBase(groupname, pdata, facdata) && checkPlanes(groupname, pdata))	{
				briefingApendLine = "You have been relocated to another squadron! ";
				return;
			}
			if(!checkBase(groupname, pdata, facdata) || !checkPlanes(groupname, pdata))	{
				std::string newGroup = findAirGroup(groupname, pdata, facdata);
				if(newGroup != "NoGroup")	{
					groupname = newGroup;
					briefingApendLine = "The squadron You were relocated to lacks planes or an airfield. You have been relocated to another squadron. ";
					return;
				}
				if(newGroup == "NoGroup")	{
					groupname = "NoString";
					briefingApendLine = "No planes or no airfields left. ";
					return;
				}
			}
		}
		if((groupname == currGroup) && (currGroup == pdata.Airgroups[i]) && (side == pdata.side[i]))
			if(!checkBase(currGroup, pdata, facdata) || !checkPlanes(currGroup, pdata))	{
				std::string newGroup = findAirGroup(groupname, pdata, facdata);
				if(newGroup != "NoGroup")	{
					groupname = newGroup;
					briefingApendLine = "Your planes have been attrited or Your airfield destroyed. You have been relocated to another squadron. ";
					return;
				}
				if(newGroup == "NoGroup")	{
					groupname = "NoString";
					briefingApendLine = "No planes or no airfields left. ";
					return;
				}
			}
	}
}

const std::string pilotLog::MPLine()	{
	if(briefingApendLine == "No planes or no airfields left. ")
		return "";
	std::size_t sz;
	std::size_t posit = groupname.find('.');
	std::string squadronid = groupname.substr(0, posit);
	std::string firstNo = groupname.substr(posit + 1);
	firstNo = firstNo.substr(0, 1);
	int squadronNo = std::stoi(firstNo, &sz);
	double no1, no2;
	int flightNo, planeNo;
	planesData pdata;
	pdata.load("SIDCMission.state");
	for(int i = 0; i < pdata.Airgroups.getSize(); i++)
		if(pdata.Airgroups[i] == groupname)	{
			int currPlanesNo = 0;
			for(int ni = 0; ni <= pdata.flights[i].getflight0Limit(); ni++)
				if(!pdata.flights[i].flight0destroyed[ni])
					currPlanesNo++;
			for(int ni = 0; ni <= pdata.flights[i].getflight1Limit(); ni++)
				if(!pdata.flights[i].flight1destroyed[ni])
					currPlanesNo++;
			for(int ni = 0; ni <= pdata.flights[i].getflight2Limit(); ni++)
				if(!pdata.flights[i].flight2destroyed[ni])
					currPlanesNo++;
			for(int ni = 0; ni < pdata.flights[i].getflight3Limit(); ni++)
				if(!pdata.flights[i].flight3destroyed[ni])
					currPlanesNo++;
			int planesPerFlight = 0;
			if(pdata.flights[i].getflight0Limit() + 1 > planesPerFlight)
				planesPerFlight = pdata.flights[i].getflight0Limit() + 1;
			if(pdata.flights[i].getflight1Limit() + 1 > planesPerFlight)
				planesPerFlight = pdata.flights[i].getflight1Limit() + 1;
			if(pdata.flights[i].getflight2Limit() + 1 > planesPerFlight)
				planesPerFlight = pdata.flights[i].getflight2Limit() + 1;
			if(pdata.flights[i].getflight3Limit() + 1 > planesPerFlight)
				planesPerFlight = pdata.flights[i].getflight3Limit() + 1;
			if(currentRank == 0)	{
				flightNo = 0;
				planeNo = 0;
			}
			if(currentRank + 1 >= currPlanesNo)	{
				if(currPlanesNo % planesPerFlight != 0)	{
					no1 = currPlanesNo / planesPerFlight;
					flightNo = int(no1);
					no2 = currPlanesNo - flightNo * planesPerFlight - 1;
					planeNo = int(no2);
				}
				if(currPlanesNo % planesPerFlight == 0)	{
					no1 = currPlanesNo / planesPerFlight;
					flightNo = int(no1) - 1;
					no2 = currPlanesNo - flightNo * planesPerFlight - 1;
					planeNo = int(no2);
				}
			}
			if((currentRank + 1 < currPlanesNo) && (currentRank > 0))	{
				if((currentRank + 1) % planesPerFlight != 0)	{
					no1 = (currentRank + 1) / planesPerFlight;
					flightNo = int(no1);
					no2 = currentRank - flightNo * planesPerFlight;
					planeNo = int(no2);
				}
				if((currentRank + 1) % planesPerFlight == 0)	{
					no1 = (currentRank + 1) / planesPerFlight;
					flightNo = int(no1) - 1;
					no2 = currentRank - flightNo * planesPerFlight;
					planeNo = int(no2);
				}
			}
			break;
		}
	flightNumber = flightNo + 1;
	planeNumber = planeNo + 1;
	std::string res = "  player " + squadronid + '.' + std::to_string(squadronNo) + std::to_string(flightNo) + std::to_string(planeNo);
	return res;
}

void pilotLog::setFromKillLog()	{
	std::string line;
	seArray<std::string, 20> killLog;
	std::ifstream killLogIn("kill.log");
	int killCount = 0;
	if(!killLogIn)
		return;
	while(getline(killLogIn, line))
		killLog.add(line);
	for(int i = 0; i < killLog.getSize(); i++)	{
		if(killLog[i] == "DeadPilot")	{
			alive = false;
		}
		if(killLog[i] == "KilledByPilot")	{
			killCount++;
		}
	}
	AtAKills += killCount;
}

void pilotLog::promote()	{
	double promotion = flightHours + AtAKills * 10;
	double cRank = getRankLimit() - (promotion / 100);
	if((cRank >= getRankLimit()) || (currentRank == 0))	{
		return;
	}
	if((cRank < currentRank) && ((int)(cRank + 1) != currentRank) && (currentRank != 0))	{
		currentRank = cRank + 1;
		if(currentRank < 0)
			currentRank = 0;
		if(briefingApendLine == "NoString")	{
			briefingApendLine = "You have just been promoted to the rank of " + rank[currentRank] + ". ";
			return;
		}
		if((briefingApendLine != "NoString") && (briefingApendLine.find("You have been killed") == -1) && (briefingApendLine.find("No planes or no airfields left") == -1))	{
			briefingApendLine = briefingApendLine + " You have just been promoted to the rank of " + rank[currentRank] + '.';
			return;
		}
	}
	if((cRank < 0) && (currentRank != 0))	{
		currentRank = 0;
		if(briefingApendLine == "NoString")	{
			briefingApendLine = "You have just been promoted to the rank of " + rank[currentRank] + ". ";
			return;
		}
		if((briefingApendLine != "NoString") && (briefingApendLine.find("You have been killed") == -1) && (briefingApendLine.find("No planes or no airfields left") == -1))	{
			briefingApendLine = briefingApendLine + " You have just been promoted to the rank of " + rank[currentRank] + '.';
			return;
		}
	}
}

void pilotLog::resetLog()	{
	if(!alive)	{
		flightHours = 0;
		AtAKills = 0;
		currentRank = getRankLimit();
		alive = true;
		groupname = getGroupID("DataBackup/SIDCMission.state");
		if(briefingApendLine == "NoString")
			briefingApendLine = "You have been killed! Your log has been reset. ";
		if((briefingApendLine != "NoString") && (briefingApendLine != "You have been killed! Your log has been reset. "))
			briefingApendLine = briefingApendLine + "You have been killed! Your log has been reset. ";
		save();
	}
}


void checkBlitz::load()	{
	std::ifstream in("cBlitz");
	if(!in)	{
		char answer = 'a';
		std::cout << "\n\nDo You plan to run this campaign with\n"
		          << "IL- 2: Cliffs of Dover- Blitz?\n"
		          << "(Type \'y\' for Yes, \'n\' for No)\n\n";
		std::cin >> answer;
		while((answer != 'y') && (answer != 'n'))	{
			std::cout << "\nPlease type \'y\' or \'n\'!\n";
			std::cin >> answer;
		}
		if(answer == 'y')
			isBlitz = true;
		if(answer == 'n')
			isBlitz = false;
		save();
	} else	{
		std::string line;
		std::size_t sz;
		getline(in, line);
		line = line[0];
		isBlitz = std::stoi(line, &sz);
	}
}

void checkBlitz::save()	{
	std::ofstream out("cBlitz");
	out << std::to_string(isBlitz);
}



void backup()	{
	std::cout << "\n\nYour campaign files have just been created.\n"
	          << "Now is the moment to edit Your .dat files and\n"
	          << "replace generic place names, factory names etc.\n"
	          << "by proper names. If You wish to do so, please open\n"
	          << "up the .dat files in a text editor and complete the task.\n"
	          << "When You\' re done, come back to this window and continue.\n\n"
	          << "Press 'c' and then ENTER to continue.\n\n\n";
	char c;
	while(c != 'c')
		std::cin >> c;
	system("mkdir DataBackup");
	system("copy campaignTime \"DataBackup\\campaignTime\" >nul");
	std::ifstream cdin("chiefs.dat");
	if(cdin)
		system("copy chiefs.dat \"DataBackup\\chiefs.dat\" >nul");
	cdin.close();
	std::ifstream facin("facilities.dat");
	if(facin)
		system("copy facilities.dat \"DataBackup\\facilities.dat\" >nul");
	facin.close();
	std::ifstream fin("factories.dat");
	if(fin)
		system("copy factories.dat \"DataBackup\\factories.dat\" >nul");
	fin.close();
	system("copy mode \"DataBackup\\mode\" >nul");
	std::ifstream pin("planes.dat");
	if(pin)
		system("copy planes.dat \"DataBackup\\planes.dat\" >nul");
	pin.close();
	system("copy SIDCMission.state \"DataBackup\\SIDCMission.state\" >nul");
	std::ifstream sin("static.dat");
	if(sin)
		system("copy static.dat \"DataBackup\\static.dat\" >nul");
	sin.close();
	std::ifstream subin("subcontractors.dat");
	if(subin)
		system("copy subcontractors.dat \"DataBackup\\subcontractors.dat\" >nul");
	system("copy cBlitz \"DataBackup\\cBlitz\" >nul");
	std::cout << "\nJust backed up the files...\n\n";
}



void reset()	{
	system("del campaignTime");
	{
		std::ifstream cin("chiefs.dat");
		if(cin)	{
			cin.close();
			system("del chiefs.dat");
		} else
			cin.close();
	}
	{
		std::ifstream facin("facilities.dat");
		if(facin)	{
			facin.close();
			system("del facilities.dat");
		} else
			facin.close();
	}
	{
		std::ifstream fin("factories.dat");
		if(fin)	{
			fin.close();
			system("del factories.dat");
		} else
			fin.close();
	}
	system("del SIDCMission.*");
	system("del missionCount");
	system("del mode");
	{
		std::ifstream pin("planes.dat");
		if(pin)	{
			pin.close();
			system("del planes.dat");
		} else
			pin.close();
	}
	{
		std::ifstream brin("SIDCMission.briefing");
		if(brin)	{
			brin.close();
			system("del SIDCMission.briefing");
		} else
			brin.close();
	}
	system("del SIDCMission.state");
	{
		std::ifstream sin("static.dat");
		if(sin)	{
			sin.close();
			system("del static.dat");
		} else
			sin.close();
	}
	{
		std::ifstream subin("subcontractors.dat");
		if(subin)	{
			subin.close();
			system("del subcontractors.dat");
		} else
			subin.close();
	}
	{
		std::ifstream killin("kill.log");
		if(killin)	{
			killin.close();
			system("del kill.log");
		} else
			killin.close();
	}
	system("del cBlitz");
	system("copy \"DataBackup\\campaignTime\" campaignTime > nul");
	std::ifstream cin1("DataBackup\\chiefs.dat");
	if(cin1)
		system("copy \"DataBackup\\chiefs.dat\" chiefs.dat >nul");
	cin1.close();
	std::ifstream facin1("DataBackup\\facilities.dat");
	if(facin1)
		system("copy \"DataBackup\\facilities.dat\" facilities.dat >nul");
	facin1.close();
	std::ifstream fin1("DataBackup\\factories.dat");
	if(fin1)
		system("copy \"DataBackup\\factories.dat\" factories.dat >nul");
	fin1.close();
	system("copy \"DataBackup\\mode\" mode >nul");
	std::ifstream pin1("DataBackup\\planes.dat");
	if(pin1)
		system("copy \"DataBackup\\planes.dat\" planes.dat >nul");
	pin1.close();
	system("copy \"DataBackup\\SIDCMission.state\" SIDCMission.state >nul");
	std::ifstream sin1("DataBackup\\static.dat");
	if(sin1)
		system("copy \"DataBackup\\static.dat\" static.dat >nul");
	sin1.close();
	std::ifstream subin1("DataBackup\\subcontractors.dat");
	if(subin1)
		system("copy \"DataBackup\\subcontractors.dat\" subcontractors.dat >nul");
	subin1.close();
	system("copy \"DataBackup\\cBlitz\" cBlitz >nul");
}



void assesStrength(mainTables& pmt, pattern& ppat, pilotLog& pplog)	{
	assesResult = "NoString";
	resetPlayerLine = false;
	int redStrength = 0;
	int redCounter = 0;
	int blueStrength = 0;
	int blueCounter = 0;
	bool redSideOwn = false;
	bool blueSideOwn = false;
	int playerIndex = 0;
	std::string result = "NoString";
	for(int i = 0; i < ppat.uniqueid.getSize(); i++)
		if(ppat.uniqueid[i] == "player")	{
			playerIndex = ppat.LineIndex[i];
			break;
		}
	std::string playerAGID = ppat.missionMis[playerIndex];
	playerAGID = playerAGID.substr(9);
	playerAGID = playerAGID.substr(0, playerAGID.length() - 2);
	planesData pdata;
	pdata.load("SIDCMission.state");
	for(int i = 0; i < pdata.Airgroups.getSize(); i++)
		if(pdata.Airgroups[i].find(playerAGID) != -1)	{
			if(pdata.side[i] == "red")
				redSideOwn = true;
			if(pdata.side[i] == "blue")
				blueSideOwn = true;
		}
	pdata.load("SIDCMission.state");
	for(int i = 0; i < pmt.fightersRed.getSize(); i++)
		redCounter++;
	redStrength = redStrength + redCounter * fighterStrength;
	redCounter = 0;
	for(int i = 0; i < pmt.bombersRed.getSize(); i++)
		redCounter++;
	redStrength = redStrength + redCounter * bomberStrength;
	redCounter = 0;
	for(int i = 0; i < pmt.jabosRed.getSize(); i++)
		redCounter++;
	redStrength = redStrength + redCounter * jaboStrength;
	for(int i = 0; i < pmt.gunsRed.getSize(); i++)
		redCounter++;
	redStrength = redStrength + redCounter * artyStrength;
	redCounter = 0;
	for(int i = 0; i < pmt.tanksRed.getSize(); i++)
		redCounter++;
	redStrength = redStrength + redCounter * redTankStrength;
	redCounter = 0;
	for(int i = 0; i < pmt.shipsRed.getSize(); i++)
		redCounter++;
	redStrength = redStrength + redCounter * shipStrength;
	for(int i = 0; i < pmt.fightersBlue.getSize(); i++)
		blueCounter++;
	blueStrength = blueStrength + blueCounter * fighterStrength;
	blueCounter = 0;
	for(int i = 0; i < pmt.bombersBlue.getSize(); i++)
		blueCounter++;
	blueStrength = blueStrength + blueCounter * bomberStrength;
	blueCounter = 0;
	for(int i = 0; i < pmt.jabosBlue.getSize(); i++)
		blueCounter++;
	blueStrength = blueStrength + blueCounter * jaboStrength;
	for(int i = 0; i < pmt.gunsBlue.getSize(); i++)
		blueCounter++;
	blueStrength = blueStrength + blueCounter * artyStrength;
	blueCounter = 0;
	for(int i = 0; i < pmt.tanksBlue.getSize(); i++)
		blueCounter++;
	blueStrength = blueStrength + blueCounter * blueTankStrength;
	blueCounter = 0;
	for(int i = 0; i < pmt.shipsBlue.getSize(); i++)
		blueCounter++;
	blueStrength = blueStrength + blueCounter * shipStrength;
	if(redStrength < 0.15 * blueStrength)	{
		if(redSideOwn)	{
			result = "The war is over. You have lost and the campaign was reset!\n\n";
			reset();
		}
		if(!redSideOwn)	{
			result = "The enemy is defeated! You achieved a complete victory and the campaign was reset!\n\n";
			reset();
		}
	}
	if(blueStrength < 0.15 * redStrength)	{
		if(blueSideOwn)	{
			result = "The war is over. You have lost and the campaign was reset!\n\n";
			reset();
		}
		if(!blueSideOwn)	{
			result = "The enemy is defeated! You achieved a complete victory and the campaign was reset!\n\n";
			reset();
		}
	}
	if(pmt.bombersRed.getSize() == 0 && pmt.bombersBlue.getSize() == 0 && pmt.jabosRed.getSize() == 0 && pmt.jabosBlue.getSize() == 0)	{
		result = "Neither side can prevail. The war is over and the campaign is reset!\n\n";
		reset();
	}
	if(!pplog.getDeath())	{
		result = "You have been killed. Your campaign and Your log book are reset!\n\n";
		pplog.resetLog();
		resetPlayerLine = true;
		reset();
	}
	if(pplog.getBALine().find("No planes or no airfields left") != -1)	{
		result = "You have no aero planes left or no airfields to take off from. The campaign is reset!\n\n";
		resetPlayerLine = true;
		reset();
	}
	if(result != "NoString")
		assesResult = result;
}



void makeWeatherSection(weatherSection* pws)	{
	missionCount mc;
	timeFlow tf;
	int loopExit = 0;
	float FweatherIndex = 0;
	int weatherIndex = 0;
	int cloudHeight = 0;
	int breezeActivity = 0;
	int thermalActivity = 0;
	srand(int(mc.get()));
	loopExit = mc.get();
	if(tf.getSeason() == "spring")	{
		if((mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit--;
		if((mc.get() % 3 != 0) && (mc.get() % 5 == 0))
			loopExit--;
		if((mc.get() % 3 == 0) && (mc.get() % 5 == 0))
			loopExit++;
		for(int i = 0; i <= loopExit; i++)	{
			weatherIndex = rand() % 24;
			FweatherIndex = weatherIndex;
			FweatherIndex /= 10;
			FweatherIndex = round(FweatherIndex);
			weatherIndex = FweatherIndex;
			cloudHeight = rand() % 1000 + 500;
			breezeActivity = rand() % ((weatherIndex + 1) * 3 + 1);
			thermalActivity = rand() % ((weatherIndex + 1) * 3 + 1);
		}
		pws->ws.add("  WeatherIndex " + std::to_string(weatherIndex));
		pws->ws.add("  CloudsHeight " + std::to_string(cloudHeight));
		pws->ws.add("  BreezeActivity " + std::to_string(breezeActivity));
		pws->ws.add("  ThermalActivity " + std::to_string(thermalActivity));
	}
	if(tf.getSeason() == "summer")	{
		if((mc.get() % 2 == 0) && (mc.get() % 3 != 0) && (mc.get() % 5 != 0))
			loopExit--;
		if((mc.get() % 2 != 0) && (mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit--;
		if((mc.get() % 2 != 0) && (mc.get() % 3 != 0) && (mc.get() % 5 == 0))
			loopExit--;
		if((mc.get() % 2 == 0) && (mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit++;
		if((mc.get() % 2 != 0) && (mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit++;
		if((mc.get() % 2 != 0) && (mc.get() % 3 != 0) && (mc.get() % 5 == 0))
			loopExit++;
		for(int i = 0; i <= loopExit; i++)	{
			weatherIndex = rand() % 16;
			FweatherIndex = weatherIndex;
			FweatherIndex /= 10;
			FweatherIndex = round(FweatherIndex);
			weatherIndex = FweatherIndex;
			cloudHeight = rand() % 500 + 1000;
			breezeActivity = rand() % ((weatherIndex + 1) * 3 + 1);
			thermalActivity = rand() % ((weatherIndex + 1) * 3 + 1);
		}
		pws->ws.add("  WeatherIndex " + std::to_string(weatherIndex));
		pws->ws.add("  CloudsHeight " + std::to_string(cloudHeight));
		pws->ws.add("  BreezeActivity " + std::to_string(breezeActivity));
		pws->ws.add("  ThermalActivity " + std::to_string(thermalActivity));
	}
	if(tf.getSeason() == "autumn")	{
		if((mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit--;
		if((mc.get() % 3 != 0) && (mc.get() % 5 == 0))
			loopExit--;
		if((mc.get() % 3 == 0) && (mc.get() % 5 == 0))
			loopExit++;
		for(int i = 0; i <= loopExit; i++)	{
			weatherIndex = rand() % 22 + 2;
			FweatherIndex = weatherIndex;
			FweatherIndex /= 10;
			FweatherIndex = round(FweatherIndex);
			weatherIndex = FweatherIndex;
			cloudHeight = rand() % 1000 + 500;
			breezeActivity = rand() % ((weatherIndex + 1) * 3 + 1);
			thermalActivity = rand() % ((weatherIndex + 1) * 3 + 1);
		}
		pws->ws.add("  WeatherIndex " + std::to_string(weatherIndex));
		pws->ws.add("  CloudsHeight " + std::to_string(cloudHeight));
		pws->ws.add("  BreezeActivity " + std::to_string(breezeActivity));
		pws->ws.add("  ThermalActivity " + std::to_string(thermalActivity));
	}
	if(tf.getSeason() == "winter")	{
		if((mc.get() % 2 == 0) && (mc.get() % 3 != 0) && (mc.get() % 5 != 0))
			loopExit--;
		if((mc.get() % 2 != 0) && (mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit--;
		if((mc.get() % 2 != 0) && (mc.get() % 3 != 0) && (mc.get() % 5 == 0))
			loopExit--;
		if((mc.get() % 2 == 0) && (mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit++;
		if((mc.get() % 2 != 0) && (mc.get() % 3 == 0) && (mc.get() % 5 != 0))
			loopExit++;
		if((mc.get() % 2 != 0) && (mc.get() % 3 != 0) && (mc.get() % 5 == 0))
			loopExit++;
		for(int i = 0; i <= loopExit; i++)	{
			weatherIndex = rand() % 17 + 2;
			FweatherIndex = weatherIndex;
			FweatherIndex /= 10;
			FweatherIndex = round(FweatherIndex);
			weatherIndex = FweatherIndex;
			cloudHeight = rand() % 1000 + 500;
			breezeActivity = rand() % ((weatherIndex + 1) * 3 + 1);
			thermalActivity = rand() % ((weatherIndex + 1) * 3 + 1);
		}
		pws->ws.add("  WeatherIndex " + std::to_string(weatherIndex));
		pws->ws.add("  CloudsHeight " + std::to_string(cloudHeight));
		pws->ws.add("  BreezeActivity " + std::to_string(breezeActivity));
		pws->ws.add("  ThermalActivity " + std::to_string(thermalActivity));
	}
}



void cleanup()	{
	system("del campaignTime");
	{
		std::ifstream cin("chiefs.dat");
		if(cin)	{
			cin.close();
			system("del chiefs.dat");
		} else
			cin.close();
	}
	{
		std::ifstream facin("facilities.dat");
		if(facin)	{
			facin.close();
			system("del facilities.dat");
		} else
			facin.close();
	}
	{
		std::ifstream fin("factories.dat");
		if(fin)	{
			fin.close();
			system("del factories.dat");
		} else
			fin.close();
	}
	system("del missionCount");
	system("del mode");
	{
		std::ifstream pin("planes.dat");
		if(pin)	{
			pin.close();
			system("del planes.dat");
		} else
			pin.close();
	}
	{
		std::ifstream brin("SIDCMission.briefing");
		if(brin)	{
			brin.close();
			system("del SIDCMission.briefing");
		} else
			brin.close();
	}
	{
		std::ifstream msin("SIDCMission.mis");
		if(msin)	{
			msin.close();
			system("del SIDCMission.mis");
		} else
			msin.close();
	}
	{
		std::ifstream stin("SIDCMission.state");
		if(stin)	{
			stin.close();
			system("del SIDCMission.state");
		} else
			stin.close();
	}
	{
		std::ifstream sin("static.dat");
		if(sin)	{
			sin.close();
			system("del static.dat");
		} else
			sin.close();
	}
	{
		std::ifstream subin("subcontractors.dat");
		if(subin)	{
			subin.close();
			system("del subcontractors.dat");
		} else
			subin.close();
	}
	{
		std::ifstream killin("kill.log");
		if(killin)	{
			killin.close();
			system("del kill.log");
		} else
			killin.close();
	}
	system("del cBlitz");
}



bool copyFromBackup(const std::string pFolderName)	{
	std::string folderPath = pFolderName;
	for(int ii = 0; ii < folderPath.length(); ii++)
		if(folderPath[ii] == '\\')	{
			folderPath[ii] = '|';
			std::size_t sz = ii;
			folderPath.insert(sz, 1, '|');
		}
	for(int ii = 0; ii < folderPath.length(); ii++)
		if(folderPath[ii] == '|')
			folderPath[ii] = '\\';
	std::string filePath = folderPath + "\\\\SIDCMission.state";
	std::ifstream bin(filePath);
	if(!bin)	{
		std::cout << "\n\nThe folder specified:\n"
		          << pFolderName << std::endl
		          << "doesn\' t contain a campaign backup!\n\n";
		return false;
	}
	seArray<std::string, 100> state;
	std::string line;
	while(getline(bin, line))
		state.add(line);
	bin.close();
	std::ofstream stateo("SIDCMission.state");
	for(int i = 0; i < state.getSize(); i++)
		stateo << state[i] << '\n';
	stateo.close();
	filePath = folderPath + "\\\\campaignTime";
	std::ifstream timein(filePath);
	seArray<std::string, 20> ctime;
	while(getline(timein, line))
		ctime.add(line);
	timein.close();
	std::ofstream timeout("campaignTime");
	for(int i = 0; i < ctime.getSize(); i++)
		timeout << ctime[i] << '\n';
	timeout.close();
	filePath = folderPath + "\\\\chiefs.dat";
	std::ifstream chiefsin(filePath);
	if(chiefsin)	{
		seArray<std::string, 20> chiefs;
		while(getline(chiefsin, line))
			chiefs.add(line);
		std::ofstream chiefsout("chiefs.dat");
		for(int i = 0; i < chiefs.getSize(); i++)
			chiefsout << chiefs[i] << '\n';
		chiefsout.close();
	}
	chiefsin.close();
	filePath = folderPath + "\\\\facilities.dat";
	std::ifstream facilitiesin(filePath);
	if(facilitiesin)	{
		seArray<std::string, 20> facilities;
		while(getline(facilitiesin, line))
			facilities.add(line);
		std::ofstream facilitiesout("facilities.dat");
		for(int i = 0; i < facilities.getSize(); i++)
			facilitiesout << facilities[i] << '\n';
		facilitiesout.close();
	}
	facilitiesin.close();
	filePath = folderPath + "\\\\factories.dat";
	std::ifstream factoriesin(filePath);
	if(factoriesin)	{
		seArray<std::string, 20> factories;
		while(getline(factoriesin, line))
			factories.add(line);
		std::ofstream factoriesout("factories.dat");
		for(int i = 0; i < factories.getSize(); i++)
			factoriesout << factories[i] << '\n';
		factoriesout.close();
	}
	factoriesin.close();
	filePath = folderPath + "\\\\mode";
	std::ifstream modein(filePath);
	seArray<std::string, 20> mode;
	while(getline(modein, line))
		mode.add(line);
	modein.close();
	std::ofstream modeout("mode");
	for(int i = 0; i < mode.getSize(); i++)
		modeout << mode[i];
	modeout.close();
	filePath = folderPath + "\\\\planes.dat";
	std::ifstream planesin(filePath);
	if(planesin)	{
		seArray<std::string, 20> planes;
		while(getline(planesin, line))
			planes.add(line);
		std::ofstream planesout("planes.dat");
		for(int i = 0; i < planes.getSize(); i++)
			planesout << planes[i] << '\n';
		planesout.close();
	}
	planesin.close();
	filePath = folderPath + "\\\\static.dat";
	std::ifstream staticin(filePath);
	if(staticin)	{
		seArray<std::string, 20> sstatic;
		while(getline(staticin, line))
			sstatic.add(line);
		std::ofstream staticout("static.dat");
		for(int i = 0; i < sstatic.getSize(); i++)
			staticout << sstatic[i] << '\n';
		staticout.close();
	}
	staticin.close();
	filePath = folderPath + "\\\\subcontractors.dat";
	std::ifstream subcontractorsin(filePath);
	if(subcontractorsin)	{
		seArray<std::string, 20> subcontractors;
		while(getline(subcontractorsin, line))
			subcontractors.add(line);
		std::ofstream subcontractorsout("subcontractors.dat");
		for(int i = 0; i < subcontractors.getSize(); i++)
			subcontractorsout << subcontractors[i] << '\n';
		subcontractorsout.close();
	}
	subcontractorsin.close();
	filePath = folderPath + "\\\\cBlitz";
	std::ifstream cBlitzin(filePath);
	if(cBlitzin)	{
		seArray<std::string, 2> cblitz;
		while(getline(cBlitzin, line))
			cblitz.add(line);
		std::ofstream cBlitzout("cBlitz");
		for(int i = 0; i < cblitz.getSize(); i++)
			cBlitzout << cblitz[i];
		cBlitzout.close();
	}
	cBlitzin.close();
	return true;
}

