
#include "CLODDC.h"
#include <fstream>
#include <string>
#include <cstdlib>



const double sin60 = 0.8660254;
const double cos60 = 0.5;
const double interceptRange = 60000;																
const double intZRadius = 5000;


int randGenCounter = 1;


void triangularPattern::setPattern(const double pperiod, const position ppos, const double pspeed)	{
	double speed = (pspeed * 1000) / 60;
	double triangleSide = (speed * pperiod) / 3;
	tpp[0].positionX = ppos.positionX - triangleSide * sin60;
	tpp[0].positionY = ppos.positionY + triangleSide * cos60;
	tpp[0].altitude = ppos.altitude;
	tpp[1].positionX = tpp[0].positionX;
	tpp[1].positionY = tpp[0].positionY - triangleSide;
	tpp[1].altitude = tpp[0].altitude;
	tpp[2] = ppos;
}



void squarePattern::setPattern(const double pperiod, const position ppos, const double pspeed)	{
	double speed = (pspeed * 1000) / 60;
	double squareSide = (speed * pperiod) / 4;
	spp[0].positionX = ppos.positionX + squareSide / 2;
	spp[0].positionY = ppos.positionY;
	spp[0].altitude = ppos.altitude;
	spp[1].positionX = spp[0].positionX;
	spp[1].positionY = ppos.positionY + squareSide / 2;
	spp[1].altitude = ppos.altitude;
	spp[2].positionX = spp[1].positionX - squareSide;
	spp[2].positionY = spp[1].positionY;
	spp[2].altitude = spp[1].altitude;
	spp[3].positionX = spp[2].positionX;
	spp[3].positionY = spp[2].positionY - squareSide;
	spp[3].altitude = spp[2].altitude;
	spp[4].positionX = spp[0].positionX;
	spp[4].positionY = spp[3].positionY;
	spp[4].altitude = spp[3].altitude;
	spp[5] = spp[0];
}



void attrit(timeFlow& ptf)	{
	std::ifstream in("kill.log");
	std::string line;
	std::size_t firstBracket, secondBracket;
	bool present;
	seArray<std::string, 20> killLog;
	while(getline(in, line))
		killLog.add(line);
	seArray<std::string, 10> attritedStatic;
	seArray<std::string, 10> attritedChiefs;
	seArray<std::string, 10> attritedPlanes;
	landedPlanes lp;
	for(int i = 0; i < killLog.getSize(); i++)	{
		present = false;
		if(killLog[i].find("duration") != -1 || killLog[i].find("DeadPilot") != -1 || killLog[i].find("KilledByPilot") != -1 || killLog[i].find("NONAME") != -1 || killLog[i].find("Landed") != -1)		
			continue;
		if(killLog[i].find("Chief") != -1)	{
			firstBracket = killLog[i].find('[');													
			secondBracket = killLog[i].find(']');
			line = killLog[i].substr(firstBracket + 3, secondBracket - firstBracket - 3);	
			for(int j = 0; j < attritedChiefs.getSize(); j++)
				if(attritedChiefs[j] == line)	{
					present = true;
					break;
				}
			if(!present)							
				attritedChiefs.add(line);
		}
		if(killLog[i].find("Static") != -1)	{
			firstBracket = killLog[i].find('[');													
			secondBracket = killLog[i].find(']');
			line = killLog[i].substr(firstBracket + 3, secondBracket - firstBracket - 3);			
			for(int jj = 0; jj < attritedStatic.getSize(); jj++)
				if(attritedStatic[jj] == line)	{
					present = true;
					break;
				}
			if(!present)
				attritedStatic.add(line);
		}
		if(killLog[i].find("Static") == -1 && killLog[i].find("Chief") == -1)	{
			if(killLog[i].find("human") == -1)	{
				firstBracket = killLog[i].find('[');
				secondBracket = killLog[i].find(']');
				line = killLog[i].substr(firstBracket + 3, secondBracket - firstBracket - 3);	
				for(int jjj = 0; jjj < attritedPlanes.getSize(); jjj++)
					if(attritedPlanes[jjj] == line)	{
						present = true;
						break;
					}
				if(!present && !lp.planeLanded(line))
					attritedPlanes.add(line);
			}
		}
	}
	if(attritedChiefs.getSize() > 0)	{
		chiefsData cdata;
		cdata.load("SIDCMission.state");
		seArray<std::string, 10> processedChiefNames;											
		std::size_t fPosit;																		
		std::string currChiefName;
		for(int i = 0; i < attritedChiefs.getSize(); i++)	{
			int currChiefVehiclesNo = 0;											
			present = false;
			fPosit = attritedChiefs[i].find('f');
			currChiefName = attritedChiefs[i].substr(0, fPosit + 1);
			for(int ii = 0; ii < processedChiefNames.getSize(); ii++)	
				if(processedChiefNames[ii] == currChiefName)	{
					present = true;																
					break;
				}
			if(!present)	{
				processedChiefNames.add(currChiefName);
				for(int j = 0; j < attritedChiefs.getSize(); j++)
					if(attritedChiefs[j].find(currChiefName) != -1)								
						currChiefVehiclesNo++;
				for(int k = 0; k < cdata.chiefname.getSize(); k++)
					if(cdata.chiefname[k] == currChiefName)	{
						int newVehiclesNo = cdata.vehiclesNo[k] - currChiefVehiclesNo;
						if(newVehiclesNo < 0)	{												
							newVehiclesNo = 0;
						}
						*(cdata.vehiclesNo.mod(k)) = newVehiclesNo;
					}
			}
		}
		cdata.save();
	}
	if(attritedStatic.getSize() > 0)	{
		factoriesData fdata;
		fdata.load("SIDCMission.state");
		facilitiesData facdata;
		facdata.load("SIDCMission.state");
		staticData sdata;
		sdata.load("SIDCMission.state");
		std::string currStaticID;
		for(int i = 0; i < attritedStatic.getSize(); i++)	{
			bool found = false;
			currStaticID = attritedStatic[i];
			for(int j = 0; j < fdata.factories.getSize(); j++)
				for(int k = 0; k < 4; k++)
					if(fdata.factories[j].staticid[k] == currStaticID)	{
						fdata.factories.mod(j)->bicycleDestroyed[k] = true;
						found = true;
						break;
					}
			if(found)
				continue;
			for(int j = 0; j < fdata.subcontractors.getSize(); j++)
				for(int k = 0; k < 4; k++)
					if(fdata.subcontractors[j].staticid[k] == currStaticID)	{
						fdata.subcontractors.mod(j)->bicycleDestroyed[k] = true;
						found = true;
						break;
					}
			if(found)
				continue;
			for(int j = 0; j < facdata.airfields.getSize(); j++)
				for(int k = 0; k < 4; k++)
					if(facdata.airfields[j].staticid[k] == currStaticID)	{
						facdata.airfields.mod(j)->tractorDestroyed[k] = true;
						facdata.airfields.mod(j)->ToTDestruction[k] = ptf.getLongTime();
						found = true;
						break;
					}
			if(found)
				continue;
			for(int j = 0; j < facdata.ports.getSize(); j++)
				for(int k = 0; k < 4; k++)
					if(facdata.ports[j].staticid[k] == currStaticID)	{
						facdata.ports.mod(j)->tractorDestroyed[k] = true;
						facdata.ports.mod(j)->ToTDestruction[k] = ptf.getLongTime();
						found = true;
						break;
					}
			if(found)
				continue;
			for(int j = 0; j < sdata.guns.getSize(); j++)
				if(sdata.guns[j].staticid == currStaticID)	{
					sdata.guns.mod(j)->destroyed = true;
					found = true;
					break;
				}
			if(found)
				continue;
			for(int j = 0; j < sdata.radars.getSize(); j++)
				if(sdata.radars[j].staticid == currStaticID)	{
					sdata.radars.mod(j)->destroyed = true;
					found = true;
					break;
				}
		}
		if(fdata.factories.getSize() > 0 || fdata.subcontractors.getSize() > 0)
			fdata.save();
		if(facdata.airfields.getSize() > 0 || facdata.ports.getSize() > 0)
			facdata.save();
		if(sdata.radars.getSize() > 0 || sdata.guns.getSize() > 0)
			sdata.save();
	}
	if(attritedPlanes.getSize() > 0)	{
		std::size_t sz;
		std::string flightLine;
		std::string currGroupID;							
		std::string currTacticalNo;							
		std::string wholeID;								
		std::string flightID;										
		int flightNo, planeNo;
		bool doneHere = false;
		planesData pdata;
		pdata.load("SIDCMission.state");
		for(int i = 0; i < attritedPlanes.getSize(); i++)	{
			doneHere = false;
			wholeID = attritedPlanes[i];
			currGroupID = attritedPlanes[i].substr(0, wholeID.length() - 2);
			std::string c = wholeID.substr(wholeID.length() - 2, 1);
			flightNo = std::stoi(c, &sz);
			std::string c1 = wholeID.substr(wholeID.length() - 1, 1);
			planeNo = std::stoi(c1, &sz);
			pattern pat("SIDCMission.state");
			for(int ii = 0; ii < pat.uniqueid.getSize(); ii++)	{
				if(pat.uniqueid[ii].find(currGroupID) != -1 && pat.start[ii] && !pat.single[ii] && pat.missionMis[pat.LineIndex[ii]].find("Way") == -1)
						for(int ji = pat.LineIndex[ii]; ji < pat.LineIndex[ii] + 5; ji++)	{
							flightID = "Flight" + std::to_string(flightNo);
							if(pat.missionMis[ji].find(flightID) != -1)	{
								sz = 2;
								flightLine = pat.missionMis[ji];
								for(int si = 0; si <= planeNo; si++)
									sz = flightLine.find(' ', sz + 1);
								flightLine = flightLine.substr(sz + 1);
								sz = flightLine.find(' ');
								currTacticalNo = flightLine.substr(0, sz);
								doneHere = true;
								break;		
							}
						}
				if(doneHere)
					break;
			}
			for(int j = 0; j < pdata.Airgroups.getSize(); j++)	{
				if(pdata.Airgroups[j].find(currGroupID) != -1)	{
					for(int k = 0; k <= pdata.flights[j].getflight0Limit(); k++)
						if(pdata.flights[j].flight0[k] == currTacticalNo)
							pdata.flights.mod(j)->flight0destroyed[k] = true;
					for(int k = 0; k <= pdata.flights[j].getflight1Limit(); k++)
						if(pdata.flights[j].flight1[k] == currTacticalNo)
							pdata.flights.mod(j)->flight1destroyed[k] = true;
					for(int k = 0; k <= pdata.flights[j].getflight2Limit(); k++)
						if(pdata.flights[j].flight2[k] == currTacticalNo)
							pdata.flights.mod(j)->flight2destroyed[k] = true;
					for(int k = 0; k <= pdata.flights[j].getflight3Limit(); k++)
						if(pdata.flights[j].flight3[k] == currTacticalNo)
							pdata.flights.mod(j)->flight3destroyed[k] = true;
				}
				if(!pdata.destroyed[j])
					pdata.setAirgroupDestroyed(j);
			}
		}
		pdata.save();
	}
}



position splitLine(const position& ppos1, const position& ppos2, const double pdistance)	{
	if(distance(ppos1, ppos2) <= pdistance)	{
		std::cout << "The distace sent to the function exceeds the distance between the positions sent!\n";
		return ppos2;
	}
	double L = pdistance / (distance(ppos1, ppos2) - pdistance);
	position result;
	result.positionX = (ppos1.positionX + L * ppos2.positionX) / (1 + L);
	result.positionY = (ppos1.positionY + L * ppos2.positionY) / (1 + L);
	double altDifference = ppos1.altitude - ppos2.altitude;
	result.altitude = ppos1.altitude - L * altDifference;
	return result;
}



double randAlt(double palt, double paltdiff)	{
	int alt = (int)palt;
	int altDiff = (int)paltdiff;
	int result;
	srand(int(1000));
	for(int i = 0; i < randGenCounter; i++)
		result = rand() % (2 * altDiff) + (alt - altDiff);
	randGenCounter++;
	return result;
}


int getRedFGroupNo(mainTables& pmt)	{
	int result = 0;
	if(pmt.fightersRed.getSize() == 0)
		return result;
	if(pmt.fightersRed.getSize() > 0)	{
		std::string groupName = pmt.fightersRed[0].groupname;
		result = 1;
		for(int i = 0; i < pmt.fightersRed.getSize(); i++)
			if(pmt.fightersRed[i].groupname != groupName)	{
				groupName = pmt.fightersRed[i].groupname;
				result++;
			}
	}
	return result;
}


int getBlueFGroupNo(mainTables& pmt)	{
	int result = 0;
	if(pmt.fightersBlue.getSize() == 0)
		return result;
	if(pmt.fightersBlue.getSize() > 0)	{
		std::string groupName = pmt.fightersBlue[0].groupname;
		result = 1;
		for(int i = 0; i < pmt.fightersBlue.getSize(); i++)
			if(pmt.fightersBlue[i].groupname != groupName)	{
				groupName = pmt.fightersBlue[i].groupname;
				result++;
			}
	}
	return result;
}


int getRedBGroupNo(mainTables& pmt)	{
	int result = 0;
	if(pmt.bombersRed.getSize() == 0)
		return result;
	if(pmt.bombersRed.getSize() > 0)	{
		std::string groupName = pmt.bombersRed[0].groupname;
		result = 1;
		for(int i = 0; i < pmt.bombersRed.getSize(); i++)
			if(pmt.bombersRed[i].groupname != groupName)	{
				groupName = pmt.bombersRed[i].groupname;
				result++;
			}
	}
	return result;
}



int getBlueBGroupNo(mainTables& pmt)	{
	int result = 0;
	if(pmt.bombersBlue.getSize() == 0)
		return result;
	if(pmt.bombersBlue.getSize() > 0)	{
		std::string groupName = pmt.bombersBlue[0].groupname;
		result = 1;
		for(int i = 0; i < pmt.bombersBlue.getSize(); i++)
			if(pmt.bombersBlue[i].groupname != groupName)	{
				groupName = pmt.bombersBlue[i].groupname;
				result++;
			}
	}
	return result;
}

int getRedJGroupNo(mainTables& pmt)	{
	int result = 0;
	if(pmt.jabosRed.getSize() == 0)
		return result;
	if(pmt.jabosRed.getSize() > 0)	{
		std::string groupName = pmt.jabosRed[0].groupname;
		result = 1;
		for(int i = 0; i < pmt.jabosRed.getSize(); i++)
			if(pmt.jabosRed[i].groupname != groupName)	{
				groupName = pmt.jabosRed[i].groupname;
				result++;
			}
	}
	return result;
}


int getBlueJGroupNo(mainTables& pmt)	{
	int result = 0;
	if(pmt.jabosBlue.getSize() == 0)
		return result;
	if(pmt.jabosBlue.getSize() > 0)	{
		std::string groupName = pmt.jabosBlue[0].groupname;
		result = 1;
		for(int i = 0; i < pmt.jabosBlue.getSize(); i++)
			if(pmt.jabosBlue[i].groupname != groupName)	{
				groupName = pmt.jabosBlue[i].groupname;
				result++;
			}
	}
	return result;
}



void planMissions(mainTables& pmt, pilotLog& pplog)	{
	int nextGroupIndex;																			
	int previousGroupIndex;																		
	int briefingIDNo = 1;																		
	std::string currGroupName;
	if(pmt.bombersRed.getSize() > 0)	{
		currGroupName = pmt.bombersRed[0].groupname;
		nextGroupIndex = 0;
		previousGroupIndex = 0;
		while(nextGroupIndex < pmt.bombersRed.getSize())	{
			previousGroupIndex = nextGroupIndex;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.radarsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.radarsBlue.getSize(); j++)	{
					std::string currStaticID = pmt.radarsBlue[0].staticid;
					int currTokenOfAttention = pmt.radarsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.radarsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.radarsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{			
							currStaticID = pmt.radarsBlue[k].staticid;	
							currTokenOfAttention = pmt.radarsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)
						if((pmt.radarsBlue[k].staticid == currStaticID) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.radarsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " The target for this mission is a " + pmt.radarsBlue[k].classid + ", which is situated at grid " + removeUnderscores(pmt.radarsBlue[k].grid) + ", near " + pmt.radarsBlue[k].gridname + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersRed[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersRed[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.radarsBlue[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.radarsBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.radarsBlue.mod(k)->tokenOfAttention + 1;
							pmt.radarsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																				
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())														
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())														
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.airfieldTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.airfieldTargetsBlue.getSize(); j++)	{
					seArray<airfieldTarget> LAFields;														
					std::string currAFName = pmt.airfieldTargetsBlue[0].name;
					int currTokenOfAttention = pmt.airfieldTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.airfieldTargetsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsBlue[k].airfieldPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{		
							currTokenOfAttention = pmt.airfieldTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)	
						if(pmt.airfieldTargetsBlue[k].tokenOfAttention == currTokenOfAttention)
							LAFields.add(pmt.airfieldTargetsBlue[k]);
					double closestABDistance = distance(LAFields[0].airfieldPosit, pmt.bombersRed[nextGroupIndex].wayPoints[0]);
					for(int k = 1; k < LAFields.getSize(); k++)															
						if(closestABDistance > distance(LAFields[k].airfieldPosit, pmt.bombersRed[nextGroupIndex].wayPoints[0]))
							currAFName = LAFields[k].name;
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)
						if((pmt.airfieldTargetsBlue[k].name == currAFName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsBlue[k].airfieldPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " You are to deliver a package to an enemy " + pmt.airfieldTargetsBlue[k].classid + ", " + pmt.airfieldTargetsBlue[k].name + ", situated at grid " + removeUnderscores(pmt.airfieldTargetsBlue[k].grid) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersRed[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersRed[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.airfieldTargetsBlue[k].airfieldPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.airfieldTargetsBlue[k].airfieldPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.airfieldTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.airfieldTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																				
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())														
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())														
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.factoryTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.factoryTargetsBlue.getSize(); j++)	{
					std::string currFName = pmt.factoryTargetsBlue[0].name;
					int currTokenOfAttention = pmt.factoryTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.factoryTargetsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.factoryTargetsBlue[k].factoryPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{			
							currFName = pmt.factoryTargetsBlue[k].name;	
							currTokenOfAttention = pmt.factoryTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)
						if((pmt.factoryTargetsBlue[k].name == currFName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.factoryTargetsBlue[k].factoryPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " This time, You will blow up the " + pmt.factoryTargetsBlue[k].name + ' ' + pmt.factoryTargetsBlue[k].classid + ", at grid " + removeUnderscores(pmt.factoryTargetsBlue[k].grid) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersRed[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersRed[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.factoryTargetsBlue[k].factoryPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.factoryTargetsBlue[k].factoryPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.factoryTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.factoryTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																				
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())														
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())														
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.subcontractorTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.subcontractorTargetsBlue.getSize(); j++)	{
					std::string currSName = pmt.subcontractorTargetsBlue[0].name;
					int currTokenOfAttention = pmt.subcontractorTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.subcontractorTargetsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.subcontractorTargetsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsBlue[k].subcontractorPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{			
							currSName = pmt.subcontractorTargetsBlue[k].name;	
							currTokenOfAttention = pmt.subcontractorTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.subcontractorTargetsBlue.getSize(); k++)
						if((pmt.subcontractorTargetsBlue[k].name == currSName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsBlue[k].subcontractorPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " The " + pmt.subcontractorTargetsBlue[k].name + " workshop is producing material for the enemy. Your mission is to put an end to such activities." + "You will find the target at grid " + removeUnderscores(pmt.subcontractorTargetsBlue[k].grid) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersRed[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersRed[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.subcontractorTargetsBlue[k].subcontractorPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.subcontractorTargetsBlue[k].subcontractorPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.subcontractorTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.subcontractorTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																				
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())														
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())														
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.portTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.portTargetsBlue.getSize(); j++)	{
					std::string currPName = pmt.portTargetsBlue[0].name;
					int currTokenOfAttention = pmt.portTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.portTargetsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.portTargetsBlue[k].portPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{		
							currPName = pmt.portTargetsBlue[k].name;	
							currTokenOfAttention = pmt.portTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)
						if((pmt.portTargetsBlue[k].name == currPName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.portTargetsBlue[k].portPosit) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " The target for this mission is a " + pmt.portTargetsBlue[k].classid + " at " + pmt.portTargetsBlue[k].name + ", which is situated at grid " + removeUnderscores(pmt.portTargetsBlue[k].grid) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersRed[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersRed[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.portTargetsBlue[k].portPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.portTargetsBlue[k].portPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.portTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.portTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																				
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())													
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())														
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.tanksBlue.getSize() > 0)	
				for(int j = 0; j < pmt.tanksBlue.getSize(); j++)	{
					bool CASCondition = false;
					std::string currCName = pmt.tanksBlue[0].chiefname;
					int currTokenOfAttention = pmt.tanksBlue[0].tokenOfAttention;
					int friendlyIndex = 0;
					bool isTank = false;
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.tanksBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{		
							currCName = pmt.tanksBlue[k].chiefname;	
							currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;
						}
					for(int kkk = 0; kkk < pmt.tanksBlue.getSize(); kkk++)						
						if(currCName == pmt.tanksBlue[kkk].chiefname)	{
							for(int kk = 0; kk < pmt.tanksRed.getSize(); kk++)
								if(distance(pmt.tanksBlue[kkk].makePosit(), pmt.tanksRed[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									isTank = true;
									break;
								}
							for(int kk = 0; kk < pmt.gunsRed.getSize(); kk++)
								if(distance(pmt.tanksBlue[kkk].makePosit(), pmt.gunsRed[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									break;
								}
							break;
						}
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((pmt.tanksBlue[k].chiefname == currCName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available && CASCondition)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAS";
							if(isTank)
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from our base at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " Our troops at grid " + removeUnderscores(grid(pmt.tanksRed[friendlyIndex].makePosit(), "SIDCMission.state")) + " are in contact with the enemy and have requested air support. You are to target enemy tanks which are moving from grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksBlue[k].chiefPath.wpoints[pmt.tanksBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							if(!isTank)
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from our base at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " Our troops at grid " + removeUnderscores(grid(pmt.gunsRed[friendlyIndex].makePosit(), "SIDCMission.state")) + " are in contact with the enemy and have requested air support. You are to target enemy tanks which are moving from grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksBlue[k].chiefPath.wpoints[pmt.tanksBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit(), distance(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[5], pmt.tanksBlue[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksBlue[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksBlue.mod(k)->tokenOfAttention + 1;
							pmt.tanksBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																			
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())													
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())														
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.tanksBlue.getSize() > 0)	
				for(int j = 0; j < pmt.tanksBlue.getSize(); j++)	{
					std::string currCName = pmt.tanksBlue[0].chiefname;
					int currTokenOfAttention = pmt.tanksBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.tanksBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{			
							currCName = pmt.tanksBlue[k].chiefname;	
							currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((pmt.tanksBlue[k].chiefname == currCName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airbase at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " Enemy tanks are on the move and the orders have arrived to attack them befroe they reach their destination. The tanks are moving from grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksBlue[k].chiefPath.wpoints[pmt.tanksBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit(), distance(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[5], pmt.tanksBlue[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksBlue[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksBlue.mod(k)->tokenOfAttention + 1;
							pmt.tanksBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																				
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())														
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())													
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{									
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.gunsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.gunsBlue.getSize(); j++)	{
					std::string currStaticID = pmt.gunsBlue[0].staticid;
					int currTokenOfAttention = pmt.gunsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.gunsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.gunsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.gunsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{		
							currStaticID = pmt.gunsBlue[k].staticid;	
							currTokenOfAttention = pmt.gunsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.gunsBlue.getSize(); k++)
						if((pmt.gunsBlue[k].staticid == currStaticID) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.gunsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the frienfly airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " This time, You are to smash enemy " + pmt.gunsBlue[k].classid + ", situated at grid " + removeUnderscores(pmt.gunsBlue[k].grid) + ", near " + pmt.gunsBlue[k].gridname + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersRed[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersRed[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.gunsBlue[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.gunsBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.gunsBlue.mod(k)->tokenOfAttention + 1;
							pmt.gunsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																			
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())												
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())												
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{								
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.vehiclesctBlue.getSize() > 0)	
				for(int j = 0; j < pmt.vehiclesctBlue.getSize(); j++)	{
					std::string currCName = pmt.vehiclesctBlue[0].chiefname;
					int currTokenOfAttention = pmt.vehiclesctBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.vehiclesctBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.vehiclesctBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.vehiclesctBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{		
							currCName = pmt.vehiclesctBlue[k].chiefname;	
							currTokenOfAttention = pmt.vehiclesctBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.vehiclesctBlue.getSize(); k++)
						if((pmt.vehiclesctBlue[k].chiefname == currCName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.vehiclesctBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". An enemy vehicle column is transporting important products and the orders have arrived to destroy it. Intelligence suggests that it will be moving from grid " + removeUnderscores(grid(pmt.vehiclesctBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.vehiclesctBlue[k].chiefPath.wpoints[pmt.vehiclesctBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.vehiclesctBlue[k].makePosit(), distance(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.vehiclesctBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[5], pmt.vehiclesctBlue[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.vehiclesctBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.vehiclesctBlue[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.vehiclesctBlue.mod(k)->tokenOfAttention + 1;
							pmt.vehiclesctBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																		
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())												
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{									
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.shipsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.shipsBlue.getSize(); j++)	{
					std::string currCName = pmt.shipsBlue[0].chiefname;
					int currTokenOfAttention = pmt.shipsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.shipsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.shipsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{		
							currCName = pmt.shipsBlue[k].chiefname;	
							currTokenOfAttention = pmt.shipsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)
						if((pmt.shipsBlue[k].chiefname == currCName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.shipsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: ANTI SHIP";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " Enemy ships are the target of this mission. They will be moving from grid " + removeUnderscores(grid(pmt.shipsBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.shipsBlue[k].chiefPath.wpoints[pmt.shipsBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.shipsBlue[k].makePosit(), distance(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.shipsBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[5], pmt.shipsBlue[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.shipsBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.shipsBlue[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.shipsBlue.mod(k)->tokenOfAttention + 1;
							pmt.shipsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																			
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())												
						break;
				}
			if(nextGroupIndex == pmt.bombersRed.getSize())												
				break;
			if(!pmt.bombersRed[nextGroupIndex].available)	{								
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.trainsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.trainsBlue.getSize(); j++)	{
					std::string currCName = pmt.trainsBlue[0].chiefname;
					int currTokenOfAttention = pmt.trainsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.trainsBlue.getSize(); k++)
						if((currTokenOfAttention >= pmt.trainsBlue[k].tokenOfAttention) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.trainsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius))	{			// Finding the train within the action radius of the bomber which got the least attention...
							currCName = pmt.trainsBlue[k].chiefname;	
							currTokenOfAttention = pmt.trainsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.trainsBlue.getSize(); k++)
						if((pmt.trainsBlue[k].chiefname == currCName) && (distance(pmt.bombersRed[nextGroupIndex].wayPoints[0], pmt.trainsBlue[k].makePosit()) < 0.9 * pmt.bombersRed[nextGroupIndex].actionRadius) && pmt.bombersRed[nextGroupIndex].available)	{
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.bombersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.' + " An enemy train is to be attacked this time. You will find it moving from grid " + removeUnderscores(grid(pmt.trainsBlue[k].makePosit(), "SIDCMission.state")) + " to grid: " + removeUnderscores(grid(pmt.trainsBlue[k].chiefPath.wpoints[pmt.trainsBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.trainsBlue[k].makePosit(), distance(pmt.bombersRed[nextGroupIndex].wayPoints[4], pmt.trainsBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersRed[nextGroupIndex].wayPoints[5], pmt.trainsBlue[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.trainsBlue[k].makePosit();
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.trainsBlue[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersRed[nextGroupIndex].wayPoints[5];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersRed.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersRed[nextGroupIndex].wayPoints[0];
							pmt.bombersRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.trainsBlue.mod(k)->tokenOfAttention + 1;
							pmt.trainsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersRed.getSize() - 1)
										pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.bombersRed.getSize() - 1)	{
										if(pmt.bombersRed[nextGroupIndex].groupname != pmt.bombersRed[nextGroupIndex + 1].groupname)
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersRed[jj].groupname)	{
										if(pmt.bombersRed.getSize() - 1 > jj)
											currGroupName = pmt.bombersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																			
						}
					if(nextGroupIndex == pmt.bombersRed.getSize())													
						break;
				}
			if(!pmt.bombersRed[nextGroupIndex].available)	{										
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(previousGroupIndex == nextGroupIndex)	{															
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: FREE FLIGHT";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[1] = "Either Your squadron is too far from the zone of operations,";
				pmt.bombersRed.mod(nextGroupIndex)->briefingLines[2] = "or the end of the war is drawing near. Enjoy a free flight.";
				pmt.bombersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersRed[jj].groupname)	{
						if(pmt.bombersRed.getSize() - 1 > jj)
							currGroupName = pmt.bombersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
								break;
					}
			}
			if(nextGroupIndex == pmt.bombersRed.getSize() || nextGroupIndex == 0)												
				break;
		}
	}
	if(pmt.bombersBlue.getSize() > 0)	{
		currGroupName = pmt.bombersBlue[0].groupname;
		nextGroupIndex = 0;
		previousGroupIndex = 0;
		while(nextGroupIndex < pmt.bombersBlue.getSize())	{
			previousGroupIndex = nextGroupIndex;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{									
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.radarsRed.getSize() > 0)	
				for(int j = 0; j < pmt.radarsRed.getSize(); j++)	{
					std::string currStaticID = pmt.radarsRed[0].staticid;
					int currTokenOfAttention = pmt.radarsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.radarsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.radarsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currStaticID = pmt.radarsRed[k].staticid;	
							currTokenOfAttention = pmt.radarsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)	{
						if((pmt.radarsRed[k].staticid == currStaticID) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.radarsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". The target for today is a " + pmt.radarsRed[k].classid + ", situated near " + pmt.radarsRed[k].gridname + " at grid " + removeUnderscores(pmt.radarsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersBlue[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersBlue[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.radarsRed[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.radarsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.radarsRed.mod(k)->tokenOfAttention + 1;
							pmt.radarsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																			
						}
						if((pmt.radarsRed[k].staticid == currStaticID) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.radarsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{					
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from our base at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". The target for today is a " + pmt.radarsRed[k].classid + ", situated near " + pmt.radarsRed[k].gridname + " at grid " + removeUnderscores(pmt.radarsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.radarsRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.radarsRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.radarsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.radarsRed[k].staticid + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.radarsRed.mod(k)->tokenOfAttention + 1;
							pmt.radarsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																		
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())										
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{								
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.airfieldTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.airfieldTargetsRed.getSize(); j++)	{
					seArray<airfieldTarget> LAFields;									
					std::string currAFName = pmt.airfieldTargetsRed[0].name;
					int currTokenOfAttention = pmt.airfieldTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.airfieldTargetsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsRed[k].airfieldPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currTokenOfAttention = pmt.airfieldTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)	
						if(pmt.airfieldTargetsRed[k].tokenOfAttention == currTokenOfAttention)
							LAFields.add(pmt.airfieldTargetsRed[k]);
					double closestABDistance = distance(LAFields[0].airfieldPosit, pmt.bombersBlue[nextGroupIndex].wayPoints[0]);
					for(int k = 1; k < LAFields.getSize(); k++)									
						if(closestABDistance > distance(LAFields[k].airfieldPosit, pmt.bombersBlue[nextGroupIndex].wayPoints[0]))
							currAFName = LAFields[k].name;
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)	{
						if((pmt.airfieldTargetsRed[k].name == currAFName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsRed[k].airfieldPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to take off from our base at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Your target for this mission is " + pmt.airfieldTargetsRed[k].name + ", situated at grid " + removeUnderscores(pmt.airfieldTargetsRed[k].grid) + ". We have to take this " + pmt.airfieldTargetsRed[k].classid + " out!";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersBlue[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersBlue[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.airfieldTargetsRed[k].airfieldPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.airfieldTargetsRed[k].airfieldPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.airfieldTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.airfieldTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
						if((pmt.airfieldTargetsRed[k].name == currAFName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsRed[k].airfieldPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to take off from our base at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Your target for this mission is " + pmt.airfieldTargetsRed[k].name + ", situated at grid " + removeUnderscores(pmt.airfieldTargetsRed[k].grid) + ". We have to take this " + pmt.airfieldTargetsRed[k].classid + " out!";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.airfieldTargetsRed[k].airfieldPosit, 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.airfieldTargetsRed[k].airfieldPosit, 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.airfieldTargetsRed[k].airfieldPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.airfieldTargetsRed[k].getTractorID(currAFName) + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.airfieldTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.airfieldTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())				
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())			
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{		
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.factoryTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.factoryTargetsRed.getSize(); j++)	{
					std::string currFName = pmt.factoryTargetsRed[0].name;
					int currTokenOfAttention = pmt.factoryTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.factoryTargetsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.factoryTargetsRed[k].factoryPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{
							currFName = pmt.factoryTargetsRed[k].name;	
							currTokenOfAttention = pmt.factoryTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)	{
						if((pmt.factoryTargetsRed[k].name == currFName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.factoryTargetsRed[k].factoryPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Today, You will be bombing the " + pmt.factoryTargetsRed[k].name + ' ' + pmt.factoryTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.factoryTargetsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersBlue[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersBlue[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.factoryTargetsRed[k].factoryPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.factoryTargetsRed[k].factoryPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.factoryTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.factoryTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;													
						}
						if((pmt.factoryTargetsRed[k].name == currFName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.factoryTargetsRed[k].factoryPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{	
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from our base at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Today, You will be bombing the " + pmt.factoryTargetsRed[k].name + ' ' + pmt.factoryTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.factoryTargetsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.factoryTargetsRed[k].factoryPosit, 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.factoryTargetsRed[k].factoryPosit, 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.factoryTargetsRed[k].factoryPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.factoryTargetsRed[k].getBicycleID(currFName) + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.factoryTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.factoryTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;										
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())						
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())							
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{				
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.subcontractorTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.subcontractorTargetsRed.getSize(); j++)	{
					std::string currSName = pmt.subcontractorTargetsRed[0].name;
					int currTokenOfAttention = pmt.subcontractorTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.subcontractorTargetsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.subcontractorTargetsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsRed[k].subcontractorPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{		
							currSName = pmt.subcontractorTargetsRed[k].name;	
							currTokenOfAttention = pmt.subcontractorTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.subcontractorTargetsRed.getSize(); k++)	{
						if((pmt.subcontractorTargetsRed[k].name == currSName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsRed[k].subcontractorPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake of from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Today, You will be bombing the " + pmt.subcontractorTargetsRed[k].name + ' ' + pmt.subcontractorTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.subcontractorTargetsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersBlue[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersBlue[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.subcontractorTargetsRed[k].subcontractorPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.subcontractorTargetsRed[k].subcontractorPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.subcontractorTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.subcontractorTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
						if((pmt.subcontractorTargetsRed[k].name == currSName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsRed[k].subcontractorPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Today, You will be bombing the " + pmt.subcontractorTargetsRed[k].name + ' ' + pmt.subcontractorTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.subcontractorTargetsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.subcontractorTargetsRed[k].subcontractorPosit, 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.subcontractorTargetsRed[k].subcontractorPosit, 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.subcontractorTargetsRed[k].subcontractorPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.subcontractorTargetsRed[k].getBicycleID(currSName) + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.subcontractorTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.subcontractorTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																	
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())										
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{						
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.portTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.portTargetsRed.getSize(); j++)	{
					std::string currPName = pmt.portTargetsRed[0].name;
					int currTokenOfAttention = pmt.portTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.portTargetsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.portTargetsRed[k].portPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{
							currPName = pmt.portTargetsRed[k].name;	
							currTokenOfAttention = pmt.portTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)	{
						if((pmt.portTargetsRed[k].name == currPName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.portTargetsRed[k].portPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack the " + pmt.portTargetsRed[k].name + ' ' + pmt.portTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.portTargetsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersBlue[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersBlue[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.portTargetsRed[k].portPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.portTargetsRed[k].portPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.portTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.portTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;													
						}
						if((pmt.portTargetsRed[k].name == currPName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.portTargetsRed[k].portPosit) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack the " + pmt.portTargetsRed[k].name + ' ' + pmt.portTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.portTargetsRed[k].grid) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.portTargetsRed[k].portPosit, 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.portTargetsRed[k].portPosit, 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.portTargetsRed[k].portPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.portTargetsRed[k].getTractorID(currPName) + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.portTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.portTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																		
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())											
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{					
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.tanksRed.getSize() > 0)	
				for(int j = 0; j < pmt.tanksRed.getSize(); j++)	{
					bool CASCondition = false;
					std::string currCName = pmt.tanksRed[0].chiefname;
					int currTokenOfAttention = pmt.tanksRed[0].tokenOfAttention;
					int friendlyIndex = 0;
					bool isTank = false;
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.tanksRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currCName = pmt.tanksRed[k].chiefname;	
							currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;
						}
					for(int kkk = 0; kkk < pmt.tanksRed.getSize(); kkk++)					
						if(currCName == pmt.tanksRed[kkk].chiefname)	{
							for(int kk = 0; kk < pmt.tanksBlue.getSize(); kk++)
								if(distance(pmt.tanksRed[kkk].makePosit(), pmt.tanksBlue[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									isTank = true;
									break;
								}
							for(int kk = 0; kk < pmt.gunsBlue.getSize(); kk++)
								if(distance(pmt.tanksRed[kkk].makePosit(), pmt.gunsBlue[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									break;
								}
							break;
						}
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)	{
						if((pmt.tanksRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && CASCondition && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAS";
							if(isTank)
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Our troops at grid " + removeUnderscores(grid(pmt.tanksBlue[friendlyIndex].makePosit(), "SIDCMission.state")) + " are in close contact with enemy armor and are requesting air support. The enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							if(!isTank)
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Our troops at grid " + removeUnderscores(grid(pmt.gunsBlue[friendlyIndex].makePosit(), "SIDCMission.state")) + " are in close contact with enemy armor and are requesting air support. The enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit(), distance(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.tanksRed[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksRed[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksRed.mod(k)->tokenOfAttention + 1;
							pmt.tanksRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																	
						}
						if((pmt.tanksRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && CASCondition && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{				
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAS";
							if(isTank)
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Our troops at grid " + removeUnderscores(grid(pmt.tanksBlue[friendlyIndex].makePosit(), "SIDCMission.state")) + " are in close contact with enemy armor and are requesting air support. The enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							if(!isTank)
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Our troops at grid " + removeUnderscores(grid(pmt.gunsBlue[friendlyIndex].makePosit(), "SIDCMission.state")) + " are in close contact with enemy armor and are requesting air support. The enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.tanksRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksRed[k].chiefname + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksRed.mod(k)->tokenOfAttention + 1;
							pmt.tanksRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}	
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())							
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{					
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.tanksRed.getSize() > 0)	
				for(int j = 0; j < pmt.tanksRed.getSize(); j++)	{
					std::string currCName = pmt.tanksRed[0].chiefname;
					int currTokenOfAttention = pmt.tanksRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.tanksRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currCName = pmt.tanksRed[k].chiefname;	
							currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)	{
						if((pmt.tanksRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". There\' s an ememy armored columns we\' d like to attrit before it reaches it\' s destination. You will find it moving from grid" + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit(), distance(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.tanksRed[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksRed[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksRed.mod(k)->tokenOfAttention + 1;
							pmt.tanksRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																			
						}
						if((pmt.tanksRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". There\' s an ememy armored columns we\' d like to attrit before it reaches it\' s destination. You will find it moving from grid" + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "Target type: " + pmt.tanksRed[k].classid;
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "Target path start grid: " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "Target path end grid: " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.tanksRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksRed[k].chiefname + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksRed.mod(k)->tokenOfAttention + 1;
							pmt.tanksRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;											
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())			
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())					
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{				
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.gunsRed.getSize() > 0)	
				for(int j = 0; j < pmt.gunsRed.getSize(); j++)	{
					std::string currStaticID = pmt.gunsRed[0].staticid;
					int currTokenOfAttention = pmt.gunsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.gunsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.gunsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currStaticID = pmt.gunsRed[k].staticid;	
							currTokenOfAttention = pmt.gunsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.gunsRed.getSize(); k++)	{
						if((pmt.gunsRed[k].staticid == currStaticID) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{	
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from the airfield at grid: " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack " + pmt.gunsRed[k].classid + ", near " + removeUnderscores(pmt.gunsRed[k].gridname) + ", at grid " + removeUnderscores(pmt.gunsRed[k].grid);
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = randAlt(pmt.bombersBlue[nextGroupIndex].serviceCeiling * 0.7, 0.2 * pmt.bombersBlue[nextGroupIndex].serviceCeiling);
							position flightAltPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.gunsRed[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.gunsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.gunsRed.mod(k)->tokenOfAttention + 1;
							pmt.gunsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt)) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
						if((pmt.gunsRed[k].staticid == currStaticID) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[k].makePosit()) < (0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius)) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{			
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nHome base is at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Your task is to attack enemy artillery. You will find Your target near " + removeUnderscores(pmt.gunsRed[k].gridname) + ", at grid " + removeUnderscores(grid(pmt.gunsRed[k].makePosit(), "SIDCMission.state")) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.gunsRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.gunsRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.gunsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.gunsRed[k].staticid + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.gunsRed.mod(k)->tokenOfAttention + 1;
							pmt.gunsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())										
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{				
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.vehiclesctRed.getSize() > 0)	
				for(int j = 0; j < pmt.vehiclesctRed.getSize(); j++)	{
					std::string currCName = pmt.vehiclesctRed[0].chiefname;
					int currTokenOfAttention = pmt.vehiclesctRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.vehiclesctRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.vehiclesctRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.vehiclesctRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{		
							currCName = pmt.vehiclesctRed[k].chiefname;	
							currTokenOfAttention = pmt.vehiclesctRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.vehiclesctRed.getSize(); k++)	{
						if((pmt.vehiclesctRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.vehiclesctRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfiled at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". An enemy column is on the move and the orders have arrived to destroy it. You will find it moving from grid " + removeUnderscores(grid(pmt.vehiclesctRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.vehiclesctRed[k].chiefPath.wpoints[pmt.vehiclesctRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.vehiclesctRed[k].makePosit(), distance(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.vehiclesctRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.vehiclesctRed[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.vehiclesctRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.vehiclesctRed[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.vehiclesctRed.mod(k)->tokenOfAttention + 1;
							pmt.vehiclesctRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																	
						}
						if((pmt.vehiclesctRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.vehiclesctRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfiled at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". An enemy column is on the move and the orders have arrived to destroy it. You will find it moving from grid " + removeUnderscores(grid(pmt.vehiclesctRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.vehiclesctRed[k].chiefPath.wpoints[pmt.vehiclesctRed[k].chiefPath.getLimit()], "SIDCMission.state"));
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.vehiclesctRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.vehiclesctRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.vehiclesctRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.vehiclesctRed[k].chiefname + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.vehiclesctRed.mod(k)->tokenOfAttention + 1;
							pmt.vehiclesctRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())						
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())					
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{		
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.shipsRed.getSize() > 0)	
				for(int j = 0; j < pmt.shipsRed.getSize(); j++)	{
					std::string currCName = pmt.shipsRed[0].chiefname;
					int currTokenOfAttention = pmt.shipsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.shipsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.shipsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currCName = pmt.shipsRed[k].chiefname;	
							currTokenOfAttention = pmt.shipsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)	{
						if((pmt.shipsRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.shipsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: ANTI SHIP";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from the airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". You will be attacking enemy ships moving from grid " + removeUnderscores(grid(pmt.shipsRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.shipsRed[k].chiefPath.wpoints[pmt.shipsRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.shipsRed[k].makePosit(), distance(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.shipsRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.shipsRed[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.shipsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.shipsRed[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.shipsRed.mod(k)->tokenOfAttention + 1;
							pmt.shipsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;												
						}
						if((pmt.shipsRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.shipsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: ANTI SHIP";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from the airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". You will be attacking enemy ships moving from grid " + removeUnderscores(grid(pmt.shipsRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.shipsRed[k].chiefPath.wpoints[pmt.shipsRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.shipsRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.shipsRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.shipsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.shipsRed[k].chiefname + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.shipsRed.mod(k)->tokenOfAttention + 1;
							pmt.shipsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;														
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())						
						break;
				}
			if(nextGroupIndex == pmt.bombersBlue.getSize())						
				break;
			if(!pmt.bombersBlue[nextGroupIndex].available)	{		
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.trainsRed.getSize() > 0)	
				for(int j = 0; j < pmt.trainsRed.getSize(); j++)	{
					std::string currCName = pmt.trainsRed[0].chiefname;
					int currTokenOfAttention = pmt.trainsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.trainsRed.getSize(); k++)
						if((currTokenOfAttention >= pmt.trainsRed[k].tokenOfAttention) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.trainsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius))	{	
							currCName = pmt.trainsRed[k].chiefname;	
							currTokenOfAttention = pmt.trainsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.trainsRed.getSize(); k++)	{
						if((pmt.trainsRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.trainsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") == -1))	{
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from the airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Your target for today is a train. You will find it moving from grid " + removeUnderscores(grid(pmt.trainsRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.trainsRed[k].chiefPath.wpoints[pmt.trainsRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.trainsRed[k].makePosit(), distance(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.trainsRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.trainsRed[k].makePosit(), 4000);
							initialPosit.altitude = 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.trainsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.trainsRed[k].chiefname + ' ' + "1 /GAttackType SHALLOW_DIVE";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.trainsRed.mod(k)->tokenOfAttention + 1;
							pmt.trainsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;											
						}
						if((pmt.trainsRed[k].chiefname == currCName) && (distance(pmt.bombersBlue[nextGroupIndex].wayPoints[0], pmt.trainsRed[k].makePosit()) < 0.9 * pmt.bombersBlue[nextGroupIndex].actionRadius) && pmt.bombersBlue[nextGroupIndex].available && (pmt.bombersBlue[nextGroupIndex].type.find("Ju-87") != -1))	{		
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from the airfield at grid " + removeUnderscores(grid(pmt.bombersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Your target for today is a train. You will find it moving from grid " + removeUnderscores(grid(pmt.trainsRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.trainsRed[k].chiefPath.wpoints[pmt.trainsRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.bombersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[4], pmt.trainsRed[k].makePosit(), 10000);
							ingressPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							position initialPosit = splitLine(pmt.bombersBlue[nextGroupIndex].wayPoints[5], pmt.trainsRed[k].makePosit(), 2000);
							initialPosit.altitude = 4000;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.trainsRed[k].makePosit();
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.bombersBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.trainsRed[k].chiefname + ' ' + "0 /GAttackType DIVE /GAttackPasses ALL_OUT";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.bombersBlue[nextGroupIndex].wayPoints[5];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[8] = "HUNTING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 350;
							pmt.bombersBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.bombersBlue[nextGroupIndex].wayPoints[0];
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.bombersBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.bombersBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.trainsRed.mod(k)->tokenOfAttention + 1;
							pmt.trainsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.bombersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.bombersBlue.getSize() - 1)
										pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
									if(nextGroupIndex < pmt.bombersBlue.getSize() - 1)	{
										if(pmt.bombersBlue[nextGroupIndex].groupname != pmt.bombersBlue[nextGroupIndex + 1].groupname)
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(4000) + " meters.";
										else
											pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(4000) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.bombersBlue[jj].groupname)	{
										if(pmt.bombersBlue.getSize() - 1 > jj)
											currGroupName = pmt.bombersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																	
						}
					}
					if(nextGroupIndex == pmt.bombersBlue.getSize())					
						break;
				}
			if(!pmt.bombersBlue[nextGroupIndex].available)	{			
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(previousGroupIndex == nextGroupIndex)	{							
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: FREE FLIGHT";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[1] = "Either Your squadron is too far from the zone of operations,";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingLines[2] = "or the end of the war is drawing near. Enjoy a free flight.";
				pmt.bombersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.bombersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.bombersBlue[jj].groupname)	{
						if(pmt.bombersBlue.getSize() - 1 > jj)
							currGroupName = pmt.bombersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
								break;
					}
			}
			if(nextGroupIndex == pmt.bombersBlue.getSize() || nextGroupIndex == 0)			
				break;
		}
	}
	if(pmt.jabosRed.getSize() > 0)	{
		currGroupName = pmt.jabosRed[0].groupname;
		nextGroupIndex = 0;
		previousGroupIndex = nextGroupIndex;
		while(nextGroupIndex < pmt.jabosRed.getSize())	{
			if(!pmt.jabosRed[nextGroupIndex].available)	{					
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.tanksBlue.getSize() > 0)	
				for(int j = 0; j < pmt.tanksBlue.getSize(); j++)	{
					bool CASCondition = false;
					std::string currCName = pmt.tanksBlue[0].chiefname;
					int currTokenOfAttention = pmt.tanksBlue[0].tokenOfAttention;
					int friendlyIndex = 0;
					bool isTank = false;
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.tanksBlue[k].tokenOfAttention)	{	
							currCName = pmt.tanksBlue[k].chiefname;	
							currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;
						}
					for(int kkk = 0; kkk < pmt.tanksBlue.getSize(); kkk++)					
						if(currCName == pmt.tanksBlue[kkk].chiefname)	{
							for(int kk = 0; kk < pmt.tanksRed.getSize(); kk++)
								if(distance(pmt.tanksBlue[kkk].makePosit(), pmt.tanksRed[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									isTank = true;
									break;
								}
							for(int kk = 0; kk < pmt.gunsRed.getSize(); kk++)
								if(distance(pmt.tanksBlue[kkk].makePosit(), pmt.gunsRed[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									break;
								}
							break;
						}
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((pmt.tanksBlue[k].chiefname == currCName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available && CASCondition)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAS";
							if(isTank)
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to take off from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and provide air support for our troops situated at grid " + removeUnderscores(grid(pmt.tanksRed[friendlyIndex].makePosit(), "SIDCMission.state")) + ", which are in close contact with the enemy. The enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksBlue[k].chiefPath.wpoints[pmt.tanksBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							if(!isTank)
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to take off from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and provide air support for our troops situated at grid " + removeUnderscores(grid(pmt.gunsRed[friendlyIndex].makePosit(), "SIDCMission.state")) + ", which are in close contact with the enemy. The enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksBlue[k].chiefPath.wpoints[pmt.tanksBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit(), distance(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[5], pmt.tanksBlue[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksBlue[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksBlue.mod(k)->tokenOfAttention + 1;
							pmt.tanksBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;														
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())								
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())								
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{							
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.tanksBlue.getSize() > 0)	
				for(int j = 0; j < pmt.tanksBlue.getSize(); j++)	{
					std::string currCName = pmt.tanksBlue[0].chiefname;
					int currTokenOfAttention = pmt.tanksBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if(currTokenOfAttention >= pmt.tanksBlue[k].tokenOfAttention)	{
							currCName = pmt.tanksBlue[k].chiefname;	
							currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;
							int currCVehiclesNo = 0;
							int nextCVehiclesNo = 0;
							if((k + 1) < pmt.tanksBlue.getSize())	{
								if(pmt.tanksBlue[k].chiefname != pmt.tanksBlue[k + 1].chiefname)	{
									for(int cvn = pmt.tanksBlue.getSize() - 1; cvn >= 0; cvn--)
										if(pmt.tanksBlue[cvn].chiefname == currCName)
											currCVehiclesNo++;
										std::string nextCName = pmt.tanksBlue[k + 1].chiefname;
										for(int nvn = pmt.tanksBlue.getSize() - 1; nvn >= 0; nvn--)
											if(pmt.tanksBlue[nvn].chiefname == nextCName)
												nextCVehiclesNo++;
								}
								if(currCVehiclesNo < nextCVehiclesNo)	{
									currCName = pmt.tanksBlue[k].chiefname;	
									currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;	
								}
							}
						}
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((pmt.tanksBlue[k].chiefname == currCName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from our base at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". An enemy armored column is moving from grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksBlue[k].chiefPath.wpoints[pmt.tanksBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + ". You are tasked with destroying this column before it reaches it\' s destination.";
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit(), distance(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.tanksBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[5], pmt.tanksBlue[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksBlue[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksBlue.mod(k)->tokenOfAttention + 1;
							pmt.tanksBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;												
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())				
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())						
				break;	
			if(!pmt.jabosRed[nextGroupIndex].available)	{					
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.gunsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.gunsBlue.getSize(); j++)	{
					std::string currStaticID = pmt.gunsBlue[0].staticid;
					int currTokenOfAttention = pmt.gunsBlue[0].tokenOfAttention;
					seArray<std::string, 30> gunsList;										
					for(int li = 0; li < pmt.radarsBlue.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsBlue.getSize(); lj++)
							if(distance(pmt.radarsBlue[li].makePosit(), pmt.gunsBlue[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsBlue[lj].staticid);
								break;
							}
					for(int li = 0; li < pmt.airfieldTargetsBlue.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsBlue.getSize(); lj++)
							if(distance(pmt.airfieldTargetsBlue[li].airfieldPosit, pmt.gunsBlue[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsBlue[lj].staticid);
								break;
							}
					for(int li = 0; li < pmt.factoryTargetsBlue.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsBlue.getSize(); lj++)
							if(distance(pmt.factoryTargetsBlue[li].factoryPosit, pmt.gunsBlue[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsBlue[lj].staticid);
								break;
							}
					for(int li = 0; li < pmt.subcontractorTargetsBlue.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsBlue.getSize(); lj++)
							if(distance(pmt.subcontractorTargetsBlue[li].subcontractorPosit, pmt.gunsBlue[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsBlue[lj].staticid);
								break;
							}
					if(gunsList.getSize() > 0)	{								
						double currDist;
						for(int si = 0; si < gunsList.getSize(); si++)	{			
							for(int sj = 0; sj < pmt.gunsBlue.getSize(); sj++)	
								if(gunsList[si] == pmt.gunsBlue[sj].staticid)	{
									currStaticID = pmt.gunsBlue[sj].staticid;
									currTokenOfAttention = pmt.gunsBlue[sj].tokenOfAttention;
									currDist = distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.gunsBlue[sj].makePosit());
									break;
								}
							break;
						}
						for(int si = 0; si < gunsList.getSize(); si++)				
							for(int sj = 0; sj < pmt.gunsBlue.getSize(); sj++)
								if(gunsList[si] == pmt.gunsBlue[sj].staticid)
									if(distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.gunsBlue[sj].makePosit()) < currDist)	{
										currStaticID = pmt.gunsBlue[sj].staticid;
										currTokenOfAttention = pmt.gunsBlue[sj].tokenOfAttention;
										currDist = distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.gunsBlue[sj].makePosit());
										break;
									}
					}
					if(gunsList.getSize() == 0)	{								
						for(int k = 0; k < pmt.gunsBlue.getSize(); k++)
							if(currTokenOfAttention > pmt.gunsBlue[k].tokenOfAttention)	{
								currStaticID = pmt.gunsBlue[k].staticid;	
								currTokenOfAttention = pmt.gunsBlue[k].tokenOfAttention;
							}
					}
					for(int k = 0; k < pmt.gunsBlue.getSize(); k++)
						if((pmt.gunsBlue[k].staticid == currStaticID) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.gunsBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							for(int abyz = 0; abyz < pmt.airfieldTargetsBlue.getSize(); abyz++)													
								if(distance(pmt.gunsBlue[k].makePosit(), pmt.airfieldTargetsBlue[abyz].airfieldPosit) < intZRadius)	{
									int tOa = pmt.airfieldTargetsBlue[abyz].tokenOfAttention;
									tOa++;
									pmt.airfieldTargetsBlue.mod(abyz)->tokenOfAttention = tOa;
									break;
								}
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to take off from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack enemy artillery. You will find Your target near " + removeUnderscores(pmt.gunsBlue[k].gridname) + ", at grid " + removeUnderscores(pmt.gunsBlue[k].grid) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.gunsBlue[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = pmt.gunsBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[6] = pmt.gunsBlue[k].staticid + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.gunsBlue.mod(k)->tokenOfAttention + 1;
							pmt.gunsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;														
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())									
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{					
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.vehiclesctBlue.getSize() > 0)	
				for(int j = 0; j < pmt.vehiclesctBlue.getSize(); j++)	{
					std::string currCName = pmt.vehiclesctBlue[0].chiefname;
					int currTokenOfAttention = pmt.vehiclesctBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.vehiclesctBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.vehiclesctBlue[k].tokenOfAttention)	{	
							currCName = pmt.vehiclesctBlue[k].chiefname;	
							currTokenOfAttention = pmt.vehiclesctBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.vehiclesctBlue.getSize(); k++)
						if((pmt.vehiclesctBlue[k].chiefname == currCName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.vehiclesctBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and attack an enemy vehicle column. The target will be moving from grid " + removeUnderscores(grid(pmt.vehiclesctBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.vehiclesctBlue[k].chiefPath.wpoints[pmt.vehiclesctBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.vehiclesctBlue[k].makePosit(), distance(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.vehiclesctBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[5], pmt.vehiclesctBlue[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.vehiclesctBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.vehiclesctBlue[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.vehiclesctBlue.mod(k)->tokenOfAttention + 1;
							pmt.vehiclesctBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())								
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())								
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{						
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.shipsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.shipsBlue.getSize(); j++)	{
					std::string currCName = pmt.shipsBlue[0].chiefname;
					int currTokenOfAttention = pmt.shipsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.shipsBlue[k].tokenOfAttention)	{	
							currCName = pmt.shipsBlue[k].chiefname;	
							currTokenOfAttention = pmt.shipsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)
						if((pmt.shipsBlue[k].chiefname == currCName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.shipsBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: ANTI SHIP";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nThis is an anti ship mission. Take off from our airfield at grid" + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and attack the target. You will find the target moving from grid " + removeUnderscores(grid(pmt.shipsBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.shipsBlue[k].chiefPath.wpoints[pmt.shipsBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.shipsBlue[k].makePosit(), distance(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.shipsBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[5], pmt.shipsBlue[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.shipsBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.shipsBlue[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.shipsBlue.mod(k)->tokenOfAttention + 1;
							pmt.shipsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;														
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())					
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())							
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{					
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.trainsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.trainsBlue.getSize(); j++)	{
					std::string currCName = pmt.trainsBlue[0].chiefname;
					int currTokenOfAttention = pmt.trainsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.trainsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.trainsBlue[k].tokenOfAttention)	{	
							currCName = pmt.trainsBlue[k].chiefname;	
							currTokenOfAttention = pmt.trainsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.trainsBlue.getSize(); k++)
						if((pmt.trainsBlue[k].chiefname == currCName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.trainsBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTako of from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", find the train moving from grid " + removeUnderscores(grid(pmt.trainsBlue[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.trainsBlue[k].chiefPath.wpoints[pmt.trainsBlue[k].chiefPath.getLimit()], "SIDCMission.state")) + ", and destroy it.";
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.trainsBlue[k].makePosit(), distance(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.trainsBlue[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[5], pmt.trainsBlue[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.trainsBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[7] = pmt.trainsBlue[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.trainsBlue.mod(k)->tokenOfAttention + 1;
							pmt.trainsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())							
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())								
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{						
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.radarsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.radarsBlue.getSize(); j++)	{
					std::string currStaticID = pmt.radarsBlue[0].staticid;
					int currTokenOfAttention = pmt.radarsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.radarsBlue[k].tokenOfAttention)	{	
							currStaticID = pmt.radarsBlue[k].staticid;	
							currTokenOfAttention = pmt.radarsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)
						if((pmt.radarsBlue[k].staticid == currStaticID) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.radarsBlue[k].makePosit()) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and You will attack a " + pmt.radarsBlue[k].classid + " near " + removeUnderscores(pmt.radarsBlue[k].gridname) + ", at grid " + removeUnderscores(pmt.radarsBlue[k].grid) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.radarsBlue[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = pmt.radarsBlue[k].makePosit();
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_TARG";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointActions[6] = pmt.radarsBlue[k].staticid + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.radarsBlue.mod(k)->tokenOfAttention + 1;
							pmt.radarsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())				
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{		
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.airfieldTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.airfieldTargetsBlue.getSize(); j++)	{
					std::string currAFName = pmt.airfieldTargetsBlue[0].name;
					int currTokenOfAttention = pmt.airfieldTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.airfieldTargetsBlue[k].tokenOfAttention)	{	
							currAFName = pmt.airfieldTargetsBlue[k].name;	
							currTokenOfAttention = pmt.airfieldTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)
						if((pmt.airfieldTargetsBlue[k].name == currAFName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsBlue[k].airfieldPosit) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and You will attack the " + removeUnderscores(pmt.airfieldTargetsBlue[k].name) + ' ' + pmt.airfieldTargetsBlue[k].classid + ", at grid " + removeUnderscores(pmt.airfieldTargetsBlue[k].grid) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.airfieldTargetsBlue[k].airfieldPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = pmt.airfieldTargetsBlue[k].airfieldPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.airfieldTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.airfieldTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;													
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())			
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())					
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{		
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.factoryTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.factoryTargetsBlue.getSize(); j++)	{
					std::string currFName = pmt.factoryTargetsBlue[0].name;
					int currTokenOfAttention = pmt.factoryTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.factoryTargetsBlue[k].tokenOfAttention)	{	
							currFName = pmt.factoryTargetsBlue[k].name;	
							currTokenOfAttention = pmt.factoryTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)
						if((pmt.factoryTargetsBlue[k].name == currFName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.factoryTargetsBlue[k].factoryPosit) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nToday, You will attack an enemy factory, " + removeUnderscores(pmt.factoryTargetsBlue[k].name) + ". Take off from our base at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to grid " + removeUnderscores(pmt.factoryTargetsBlue[k].grid) + ", and bomb Your target.";
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.factoryTargetsBlue[k].factoryPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = pmt.factoryTargetsBlue[k].factoryPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.factoryTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.factoryTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())					
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())					
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{			
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.subcontractorTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.subcontractorTargetsBlue.getSize(); j++)	{
					std::string currSName = pmt.subcontractorTargetsBlue[0].name;
					int currTokenOfAttention = pmt.subcontractorTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.subcontractorTargetsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.subcontractorTargetsBlue[k].tokenOfAttention)	{	
							currSName = pmt.subcontractorTargetsBlue[k].name;	
							currTokenOfAttention = pmt.subcontractorTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.subcontractorTargetsBlue.getSize(); k++)
						if((pmt.subcontractorTargetsBlue[k].name == currSName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsBlue[k].subcontractorPosit) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nToday, You will attack an enemy subcontracting factory, " + removeUnderscores(pmt.subcontractorTargetsBlue[k].name) + ". Take off from our base at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to grid " + removeUnderscores(pmt.subcontractorTargetsBlue[k].grid) + ", and bomb Your target.";
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.subcontractorTargetsBlue[k].subcontractorPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = pmt.subcontractorTargetsBlue[k].subcontractorPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.subcontractorTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.subcontractorTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;													
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.jabosRed.getSize())										
				break;
			if(!pmt.jabosRed[nextGroupIndex].available)	{							
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.portTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.portTargetsBlue.getSize(); j++)	{
					std::string currPName = pmt.portTargetsBlue[0].name;
					int currTokenOfAttention = pmt.portTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)
						if(currTokenOfAttention > pmt.portTargetsBlue[k].tokenOfAttention)	{	
							currPName = pmt.portTargetsBlue[k].name;	
							currTokenOfAttention = pmt.portTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)
						if((pmt.portTargetsBlue[k].name == currPName) && (distance(pmt.jabosRed[nextGroupIndex].wayPoints[0], pmt.portTargetsBlue[k].portPosit) < 0.9 * pmt.jabosRed[nextGroupIndex].actionRadius) && pmt.jabosRed[nextGroupIndex].available)	{
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from our airfield at grid " + removeUnderscores(grid(pmt.jabosRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and attack the " + removeUnderscores(pmt.portTargetsBlue[k].name) + ' ' + pmt.portTargetsBlue[k].classid + ", at grid " + removeUnderscores(pmt.portTargetsBlue[k].grid) + '.';
							pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosRed[nextGroupIndex].wayPoints[4], pmt.portTargetsBlue[k].portPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6] = pmt.portTargetsBlue[k].portPosit;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosRed[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosRed[nextGroupIndex].wayPoints[5];
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosRed[nextGroupIndex].wayPoints[0];
							pmt.jabosRed.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosRed.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosRed.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosRed.mod(nextGroupIndex)->available = false;
							int TOA = pmt.portTargetsBlue.mod(k)->tokenOfAttention + 1;
							pmt.portTargetsBlue.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosRed.getSize() - 1)
										pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.jabosRed.getSize() - 1)	{
										if(pmt.jabosRed[nextGroupIndex].groupname != pmt.jabosRed[nextGroupIndex + 1].groupname)
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(int(300 * 3.2808)) + " feet.";
										else
											pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(300 * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosRed[jj].groupname)	{
										if(pmt.jabosRed.getSize() - 1 > jj)
											currGroupName = pmt.jabosRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosRed.getSize())								
						break;
				}
			if(!pmt.jabosRed[nextGroupIndex].available)	{						
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(previousGroupIndex == nextGroupIndex)	{												
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: FREE FLIGHT";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[1] = "Either Your squadron is too far from the zone of operations,";
				pmt.jabosRed.mod(nextGroupIndex)->briefingLines[2] = "or the end of the war is drawing near. Enjoy a free flight.";
				pmt.jabosRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosRed[jj].groupname)	{
						if(pmt.jabosRed.getSize() - 1 > jj)
							currGroupName = pmt.jabosRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
								break;
					}
			}
			if(nextGroupIndex == pmt.jabosRed.getSize() || nextGroupIndex == 0)											
				break;
		}
	}
	if(pmt.jabosBlue.getSize() > 0)	{
		currGroupName = pmt.jabosBlue[0].groupname;
		nextGroupIndex = 0;
		previousGroupIndex = 0;
		while(nextGroupIndex < pmt.jabosBlue.getSize())	{
			previousGroupIndex = nextGroupIndex;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{							
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.tanksRed.getSize() > 0)	
				for(int j = 0; j < pmt.tanksRed.getSize(); j++)	{
					bool CASCondition = false;
					std::string currCName = pmt.tanksRed[0].chiefname;
					int currTokenOfAttention = pmt.tanksRed[0].tokenOfAttention;
					int friendlyIndex = 0;
					bool isTank = false;
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if(currTokenOfAttention > pmt.tanksRed[k].tokenOfAttention)	{	
							currCName = pmt.tanksRed[k].chiefname;	
							currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;
						}
					for(int kkk = 0; kkk < pmt.tanksRed.getSize(); kkk++)		
						if(currCName == pmt.tanksRed[kkk].chiefname)	{
							for(int kk = 0; kk < pmt.tanksBlue.getSize(); kk++)
								if(distance(pmt.tanksRed[kkk].makePosit(), pmt.tanksBlue[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									isTank = true;
									break;
								}
							for(int kk = 0; kk < pmt.gunsBlue.getSize(); kk++)
								if(distance(pmt.tanksRed[kkk].makePosit(), pmt.gunsBlue[kk].makePosit()) < 15000)	{
									CASCondition = true;
									friendlyIndex = kk;
									break;
								}
							break;
						}
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if((pmt.tanksRed[k].chiefname == currCName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available && CASCondition)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAS";
							if(isTank)
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTakeoff from the airfield at grid: " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and provide close air support for our troops situated at grid " + removeUnderscores(grid(pmt.tanksBlue[friendlyIndex].makePosit(), "SIDCMission.state")) + ", which are in close contact with the enemy. You will find the enemy armored column moving from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							if(!isTank)
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTakeoff from the airfield at grid: " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and provide close air support for our troops situated at grid " + removeUnderscores(grid(pmt.gunsBlue[friendlyIndex].makePosit(), "SIDCMission.state")) + ", which are in close contact with the enemy. You will find the enemy armored column moving from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit(), distance(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[5], pmt.tanksRed[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksRed[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksRed.mod(k)->tokenOfAttention + 1;
							pmt.tanksRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())								
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())									
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{						
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.tanksRed.getSize() > 0)	
				for(int j = 0; j < pmt.tanksRed.getSize(); j++)	{
					std::string currCName = pmt.tanksRed[0].chiefname;
					int currTokenOfAttention = pmt.tanksRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if(currTokenOfAttention > pmt.tanksRed[k].tokenOfAttention)	{	
							currCName = pmt.tanksRed[k].chiefname;	
							currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;
							int currCVehiclesNo = 0;
							int nextCVehiclesNo = 0;
							if((k + 1) < pmt.tanksRed.getSize())	{
								if(pmt.tanksRed[k].chiefname != pmt.tanksRed[k + 1].chiefname)	{
									for(int cvn = pmt.tanksRed.getSize() - 1; cvn >= 0; cvn--)
										if(pmt.tanksRed[cvn].chiefname == currCName)
											currCVehiclesNo++;
										std::string nextCName = pmt.tanksRed[k + 1].chiefname;
										for(int nvn = pmt.tanksRed.getSize() - 1; nvn >= 0; nvn--)
											if(pmt.tanksRed[nvn].chiefname == nextCName)
												nextCVehiclesNo++;
								}
								if(currCVehiclesNo < nextCVehiclesNo)	{
									currCName = pmt.tanksRed[k].chiefname;	
									currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;	
								}
							}
						}
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if((pmt.tanksRed[k].chiefname == currCName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nAn enemy armored column is on the move, from grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.tanksRed[k].chiefPath.wpoints[pmt.tanksRed[k].chiefPath.getLimit()], "SIDCMission.state")) + ", and You are to take off from the airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and destroy it.";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit(), distance(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.tanksRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[5], pmt.tanksRed[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.tanksRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.tanksRed[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.tanksRed.mod(k)->tokenOfAttention + 1;
							pmt.tanksRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																		
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())									
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{							
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.gunsRed.getSize() > 0)	
				for(int j = 0; j < pmt.gunsRed.getSize(); j++)	{
					std::string currStaticID = pmt.gunsRed[0].staticid;
					int currTokenOfAttention = pmt.gunsRed[0].tokenOfAttention;
					seArray<std::string, 30> gunsList;															
					for(int li = 0; li < pmt.radarsRed.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsRed.getSize(); lj++)
							if(distance(pmt.radarsRed[li].makePosit(), pmt.gunsRed[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsRed[lj].staticid);
								break;
							}
					for(int li = 0; li < pmt.airfieldTargetsRed.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsRed.getSize(); lj++)
							if(distance(pmt.airfieldTargetsRed[li].airfieldPosit, pmt.gunsRed[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsRed[lj].staticid);
								break;
							}
					for(int li = 0; li < pmt.factoryTargetsRed.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsRed.getSize(); lj++)
							if(distance(pmt.factoryTargetsRed[li].factoryPosit, pmt.gunsRed[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsRed[lj].staticid);
								break;
							}
					for(int li = 0; li < pmt.subcontractorTargetsRed.getSize(); li++)
						for(int lj = 0; lj < pmt.gunsRed.getSize(); lj++)
							if(distance(pmt.subcontractorTargetsRed[li].subcontractorPosit, pmt.gunsRed[lj].makePosit()) < 5000)	{
								gunsList.add(pmt.gunsRed[lj].staticid);
								break;
							}
					if(gunsList.getSize() > 0)	{								
						double currDist;
						for(int si = 0; si < gunsList.getSize(); si++)	{		
							for(int sj = 0; sj < pmt.gunsRed.getSize(); sj++)
								if(gunsList[si] == pmt.gunsRed[sj].staticid)	{
									currStaticID = pmt.gunsRed[sj].staticid;
									currTokenOfAttention = pmt.gunsRed[sj].tokenOfAttention;
									currDist = distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[sj].makePosit());
									break;
								}
							break;
						}
						for(int si = 0; si < gunsList.getSize(); si++)				
							for(int sj = 0; sj < pmt.gunsRed.getSize(); sj++)
								if(gunsList[si] == pmt.gunsRed[sj].staticid)
									if(distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[sj].makePosit()) < currDist)	{
										currStaticID = pmt.gunsRed[sj].staticid;
										currTokenOfAttention = pmt.gunsRed[sj].tokenOfAttention;
										currDist = distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[sj].makePosit());
									}
					}
					if(gunsList.getSize() == 0)	{									
						for(int k = 0; k < pmt.gunsRed.getSize(); k++)
							if(currTokenOfAttention > pmt.gunsRed[k].tokenOfAttention)	{	
								currStaticID = pmt.gunsRed[k].staticid;	
								currTokenOfAttention = pmt.gunsRed[k].tokenOfAttention;
							}
					}
					for(int k = 0; k < pmt.gunsRed.getSize(); k++)
						if((pmt.gunsRed[k].staticid == currStaticID) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.gunsRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							for(int abyz = 0; abyz < pmt.airfieldTargetsRed.getSize(); abyz++)													
								if(distance(pmt.gunsRed[k].makePosit(), pmt.airfieldTargetsRed[abyz].airfieldPosit) < intZRadius)	{
									int tOa = pmt.airfieldTargetsRed[abyz].tokenOfAttention;
									tOa++;
									pmt.airfieldTargetsRed.mod(abyz)->tokenOfAttention = tOa;
									break;
								}
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack enemy artillery near " + removeUnderscores(pmt.gunsRed[k].gridname) + ", at grid" + removeUnderscores(pmt.gunsRed[k].grid) + '.';
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.gunsRed[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.gunsRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[6] = pmt.gunsRed[k].staticid + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.gunsRed.mod(k)->tokenOfAttention + 1;
							pmt.gunsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;													
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())											
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{								
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.vehiclesctRed.getSize() > 0)	
				for(int j = 0; j < pmt.vehiclesctRed.getSize(); j++)	{
					std::string currCName = pmt.vehiclesctRed[0].chiefname;
					int currTokenOfAttention = pmt.vehiclesctRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.vehiclesctRed.getSize(); k++)
						if(currTokenOfAttention > pmt.vehiclesctRed[k].tokenOfAttention)	{		
							currCName = pmt.vehiclesctRed[k].chiefname;	
							currTokenOfAttention = pmt.vehiclesctRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.vehiclesctRed.getSize(); k++)
						if((pmt.vehiclesctRed[k].chiefname == currCName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.vehiclesctRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and attack an enemy column moving from grid " + removeUnderscores(grid(pmt.vehiclesctRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.vehiclesctRed[k].chiefPath.wpoints[pmt.vehiclesctRed[k].chiefPath.getLimit()], "SIDCMission.state")) + '.';
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.vehiclesctRed[k].makePosit(), distance(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.vehiclesctRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[5], pmt.vehiclesctRed[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.vehiclesctRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.vehiclesctRed[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.vehiclesctRed.mod(k)->tokenOfAttention + 1;
							pmt.vehiclesctRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())									
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{						
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.shipsRed.getSize() > 0)	
				for(int j = 0; j < pmt.shipsRed.getSize(); j++)	{
					std::string currCName = pmt.shipsRed[0].chiefname;
					int currTokenOfAttention = pmt.shipsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.shipsRed[k].tokenOfAttention)	{		
							currCName = pmt.shipsRed[k].chiefname;	
							currTokenOfAttention = pmt.shipsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)
						if((pmt.shipsRed[k].chiefname == currCName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.shipsRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: ANTI SHIP";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack enemy ships moving from grid " + removeUnderscores(grid(pmt.shipsRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.shipsRed[k].chiefPath.wpoints[pmt.shipsRed[k].chiefPath.getLimit()], "SIDCMission.state")) + ". Don\' t You hate ships?";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.shipsRed[k].makePosit(), distance(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.shipsRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[5], pmt.shipsRed[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.shipsRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.shipsRed[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.shipsRed.mod(k)->tokenOfAttention + 1;
							pmt.shipsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())								
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())									
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{						
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.trainsRed.getSize() > 0)	
				for(int j = 0; j < pmt.trainsRed.getSize(); j++)	{
					std::string currCName = pmt.trainsRed[0].chiefname;
					int currTokenOfAttention = pmt.trainsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.trainsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.trainsRed[k].tokenOfAttention)	{	
							currCName = pmt.trainsRed[k].chiefname;	
							currTokenOfAttention = pmt.trainsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.trainsRed.getSize(); k++)
						if((pmt.trainsRed[k].chiefname == currCName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.trainsRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERDICTION";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", find the enemy train moving from grid " + removeUnderscores(grid(pmt.trainsRed[k].makePosit(), "SIDCMission.state")) + " to grid " + removeUnderscores(grid(pmt.trainsRed[k].chiefPath.wpoints[pmt.trainsRed[k].chiefPath.getLimit()], "SIDCMission.state")) + ", and attack it viciously!";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							position ingressPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.trainsRed[k].makePosit(), distance(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.trainsRed[k].makePosit()) - 7000);
							ingressPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = ingressPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							position initialPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[5], pmt.trainsRed[k].makePosit(), 4000);
							initialPosit.altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = initialPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.trainsRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[6].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[7] = pmt.trainsRed[k].chiefname + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[9] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[9] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[9] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.trainsRed.mod(k)->tokenOfAttention + 1;
							pmt.trainsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;															
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())							
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())									
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{							
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.radarsRed.getSize() > 0)	
				for(int j = 0; j < pmt.radarsRed.getSize(); j++)	{
					std::string currStaticID = pmt.radarsRed[0].staticid;
					int currTokenOfAttention = pmt.radarsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.radarsRed[k].tokenOfAttention)	{	
							currStaticID = pmt.radarsRed[k].staticid;	
							currTokenOfAttention = pmt.radarsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)
						if((pmt.radarsRed[k].staticid == currStaticID) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.radarsRed[k].makePosit()) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to take off from the airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and attack an enemy " + pmt.radarsRed[k].classid + ", near " + removeUnderscores(pmt.radarsRed[k].gridname) + ", at grid " + removeUnderscores(pmt.radarsRed[k].grid) + '.';
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.radarsRed[k].makePosit(), 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.radarsRed[k].makePosit();
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_TARG";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointActions[6] = pmt.radarsRed[k].staticid + ' ' + "0 /GAttackType TOP_MAST";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.radarsRed.mod(k)->tokenOfAttention + 1;
							pmt.radarsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())										
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{							
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.airfieldTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.airfieldTargetsRed.getSize(); j++)	{
					std::string currAFName = pmt.airfieldTargetsRed[0].name;
					int currTokenOfAttention = pmt.airfieldTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.airfieldTargetsRed[k].tokenOfAttention)	{	
							currAFName = pmt.airfieldTargetsRed[k].name;	
							currTokenOfAttention = pmt.airfieldTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)
						if((pmt.airfieldTargetsRed[k].name == currAFName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsRed[k].airfieldPosit) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid" + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and attack the " + removeUnderscores(pmt.airfieldTargetsRed[k].name) + ' ' + pmt.airfieldTargetsRed[k].classid + ", at grid " + removeUnderscores(pmt.airfieldTargetsRed[k].grid) + '.';
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.airfieldTargetsRed[k].airfieldPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.airfieldTargetsRed[k].airfieldPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.airfieldTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.airfieldTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																	
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())												
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())											
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{								
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.factoryTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.factoryTargetsRed.getSize(); j++)	{
					std::string currFName = pmt.factoryTargetsRed[0].name;
					int currTokenOfAttention = pmt.factoryTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.factoryTargetsRed[k].tokenOfAttention)	{		
							currFName = pmt.factoryTargetsRed[k].name;	
							currTokenOfAttention = pmt.factoryTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)
						if((pmt.factoryTargetsRed[k].name == currFName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.factoryTargetsRed[k].factoryPosit) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nAn enemy factory, " + removeUnderscores(pmt.factoryTargetsRed[k].name) + ", at grid " + removeUnderscores(pmt.factoryTargetsRed[k].grid) + " will be targeted this time. Take off from the airfield at grid "+ removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack the target.";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.factoryTargetsRed[k].factoryPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.factoryTargetsRed[k].factoryPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.factoryTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.factoryTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())					
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())					
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{				
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.subcontractorTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.subcontractorTargetsRed.getSize(); j++)	{
					std::string currSName = pmt.subcontractorTargetsRed[0].name;
					int currTokenOfAttention = pmt.subcontractorTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.subcontractorTargetsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.subcontractorTargetsRed[k].tokenOfAttention)	{	
							currSName = pmt.subcontractorTargetsRed[k].name;	
							currTokenOfAttention = pmt.subcontractorTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.subcontractorTargetsRed.getSize(); k++)
						if((pmt.subcontractorTargetsRed[k].name == currSName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.subcontractorTargetsRed[k].subcontractorPosit) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from our airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and attack an enemy subcontracting factory, " + removeUnderscores(pmt.subcontractorTargetsRed[k].name) + " at grid " + removeUnderscores(pmt.subcontractorTargetsRed[k].grid) + '.';
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.subcontractorTargetsRed[k].subcontractorPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.subcontractorTargetsRed[k].subcontractorPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.subcontractorTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.subcontractorTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																		
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.jabosBlue.getSize())											
				break;
			if(!pmt.jabosBlue[nextGroupIndex].available)	{					
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(pmt.portTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.portTargetsRed.getSize(); j++)	{
					std::string currPName = pmt.portTargetsRed[0].name;
					int currTokenOfAttention = pmt.portTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)
						if(currTokenOfAttention > pmt.portTargetsRed[k].tokenOfAttention)	{	
							currPName = pmt.portTargetsRed[k].name;	
							currTokenOfAttention = pmt.portTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)
						if((pmt.portTargetsRed[k].name == currPName) && (distance(pmt.jabosBlue[nextGroupIndex].wayPoints[0], pmt.portTargetsRed[k].portPosit) < 0.9 * pmt.jabosBlue[nextGroupIndex].actionRadius) && pmt.jabosBlue[nextGroupIndex].available)	{
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: STRIKE";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.jabosBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " fly to the enemy " + pmt.portTargetsRed[k].classid + ", " + removeUnderscores(pmt.portTargetsRed[k].name) + " at grid " + removeUnderscores(pmt.portTargetsRed[k].grid) + " and bomb it!";
							pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.jabosBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							double flightAlt = 300;
							position flightAltPosit = splitLine(pmt.jabosBlue[nextGroupIndex].wayPoints[4], pmt.portTargetsRed[k].portPosit, 10000);
							flightAltPosit.altitude = flightAlt;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.portTargetsRed[k].portPosit;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[6].altitude = pmt.jabosBlue[nextGroupIndex].wayPoints[5].altitude;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[6] = "GATTACK_POINT";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.jabosBlue[nextGroupIndex].wayPoints[5];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[7] = "NORMFLY";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 400;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8] = pmt.jabosBlue[nextGroupIndex].wayPoints[0];
							pmt.jabosBlue.mod(nextGroupIndex)->wayPoints[8].altitude = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointTypes[8] = "LANDING";
							pmt.jabosBlue.mod(nextGroupIndex)->wayPointSpeed[8] = 300;
							pmt.jabosBlue.mod(nextGroupIndex)->available = false;
							int TOA = pmt.portTargetsRed.mod(k)->tokenOfAttention + 1;
							pmt.portTargetsRed.mod(k)->tokenOfAttention = TOA;
							if(pmt.jabosBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYou will be flying unescorted!";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.jabosBlue.getSize() - 1)
										pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
									if(nextGroupIndex < pmt.jabosBlue.getSize() - 1)	{
										if(pmt.jabosBlue[nextGroupIndex].groupname != pmt.jabosBlue[nextGroupIndex + 1].groupname)
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off climb to " + std::to_string(300) + " meters.";
										else
											pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off and formed up, climb to " + std::to_string(300) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.jabosBlue[jj].groupname)	{
										if(pmt.jabosBlue.getSize() - 1 > jj)
											currGroupName = pmt.jabosBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}										
							break;																
						}
					if(nextGroupIndex == pmt.jabosBlue.getSize())											
						break;
				}
			if(!pmt.jabosBlue[nextGroupIndex].available)	{							
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}
			}
			if(previousGroupIndex == nextGroupIndex)	{													
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: FREE FLIGHT";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[1] = "Either Your squadron is too far from the zone of operations,";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingLines[2] = "or the end of the war is drawing near. Enjoy a free flight.";
				pmt.jabosBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.jabosBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.jabosBlue[jj].groupname)	{
						if(pmt.jabosBlue.getSize() - 1 > jj)
							currGroupName = pmt.jabosBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
								break;
					}
			}
			if(nextGroupIndex == pmt.jabosBlue.getSize() || nextGroupIndex == 0)											
				break;
		}
	}
	if(pmt.fightersRed.getSize() > 0)	{
		currGroupName = pmt.fightersRed[0].groupname;
		nextGroupIndex = 0;
		previousGroupIndex = 0;
		while(nextGroupIndex < pmt.fightersRed.getSize())	{
			previousGroupIndex = nextGroupIndex;
			if(!pmt.fightersRed[nextGroupIndex].available)	{						
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.airfieldTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.airfieldTargetsRed.getSize(); j++)	{
					bool interceptCondition = false;
					int selectedABIndex = 0;
					int ownBaseIndex = 0;
					bool gotJabos = false;																
					std::string currIncomingGroupname = "NoString";
					std::string currAFName = pmt.airfieldTargetsRed[j].name;
					int currTokenOfAttention = pmt.airfieldTargetsRed[j].tokenOfAttention;
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)
						if((pmt.airfieldTargetsRed[k].tokenOfAttention != 0) && (currTokenOfAttention <= pmt.airfieldTargetsRed[k].tokenOfAttention) && (!pmt.airfieldTargetsRed[k].tokenOfLove))	{		
							currAFName = pmt.airfieldTargetsRed[k].name;	
							currTokenOfAttention = pmt.airfieldTargetsRed[k].tokenOfAttention;
							selectedABIndex = k;
						}
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)																												
						if(distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsRed[k].airfieldPosit) < 2000)	{
							for(int kl = 0; kl < pmt.bombersBlue.getSize(); kl++)	{
								for(int kj = 0; kj <= pmt.bombersBlue[kl].getWPLimit(); kj++)
									if((pmt.bombersBlue[kl].wayPointTypes[kj] == "GATTACK_POINT" || pmt.bombersBlue[kl].wayPointTypes[kj] == "GATTACK_TARG") && (distance(pmt.airfieldTargetsRed[k].airfieldPosit, pmt.bombersBlue[kl].wayPoints[kj]) < intZRadius) && (distance(pmt.bombersBlue[kl].wayPoints[5], pmt.bombersBlue[kl].wayPoints[kj]) < interceptRange))	{
										interceptCondition = true;
										ownBaseIndex = k;
										gotJabos = false;
										pmt.bombersBlue.mod(kl)->escorted = true;				
										break;
									}
								if(interceptCondition)						
									break;
							}
							for(int kl = 0; kl < pmt.jabosBlue.getSize(); kl++)	
								for(int kj = 0; kj <= pmt.jabosBlue[kl].getWPLimit(); kj++)	{
									if((pmt.jabosBlue[kl].wayPointTypes[kj] == "GATTACK_POINT" || pmt.jabosBlue[kl].wayPointTypes[kj] == "GATTACK_TARG") && (distance(pmt.airfieldTargetsRed[k].airfieldPosit, pmt.jabosBlue[kl].wayPoints[kj]) < intZRadius) && (distance(pmt.jabosBlue[kl].wayPoints[5], pmt.jabosBlue[kl].wayPoints[kj]) < interceptRange))	{
										interceptCondition = true;
										ownBaseIndex = k;
										gotJabos = true;
										pmt.jabosBlue.mod(kl)->escorted = true;					
										break;
									}
									if(interceptCondition)						
										break;
								}
							if(interceptCondition)
								break;
						}
					for(int k = 0; k < pmt.airfieldTargetsRed.getSize(); k++)	{
						if((k == ownBaseIndex) && pmt.fightersRed[nextGroupIndex].available && interceptCondition)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERCEPTION";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nOur airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " will soon be overflown by an enemy bomber formation. Take off imediately and intercept the enemy bombers! Fly towards grid ";
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;															
							position interceptPosit;															
							if((pmt.bombersBlue.getSize() > 0) && (!gotJabos))											
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.airfieldTargetsRed[k].airfieldPosit) < intZRadius)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 1000;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												currIncomingGroupname = pmt.bombersBlue[kkk].groupname;
												interceptPosit = pmt.bombersBlue[kkk].wayPoints[5];
												break;
											}
							if((pmt.jabosBlue.getSize() > 0) && !altitudeSet && gotJabos)													
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.airfieldTargetsRed[k].airfieldPosit) < intZRadius)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 1000;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												currIncomingGroupname = pmt.jabosBlue[kkk].groupname;
												interceptPosit = pmt.jabosBlue[kkk].wayPoints[5];
												break;
											}
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = removeUnderscores(grid(interceptPosit, "SIDCMission.state")) + ". Climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet immediately after takeoff!";
							interceptPosit.altitude = flightAlt;
							if(!gotJabos)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = interceptPosit;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "AATTACK_BOMBERS";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointActions[5] = currIncomingGroupname + " 1";
							}
							if(gotJabos)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = interceptPosit;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "AATTACK_FIGHTERS";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointActions[5] = currIncomingGroupname + " 1";
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[6] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[7] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[7].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[7] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[7] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off, proceed to intercept imediately!";
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;														
						}
						if((pmt.airfieldTargetsRed[k].name == currAFName) && (pmt.airfieldTargetsRed[k].tokenOfAttention != 0) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsRed[k].airfieldPosit) < (0.9 * pmt.fightersRed[nextGroupIndex].actionRadius)) && pmt.fightersRed[nextGroupIndex].available && !interceptCondition)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the friendly airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", proceed to grid " + removeUnderscores(pmt.airfieldTargetsRed[k].grid) + " and patrol there. Shoot down enemy planes that stray into Your sector. Good luck!";
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																	
							if(pmt.bombersBlue.getSize() > 0)														
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.airfieldTargetsRed[k].airfieldPosit) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)												
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.airfieldTargetsRed[k].airfieldPosit) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							position flightAltPosit = pmt.airfieldTargetsRed[k].airfieldPosit;
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							if(pmt.airfieldTargetsRed[k].tokenOfAttention <= 2)
								pmt.airfieldTargetsRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																
						}
					}
					if(nextGroupIndex == pmt.fightersRed.getSize())								
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())										
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{						
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.radarsRed.getSize() > 0)	
				for(int j = 0; j < pmt.radarsRed.getSize(); j++)	{
					std::string currStaticID = pmt.radarsRed[0].staticid;
					int currTokenOfAttention = pmt.radarsRed[0].tokenOfAttention;
					int redFGroups = getRedFGroupNo(pmt);										
					int redBGroups = getRedBGroupNo(pmt);
					int redJGroups = getRedJGroupNo(pmt);
					int blueBGroups = getBlueBGroupNo(pmt);			
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)							
						if(!pmt.radarsRed[k].tokenOfAttention && !pmt.radarsRed[k].tokenOfLove)	{
							currStaticID = pmt.radarsRed[k].staticid;
							currTokenOfAttention = pmt.radarsRed[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)
						if((currTokenOfAttention <= pmt.radarsRed[k].tokenOfAttention) && (!(pmt.radarsRed[k].tokenOfLove)))	{	
							currStaticID = pmt.radarsRed[k].staticid;	
							currTokenOfAttention = pmt.radarsRed[k].tokenOfAttention;
						}
					if((redFGroups > blueBGroups) && (pmt.radarsRed.getSize() >= blueBGroups) && ((redBGroups + redJGroups) == 0))	{
						for(int ik = 0; ik < pmt.radarsRed.getSize(); ik++)
							if(pmt.radarsRed[ik].staticid == currStaticID)	{
								pmt.radarsRed.mod(ik)->tokenOfLove = false;
								break;
							}
					}
					for(int k = 0; k < pmt.radarsRed.getSize(); k++)
						if((pmt.radarsRed[k].staticid == currStaticID) && (pmt.radarsRed[k].tokenOfAttention != 0) && (!pmt.radarsRed[k].tokenOfLove) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.radarsRed[k].makePosit()) < 0.9 * pmt.fightersRed[nextGroupIndex].actionRadius) && pmt.fightersRed[nextGroupIndex].available)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + " and patrol grid " + removeUnderscores(pmt.radarsRed[k].grid) + ". Expect enemy raids.";
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																	
							if(pmt.bombersBlue.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.radarsRed[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)															
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.radarsRed[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							position flightAltPosit = pmt.radarsRed[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							pmt.radarsRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;															
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())											
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{						
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.factoryTargetsRed.getSize() > 0)	
				for(int j = 0; j < pmt.factoryTargetsRed.getSize(); j++)	{
					std::string currFName = pmt.factoryTargetsRed[0].name;
					int currTokenOfAttention = pmt.factoryTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)						
						if(!pmt.factoryTargetsRed[k].tokenOfAttention)	{
							currFName = pmt.factoryTargetsRed[k].name;
							currTokenOfAttention = pmt.factoryTargetsRed[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)
						if((currTokenOfAttention > pmt.factoryTargetsRed[k].tokenOfAttention) && (!(pmt.factoryTargetsRed[k].tokenOfLove)))	{	
							currFName = pmt.factoryTargetsRed[k].name;	
							currTokenOfAttention = pmt.factoryTargetsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.factoryTargetsRed.getSize(); k++)
						if((pmt.factoryTargetsRed[k].name == currFName) && (pmt.factoryTargetsRed[k].tokenOfAttention != 0) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.factoryTargetsRed[k].factoryPosit) < 0.9 * pmt.fightersRed[nextGroupIndex].actionRadius) && pmt.fightersRed[nextGroupIndex].available)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou are to patrol the airspace at grid " + removeUnderscores(pmt.factoryTargetsRed[k].grid) + ". You will be taking off from the airbase at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state"));
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersBlue.getSize() > 0)													
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.factoryTargetsRed[k].factoryPosit) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)													
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.factoryTargetsRed[k].factoryPosit) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							position flightAltPosit = pmt.factoryTargetsRed[k].factoryPosit;
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							pmt.factoryTargetsRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;															
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())								
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{					
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.tanksRed.getSize() > 0)	
				for(int j = 0; j < pmt.tanksRed.getSize(); j++)	{
					std::string currCName = pmt.tanksRed[0].chiefname;
					int currTokenOfAttention = pmt.tanksRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)							
						if(!pmt.tanksRed[k].tokenOfAttention)	{
							currCName = pmt.tanksRed[k].chiefname;
							currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if((currTokenOfAttention > pmt.tanksRed[k].tokenOfAttention) && (!(pmt.tanksRed[k].tokenOfLove)))	{		
							currCName = pmt.tanksRed[k].chiefname;	
							currTokenOfAttention = pmt.tanksRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.tanksRed.getSize(); k++)
						if((pmt.tanksRed[k].chiefname == currCName) && (pmt.tanksRed[k].tokenOfAttention != 0) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.tanksRed[k].makePosit()) < 0.9 * pmt.fightersRed[nextGroupIndex].actionRadius) && pmt.fightersRed[nextGroupIndex].available)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nPatrol the airspace at grid " + removeUnderscores(grid(pmt.tanksRed[k].makePosit(), "SIDCMission.state")) + ". You will be taking off from our airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.';
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																	
							if(pmt.bombersBlue.getSize() > 0)															
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)	{
										if((pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT") || (pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG"))
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.tanksRed[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
								}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)															
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if((pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT") || (pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG"))	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.tanksRed[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							position flightAltPosit = pmt.tanksRed[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							pmt.tanksRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;															
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())							
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{			
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.shipsRed.getSize() > 0)	
				for(int j = 0; j < pmt.shipsRed.getSize(); j++)	{
					std::string currCName = pmt.shipsRed[0].chiefname;
					int currTokenOfAttention = pmt.shipsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)						
						if(!pmt.shipsRed[k].tokenOfAttention)	{
							currCName = pmt.shipsRed[k].chiefname;
							currTokenOfAttention = pmt.shipsRed[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)
						if((currTokenOfAttention > pmt.shipsRed[k].tokenOfAttention) && (!(pmt.shipsRed[k].tokenOfLove)))	{	
							currCName = pmt.shipsRed[k].chiefname;	
							currTokenOfAttention = pmt.shipsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.shipsRed.getSize(); k++)
						if((pmt.shipsRed[k].chiefname == currCName) && (pmt.shipsRed[k].tokenOfAttention != 0) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.shipsRed[k].makePosit()) < 0.9 * pmt.fightersRed[nextGroupIndex].actionRadius) && pmt.fightersRed[nextGroupIndex].available)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nThis time You will patril the airspace at grid " + removeUnderscores(grid(pmt.shipsRed[k].makePosit(), "SIDCMission.state")) + ". You will take off from the airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.';
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;															
							if(pmt.bombersBlue.getSize() > 0)										
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.shipsRed[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)											
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.shipsRed[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							position flightAltPosit = pmt.shipsRed[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							pmt.shipsRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;													
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())							
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{				
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.bombersRed.getSize() > 0)															
				for(int k = 0; k < pmt.bombersRed.getSize(); k++)	{
					std::string currBGroupName;														
					double distBFaBB;																
					double distToTarget;															
					position bomberTargetPosit;														
					int bomberTargetIndex;															
					if(!pmt.bombersRed[k].available && !pmt.bombersRed[k].escorted)				
						if(pmt.bombersRed[k].wayPoints[1].positionX != 0 && pmt.bombersRed[k].wayPoints[1].positionY != 0 && pmt.bombersRed[k].wayPoints[1].altitude != 0 && pmt.bombersRed[k].wayPointTypes[1] != "NoString")	{
							distBFaBB = distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.bombersRed[k].wayPoints[0]);
							for(int ji = 0; ji < 20; ji++)	
								if(pmt.bombersRed[k].wayPointTypes[ji] == "GATTACK_POINT" || pmt.bombersRed[k].wayPointTypes[ji] == "GATTACK_TARG")	{
									distToTarget = distance(pmt.bombersRed[k].wayPoints[0], pmt.bombersRed[k].wayPoints[ji]);
									bomberTargetPosit = pmt.bombersRed[k].wayPoints[ji];
									bomberTargetIndex = ji;
									break;
								}
							if(((distBFaBB + distToTarget) < (pmt.fightersRed[nextGroupIndex].actionRadius * 0.8)) && (distBFaBB < (pmt.bombersRed[k].actionRadius * 0.1)))	{
								currBGroupName = pmt.bombersRed[k].groupname;
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: ESCORT";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nToday, You will escort friendly bombers to their target at grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ". You will rendez- vous with them over their base at grid " + removeUnderscores(grid(pmt.bombersRed[k].wayPoints[0], "SIDCMission.state")) + ", and proceed at an altitude of " + std::to_string((int)((pmt.bombersRed[k].wayPoints[bomberTargetIndex].altitude + 1000) * 3.2808)) + " feet. You will take off from the friendly airfield at grid "+ removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								double newPeriod = ((distBFaBB / 1000) / 400) * 60 + 3;					
								triangularPattern TP;
								TP.setPattern(newPeriod, pmt.bombersRed[k].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.bombersRed.mod(k)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.bombersRed.mod(k)->wayPointTypes[ii] = "NORMFLY";
									pmt.bombersRed.mod(k)->wayPointSpeed[ii] = 300;
								}
								pmt.bombersRed.mod(k)->briefingLines[3] = "\n\nAfter You\' ve taken off, wait for the escort fighters over the airfield.";
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								int endLineNumber = 1;
								int lastIndex;
								for(int iii = 4; iii <= bomberTargetIndex + 1; iii++)	{
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[iii - 2] = pmt.bombersRed[k].wayPoints[iii];
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[iii - 2].altitude = pmt.bombersRed[k].wayPoints[iii].altitude + 500;
									pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[iii - 2] = pmt.bombersRed[k].wayPointSpeed[iii];
									pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[iii - 2] = "ESCORT";
									pmt.fightersRed.mod(nextGroupIndex)->wayPointActions[iii - 2] = currBGroupName + ' ' + std::to_string(endLineNumber);
									endLineNumber++;
									lastIndex = iii - 2;
								}
								lastIndex++;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[lastIndex] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[lastIndex] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[lastIndex] = "LANDING";
								pmt.fightersRed.mod(nextGroupIndex)->available = false;
								pmt.bombersRed.mod(k)->escorted = true;
								if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off, proceed to the rendez- vous point.";
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersRed[jj].groupname)	{
										if(pmt.fightersRed.getSize() - 1 > jj)
											currGroupName = pmt.fightersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())									
				break;	
			if(!pmt.fightersRed[nextGroupIndex].available)	{						
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.bombersRed.getSize() > 0)												
				for(int k = 0; k < pmt.bombersRed.getSize(); k++)	{
					std::string currBGroupName;															
					position bomberTargetPosit;														
					if(!pmt.bombersRed[k].available)					
						if((pmt.bombersRed[k].wayPoints[1].positionX != 0) && (pmt.bombersRed[k].wayPoints[1].positionY != 0) && (pmt.bombersRed[k].wayPoints[1].altitude != 0) && (pmt.bombersRed[k].wayPointTypes[1] != "NoString"))	{
							for(int ji = 0; ji < 20; ji++)	
								if((pmt.bombersRed[k].wayPointTypes[ji] == "GATTACK_POINT") || (pmt.bombersRed[k].wayPointTypes[ji] == "GATTACK_TARG"))	{
									bomberTargetPosit = pmt.bombersRed[k].wayPoints[ji];
									break;
								}
							if(distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], bomberTargetPosit) < (0.9 * pmt.fightersRed[nextGroupIndex].actionRadius))	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: FIGHTER SWEEP";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ", and engage enemy planes You may encounter.";
								double flightAlt = randAlt(8000, 1000);
								pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								triangularPattern TP;
								TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);	
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
									pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
								}
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = bomberTargetPosit;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5].altitude = flightAlt;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
								squarePattern SP;
								SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
								for(int ija = 6; ija <= 11; ija++)	{
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
									pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
									pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
								}
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13].altitude = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "LANDING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->available = false;
								if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
										if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
											if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
												pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
											else
												pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
										}
									}
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersRed[jj].groupname)	{
										if(pmt.fightersRed.getSize() - 1 > jj)
											currGroupName = pmt.fightersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())										
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())									
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{							
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.jabosRed.getSize() > 0)													
				for(int k = 0; k < pmt.jabosRed.getSize(); k++)	{
					std::string currBGroupName;													
					position bomberTargetPosit;												
					if(!pmt.jabosRed[k].available)					
						if((pmt.jabosRed[k].wayPoints[1].positionX != 0) && (pmt.jabosRed[k].wayPoints[1].positionY != 0) && (pmt.jabosRed[k].wayPoints[1].altitude != 0) && (pmt.jabosRed[k].wayPointTypes[1] != "NoString"))	{
							for(int ji = 0; ji < 20; ji++)	
								if((pmt.jabosRed[k].wayPointTypes[ji] == "GATTACK_POINT") || (pmt.jabosRed[k].wayPointTypes[ji] == "GATTACK_TARG"))	{
									bomberTargetPosit = pmt.jabosRed[k].wayPoints[ji];
									break;
								}
							if(distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], bomberTargetPosit) < (0.9 * pmt.fightersRed[nextGroupIndex].actionRadius))	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: FIGHTER SWEEP";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nProceed to grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + " and engage enemy planes You may encounter there. You will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.';
								double flightAlt = randAlt(3000, 1000);
								pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								triangularPattern TP;
								TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
									pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
								}
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = bomberTargetPosit;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5].altitude = flightAlt;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
								squarePattern SP;
								SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
								for(int ija = 6; ija <= 11; ija++)	{
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
									pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
									pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
								}
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13].altitude = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "LANDING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->available = false;
								if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if((pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname) || (nextGroupIndex == pmt.fightersRed.getSize() - 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off proceed to the altitude of " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									else
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, proceed to the altitude of " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
								}
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersRed[jj].groupname)	{
										if(pmt.fightersRed.getSize() - 1 > jj)
											currGroupName = pmt.fightersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())									
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{					
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.jabosRed.getSize() > 0)													
				for(int k = 0; k < pmt.jabosRed.getSize(); k++)	{
					std::string currBGroupName;															
					double distBFaBB;																	
					double distToTarget;																
					position bomberTargetPosit;														
					int bomberTargetIndex;															
					if(!pmt.jabosRed[k].available && !pmt.jabosRed[k].escorted)						
						if(pmt.jabosRed[k].wayPoints[1].positionX != 0 && pmt.jabosRed[k].wayPoints[1].positionY != 0 && pmt.jabosRed[k].wayPoints[1].altitude != 0 && pmt.jabosRed[k].wayPointTypes[1] != "NoString")	{
							distBFaBB = distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.jabosRed[k].wayPoints[0]);
							for(int ji = 0; ji < 20; ji++)	
								if(pmt.jabosRed[k].wayPointTypes[ji] == "GATTACK_POINT" || pmt.jabosRed[k].wayPointTypes[ji] == "GATTACK_TARG")	{
									distToTarget = distance(pmt.jabosRed[k].wayPoints[0], pmt.jabosRed[k].wayPoints[ji]);
									bomberTargetPosit = pmt.jabosRed[k].wayPoints[ji];
									bomberTargetIndex = ji;
									break;
								}
							if(((distBFaBB + distToTarget) < (pmt.fightersRed[nextGroupIndex].actionRadius * 0.8)) && (distBFaBB < (pmt.jabosRed[k].actionRadius * 0.1)))	{
								currBGroupName = pmt.jabosRed[k].groupname;
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: ESCORT";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", proceed to the rendez- vous point at grid " + removeUnderscores(grid(pmt.jabosRed[k].wayPoints[0], "SIDCMission.state")) + " and escort the friendly bombers to their target at grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ". Flight altitude: " + std::to_string((int)((pmt.jabosRed[k].wayPoints[bomberTargetIndex].altitude + 1000) * 3.2808)) + " feet.";
								pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								double newPeriod = ((distBFaBB / 1000) / 400) * 60 + 3;					
								triangularPattern TP;
								TP.setPattern(newPeriod, pmt.jabosRed[k].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.jabosRed.mod(k)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.jabosRed.mod(k)->wayPointTypes[ii] = "NORMFLY";
									pmt.jabosRed.mod(k)->wayPointSpeed[ii] = 300;
								}
								pmt.jabosRed.mod(k)->briefingLines[3] = "\n\nAfter You\' ve taken off, wait for the escort fighters over the airfield.";
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								int endLineNumber = 1;
								int lastIndex;
								for(int iii = 4; iii <= bomberTargetIndex + 1; iii++)	{
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[iii - 2] = pmt.jabosRed[k].wayPoints[iii];
									pmt.fightersRed.mod(nextGroupIndex)->wayPoints[iii - 2].altitude = pmt.jabosRed[k].wayPoints[iii].altitude + 500;
									pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[iii - 2] = pmt.jabosRed[k].wayPointSpeed[iii];
									pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[iii - 2] = "ESCORT";
									pmt.fightersRed.mod(nextGroupIndex)->wayPointActions[iii - 2] = currBGroupName + ' ' + std::to_string(endLineNumber);
									endLineNumber++;
									lastIndex = iii - 2;
								}
								lastIndex++;
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[lastIndex] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[lastIndex] = 300;
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[lastIndex] = "LANDING";
								pmt.fightersRed.mod(nextGroupIndex)->available = false;
								pmt.jabosRed.mod(k)->escorted = true;
								if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off, proceed to the rendez- vous point.";
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersRed[jj].groupname)	{
										if(pmt.fightersRed.getSize() - 1 > jj)
											currGroupName = pmt.fightersRed[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())									
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{					
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.portTargetsRed.getSize() > 0)											
				for(int j = 0; j < pmt.portTargetsRed.getSize(); j++)	{
					int selectedABIndex = 0;
					std::string currIncomingGroupname = "NoString";
					std::string currAFName = pmt.portTargetsRed[0].name;
					int currTokenOfAttention = pmt.portTargetsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)							
						if(!pmt.portTargetsRed[k].tokenOfAttention)	{
							currAFName = pmt.portTargetsRed[k].name;
							currTokenOfAttention = pmt.portTargetsRed[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)
						if((currTokenOfAttention < pmt.portTargetsRed[k].tokenOfAttention) && (!(pmt.portTargetsRed[k].tokenOfLove)))	{	
							currAFName = pmt.portTargetsRed[k].name;	
							currTokenOfAttention = pmt.portTargetsRed[k].tokenOfAttention;
							selectedABIndex = k;
						}
					for(int k = 0; k < pmt.portTargetsRed.getSize(); k++)	{
						if((pmt.portTargetsRed[k].name == currAFName) && (pmt.portTargetsRed[k].tokenOfAttention != 0) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.portTargetsRed[k].portPosit) < 0.9 * pmt.fightersRed[nextGroupIndex].actionRadius) && pmt.fightersRed[nextGroupIndex].available)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nThis time, You will patrol the airspace at grid " + removeUnderscores(pmt.portTargetsRed[k].grid) + ". You will be taking off from the airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + '.';
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersBlue.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.portTargetsRed[k].portPosit) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)													
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.portTargetsRed[k].portPosit) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							position flightAltPosit = pmt.portTargetsRed[k].portPosit;
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							pmt.portTargetsRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;														
						}
					}
					if(nextGroupIndex == pmt.fightersRed.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())								
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{						
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.gunsRed.getSize() > 0)	
				for(int j = 0; j < pmt.gunsRed.getSize(); j++)	{
					std::string currStaticID = pmt.gunsRed[0].staticid;
					int currTokenOfAttention = pmt.gunsRed[0].tokenOfAttention;
					for(int k = 0; k < pmt.gunsRed.getSize(); k++)						
						if(!pmt.gunsRed[k].tokenOfAttention)	{
							currStaticID = pmt.gunsRed[k].staticid;
							currTokenOfAttention = pmt.gunsRed[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.gunsRed.getSize(); k++)
						if((currTokenOfAttention < pmt.gunsRed[k].tokenOfAttention) && (!(pmt.gunsRed[k].tokenOfLove)))	{	
							currStaticID = pmt.gunsRed[k].staticid;	
							currTokenOfAttention = pmt.gunsRed[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.gunsRed.getSize(); k++)
						if((pmt.gunsRed[k].staticid == currStaticID) && (pmt.gunsRed[k].tokenOfAttention != 0) && (distance(pmt.fightersRed[nextGroupIndex].wayPoints[0], pmt.gunsRed[k].makePosit()) < 0.9 * pmt.fightersRed[nextGroupIndex].actionRadius) && pmt.fightersRed[nextGroupIndex].available)	{
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from our airfield at grid " + removeUnderscores(grid(pmt.fightersRed[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and patrol the airspace at grid " + removeUnderscores(pmt.gunsRed[k].grid) + '.';
							pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersRed.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersRed[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersBlue.getSize() > 0)													
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.gunsRed[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)										
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.gunsRed[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersRed[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersRed[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.gunsRed[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersRed[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersRed.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersRed[nextGroupIndex].wayPoints[7];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersRed[nextGroupIndex].wayPoints[9];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersRed[nextGroupIndex].wayPoints[10];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersRed[nextGroupIndex].wayPoints[8];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersRed[nextGroupIndex].wayPoints[6];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersRed[nextGroupIndex].wayPoints[4];
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersRed[nextGroupIndex].wayPoints[0];
							pmt.fightersRed.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersRed.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersRed.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersRed.mod(nextGroupIndex)->available = false;
							pmt.gunsRed.mod(k)->tokenOfLove = true;
							if(pmt.fightersRed[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersRed.getSize() - 1)
										pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
									if(nextGroupIndex < pmt.fightersRed.getSize() - 1)	{
										if(pmt.fightersRed[nextGroupIndex].groupname != pmt.fightersRed[nextGroupIndex + 1].groupname)
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet.";
										else
											pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(int(flightAlt * 3.2808)) + " feet. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersRed.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersRed.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersRed[jj].groupname)	{
									if(pmt.fightersRed.getSize() - 1 > jj)
										currGroupName = pmt.fightersRed[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																
						}
					if(nextGroupIndex == pmt.fightersRed.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersRed.getSize())										
				break;
			if(!pmt.fightersRed[nextGroupIndex].available)	{							
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(previousGroupIndex == nextGroupIndex)	{												
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[0] = "Mission: FREE FLIGHT";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[1] = "Either Your squadron is too far from the zone of operations,";
				pmt.fightersRed.mod(nextGroupIndex)->briefingLines[2] = "or the end of the war is drawing near. Enjoy a free flight.";
				pmt.fightersRed.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersRed.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersRed[jj].groupname)	{
						if(pmt.fightersRed.getSize() - 1 > jj)
							currGroupName = pmt.fightersRed[jj + 1].groupname;
							nextGroupIndex = jj + 1;
								break;
					}
			}
			if(nextGroupIndex == pmt.fightersRed.getSize() || nextGroupIndex == 0)						
				break;
		}
	}
	if(pmt.fightersBlue.getSize() > 0)	{
		currGroupName = pmt.fightersBlue[0].groupname;
		nextGroupIndex = 0;
		previousGroupIndex = 0;
		while(nextGroupIndex < pmt.fightersBlue.getSize())	{
			previousGroupIndex = nextGroupIndex;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{					
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.airfieldTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.airfieldTargetsBlue.getSize(); j++)	{
					bool  interceptCondition = false;
					int selectedABIndex = 0;
					int ownBaseIndex = 0;
					bool gotJabos = false;															
					std::string currIncomingGroupname = "NoString";
					std::string currAFName = pmt.airfieldTargetsBlue[j].name;
					int currTokenOfAttention = pmt.airfieldTargetsBlue[j].tokenOfAttention;										
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)
						if((pmt.airfieldTargetsBlue[k].tokenOfAttention != 0) && (currTokenOfAttention <= pmt.airfieldTargetsBlue[k].tokenOfAttention) && (!pmt.airfieldTargetsBlue[k].tokenOfLove))	{		
							currAFName = pmt.airfieldTargetsBlue[k].name;	
							currTokenOfAttention = pmt.airfieldTargetsBlue[k].tokenOfAttention;
							selectedABIndex = k;
						}																
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)																									
						if(distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsBlue[k].airfieldPosit) < 2000)	{
							for(int kl = 0; kl < pmt.bombersRed.getSize(); kl++)	{
								for(int kj = 0; kj <= pmt.bombersRed[kl].getWPLimit(); kj++)
									if((pmt.bombersRed[kl].wayPointTypes[kj] == "GATTACK_POINT" || pmt.bombersRed[kl].wayPointTypes[kj] == "GATTACK_TARG") && (distance(pmt.airfieldTargetsBlue[k].airfieldPosit, pmt.bombersRed[kl].wayPoints[kj]) < intZRadius) && (distance(pmt.bombersRed[kl].wayPoints[5], pmt.bombersRed[kl].wayPoints[kj]) < interceptRange))	{
										interceptCondition = true;
										ownBaseIndex = k;
										pmt.bombersRed.mod(kl)->escorted = true;					
										break;
									}
								if(interceptCondition)						
									break;
							}
							for(int kl = 0; kl < pmt.jabosRed.getSize(); kl++)	{
								for(int kj = 0; kj <= pmt.jabosRed[kl].getWPLimit(); kj++)
									if((pmt.jabosRed[kl].wayPointTypes[kj] == "GATTACK_POINT" || pmt.jabosRed[kl].wayPointTypes[kj] == "GATTACK_TARG") && (distance(pmt.airfieldTargetsBlue[k].airfieldPosit, pmt.jabosRed[kl].wayPoints[kj]) < intZRadius) && (distance(pmt.jabosRed[kl].wayPoints[5], pmt.jabosRed[kl].wayPoints[kj]) < interceptRange))	{
										interceptCondition = true;
										ownBaseIndex = k;
										gotJabos = true;
										pmt.jabosRed.mod(kl)->escorted = true;					
										break;
									}
								if(interceptCondition)						
									break;
							}
							if(interceptCondition)
								break;
						}
					for(int k = 0; k < pmt.airfieldTargetsBlue.getSize(); k++)	{
						if((ownBaseIndex == k) && pmt.fightersBlue[nextGroupIndex].available && interceptCondition)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: INTERCEPTION";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nEnemy bombers are aproaching our airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ". Take off imediately and fly towards grid ";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;														
							position interceptPosit;											
							if((pmt.bombersRed.getSize() > 0) && (!gotJabos))								
								for(int kkk = 0; kkk < pmt.bombersRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersRed[kkk].wayPoints[kkkn], pmt.airfieldTargetsBlue[k].airfieldPosit) < intZRadius)	{
												flightAlt = pmt.bombersRed[kkk].wayPoints[kkkn].altitude + 1000;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												currIncomingGroupname = pmt.bombersRed[kkk].groupname;
												interceptPosit = pmt.bombersRed[kkk].wayPoints[5];
												break;
											}
							if((pmt.jabosRed.getSize() > 0) && !altitudeSet && gotJabos)									
								for(int kkk = 0; kkk < pmt.jabosRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosRed[kkk].wayPoints[kkkn], pmt.airfieldTargetsBlue[k].airfieldPosit) < intZRadius)	{
												flightAlt = pmt.jabosRed[kkk].wayPoints[kkkn].altitude + 1000;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												currIncomingGroupname = pmt.jabosRed[kkk].groupname;
												interceptPosit = pmt.jabosRed[kkk].wayPoints[5];
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = removeUnderscores(grid(interceptPosit, "SIDCMission.state")) + ". Immediately after take off, climb to the altitude of " + std::to_string((int)flightAlt) + " meters.";
							interceptPosit.altitude = flightAlt;
							if(!gotJabos)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = interceptPosit;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "AATTACK_BOMBERS";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointActions[5] = currIncomingGroupname + " 1";
							}
							if(gotJabos)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = interceptPosit;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "AATTACK_FIGHTERS";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 400;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointActions[5] = currIncomingGroupname + " 1";
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[6] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[6] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[6] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[7] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[7].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[7] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[7] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "After You\' ve taken off, proceed to intercept imediately!";
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[12] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;															
						}
						if((pmt.airfieldTargetsBlue[k].name == currAFName) && (pmt.airfieldTargetsBlue[k].tokenOfAttention != 0) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.airfieldTargetsBlue[k].airfieldPosit) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available && !interceptCondition)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nFriendly airfield at grid  " + removeUnderscores(pmt.airfieldTargetsBlue[k].grid) + " is a likely target of enemy bombers. Take off from the airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to the patrol zone and shoot down ant enemy planes You may encounter.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersRed.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersRed[kkk].wayPoints[kkkn], pmt.airfieldTargetsBlue[k].airfieldPosit) < 500)	{
												flightAlt = pmt.bombersRed[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosRed.getSize() > 0 && !altitudeSet)										
								for(int kkk = 0; kkk < pmt.jabosRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosRed[kkk].wayPoints[kkkn], pmt.airfieldTargetsBlue[k].airfieldPosit) < 500)	{
												flightAlt = pmt.jabosRed[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.airfieldTargetsBlue[k].airfieldPosit;
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							if(pmt.airfieldTargetsBlue[k].tokenOfLove <= 2)
								pmt.airfieldTargetsBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if((pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname) || (nextGroupIndex == pmt.fightersBlue.getSize() - 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off proceed to the altitude of " + std::to_string(int(flightAlt)) + " meters.";
									else
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, proceed to the altitude of " + std::to_string(int(flightAlt)) + " meters. Make sure the rest of the formation can keep up with You.";
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																
						}
					}
					if(nextGroupIndex == pmt.fightersBlue.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())									
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{				
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.radarsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.radarsBlue.getSize(); j++)	{
					std::string currStaticID = pmt.radarsBlue[0].staticid;
					int currTokenOfAttention = pmt.radarsBlue[0].tokenOfAttention;
					int blueFGroups = getBlueFGroupNo(pmt);								
					int blueBGroups = getBlueBGroupNo(pmt);
					int blueJGroups = getBlueJGroupNo(pmt);
					int redBGroups = getRedBGroupNo(pmt);
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)					
						if(!pmt.radarsBlue[k].tokenOfAttention && !pmt.radarsBlue[k].tokenOfLove)	{
							currStaticID = pmt.radarsBlue[k].staticid;
							currTokenOfAttention = pmt.radarsBlue[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)
						if((currTokenOfAttention <= pmt.radarsBlue[k].tokenOfAttention) && (!(pmt.radarsBlue[k].tokenOfLove)))	{	
							currStaticID = pmt.radarsBlue[k].staticid;	
							currTokenOfAttention = pmt.radarsBlue[k].tokenOfAttention;
						}
					if((blueFGroups > redBGroups) && (pmt.radarsBlue.getSize() >= redBGroups) && ((blueBGroups + blueJGroups) == 0))
						for(int ik = 0; ik < pmt.radarsBlue.getSize(); ik++)
							if(pmt.radarsBlue[ik].staticid == currStaticID)	{
								pmt.radarsBlue.mod(ik)->tokenOfLove = false;
								break;
							}
					for(int k = 0; k < pmt.radarsBlue.getSize(); k++)
						if((pmt.radarsBlue[k].staticid == currStaticID) && (pmt.radarsBlue[k].tokenOfAttention != 0) && (!pmt.radarsBlue[k].tokenOfLove) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.radarsBlue[k].makePosit()) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nYou will take off from our airfield at grid  " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and patrol the area at grid " + removeUnderscores(pmt.radarsBlue[k].grid) + ". Our radar which is in the area could be the target of an enemy attack.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersRed.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersRed[kkk].wayPoints[kkkn], pmt.radarsBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersRed[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosRed.getSize() > 0 && !altitudeSet)															
								for(int kkk = 0; kkk < pmt.jabosRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosRed[kkk].wayPoints[kkkn], pmt.radarsBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosRed[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.radarsBlue[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							pmt.radarsBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())									
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{						
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.factoryTargetsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.factoryTargetsBlue.getSize(); j++)	{
					std::string currFName = pmt.factoryTargetsBlue[0].name;
					int currTokenOfAttention = pmt.factoryTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)						
						if(!pmt.factoryTargetsBlue[k].tokenOfAttention)	{
							currFName = pmt.factoryTargetsBlue[k].name;
							currTokenOfAttention = pmt.factoryTargetsBlue[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)
						if((currTokenOfAttention > pmt.factoryTargetsBlue[k].tokenOfAttention) && (!(pmt.factoryTargetsBlue[k].tokenOfLove)))	{	
							currFName = pmt.factoryTargetsBlue[k].name;	
							currTokenOfAttention = pmt.factoryTargetsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.factoryTargetsBlue.getSize(); k++)
						if((pmt.factoryTargetsBlue[k].name == currFName) && (pmt.factoryTargetsBlue[k].tokenOfAttention != 0) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.factoryTargetsBlue[k].factoryPosit) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to grid " + removeUnderscores(pmt.factoryTargetsBlue[k].grid) + ", patrol there and shoot down enemy planes You may detect in the patrol zone.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																	
							if(pmt.bombersRed.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersRed[kkk].wayPoints[kkkn], pmt.factoryTargetsBlue[k].factoryPosit) < 500)	{
												flightAlt = pmt.bombersRed[kkk].wayPoints[kkkn].altitude + 700;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosRed.getSize() > 0 && !altitudeSet)													
								for(int kkk = 0; kkk < pmt.jabosRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosRed[kkk].wayPoints[kkkn], pmt.factoryTargetsBlue[k].factoryPosit) < 500)	{
												flightAlt = pmt.jabosRed[kkk].wayPoints[kkkn].altitude + 700;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.factoryTargetsBlue[k].factoryPosit;
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							pmt.factoryTargetsBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())			
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())				
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{			
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.tanksBlue.getSize() > 0)	
				for(int j = 0; j < pmt.tanksBlue.getSize(); j++)	{
					std::string currCName = pmt.tanksBlue[0].chiefname;
					int currTokenOfAttention = pmt.tanksBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)					
						if(!pmt.tanksBlue[k].tokenOfAttention)	{
							currCName = pmt.tanksBlue[k].chiefname;
							currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((currTokenOfAttention > pmt.tanksBlue[k].tokenOfAttention) && (!(pmt.tanksBlue[k].tokenOfLove)))	{
							currCName = pmt.tanksBlue[k].chiefname;	
							currTokenOfAttention = pmt.tanksBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.tanksBlue.getSize(); k++)
						if((pmt.tanksBlue[k].chiefname == currCName) && (pmt.tanksBlue[k].tokenOfAttention != 0) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.tanksBlue[k].makePosit()) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nOur armor is likely to be targeted by enemy air power. Take off from the airfield at " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to grid " + removeUnderscores(grid(pmt.tanksBlue[k].makePosit(), "SIDCMission.state")) + ", and patrol there. Attack and destroy any enemy planes You detect.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersRed.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)	{
										if((pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT") || (pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG"))
											if(distance(pmt.bombersRed[kkk].wayPoints[kkkn], pmt.tanksBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersRed[kkk].wayPoints[kkkn].altitude + 700;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
								}
							if(pmt.jabosRed.getSize() > 0 && !altitudeSet)														
								for(int kkk = 0; kkk < pmt.jabosRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if((pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT") || (pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG"))	
											if(distance(pmt.jabosRed[kkk].wayPoints[kkkn], pmt.tanksBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosRed[kkk].wayPoints[kkkn].altitude + 700;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.tanksBlue[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							pmt.tanksBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																	
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())											
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{						
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.shipsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.shipsBlue.getSize(); j++)	{
					std::string currCName = pmt.shipsBlue[0].chiefname;
					int currTokenOfAttention = pmt.shipsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)							
						if(!pmt.shipsBlue[k].tokenOfAttention)	{
							currCName = pmt.shipsBlue[k].chiefname;
							currTokenOfAttention = pmt.shipsBlue[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)
						if((currTokenOfAttention > pmt.shipsBlue[k].tokenOfAttention) && (!(pmt.shipsBlue[k].tokenOfLove)))	{	
							currCName = pmt.shipsBlue[k].chiefname;	
							currTokenOfAttention = pmt.shipsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.shipsBlue.getSize(); k++)
						if((pmt.shipsBlue[k].chiefname == currCName) && (pmt.shipsBlue[k].tokenOfAttention != 0) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.shipsBlue[k].makePosit()) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from our airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", fly to the patrol zone at grid " + removeUnderscores(grid(pmt.shipsBlue[k].makePosit(), "SIDCMission.state")) + ", patrol there and shoot down enemy planes that shwo up.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																	
							if(pmt.bombersRed.getSize() > 0)													
								for(int kkk = 0; kkk < pmt.bombersRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersRed[kkk].wayPoints[kkkn], pmt.shipsBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersRed[kkk].wayPoints[kkkn].altitude + 700;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosRed.getSize() > 0 && !altitudeSet)												
								for(int kkk = 0; kkk < pmt.jabosRed.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosRed[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosRed[kkk].wayPoints[kkkn], pmt.shipsBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosRed[kkk].wayPoints[kkkn].altitude + 700;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.shipsBlue[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							pmt.shipsBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																	
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())									
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())											
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{								
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.bombersBlue.getSize() > 0)														
				for(int k = 0; k < pmt.bombersBlue.getSize(); k++)	{
					std::string currBGroupName;															
					double distBFaBB;																	
					double distToTarget;																
					position bomberTargetPosit;															
					int bomberTargetIndex;																
					if(!pmt.bombersBlue[k].available && !pmt.bombersBlue[k].escorted)					
						if(pmt.bombersBlue[k].wayPoints[1].positionX != 0 && pmt.bombersBlue[k].wayPoints[1].positionY != 0 && pmt.bombersBlue[k].wayPoints[1].altitude != 0 && pmt.bombersBlue[k].wayPointTypes[1] != "NoString")	{
							distBFaBB = distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.bombersBlue[k].wayPoints[0]);
							for(int ji = 0; ji < 20; ji++)	
								if(pmt.bombersBlue[k].wayPointTypes[ji] == "GATTACK_POINT" || pmt.bombersBlue[k].wayPointTypes[ji] == "GATTACK_TARG")	{
									distToTarget = distance(pmt.bombersBlue[k].wayPoints[0], pmt.bombersBlue[k].wayPoints[ji]);
									bomberTargetPosit = pmt.bombersBlue[k].wayPoints[ji];
									bomberTargetIndex = ji;
									break;
								}
							if(((distBFaBB + distToTarget) < (pmt.fightersBlue[nextGroupIndex].actionRadius * 0.8)) && (distBFaBB < (pmt.bombersBlue[k].actionRadius * 0.1)))	{
								currBGroupName = pmt.bombersBlue[k].groupname;
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: ESCORT";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nFriendly bombers need escort to their target at grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ". Take off from the airbase at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and proceed to the rendez- vous point at grid " + removeUnderscores(grid(pmt.bombersBlue[k].wayPoints[0], "SIDCMission.state")) + ". The bombers will be waiting for You there.";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								double newPeriod = ((distBFaBB / 1000) / 400) * 60 + 3;					
								triangularPattern TP;
								TP.setPattern(newPeriod, pmt.bombersBlue[k].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.bombersBlue.mod(k)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.bombersBlue.mod(k)->wayPointTypes[ii] = "NORMFLY";
									pmt.bombersBlue.mod(k)->wayPointSpeed[ii] = 300;
								}
								pmt.bombersBlue.mod(k)->briefingLines[3] = "\n\nAfter You\' ve taken off, wait for the escort fighters over the airfield.";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								int endLineNumber = 1;
								int lastIndex;
								for(int iii = 4; iii <= bomberTargetIndex + 1; iii++)	{
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[iii - 2] = pmt.bombersBlue[k].wayPoints[iii];
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[iii - 2].altitude = pmt.bombersBlue[k].wayPoints[iii].altitude + 500;
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[iii - 2] = pmt.bombersBlue[k].wayPointSpeed[iii];
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[iii - 2] = "ESCORT";
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointActions[iii - 2] = currBGroupName + ' ' + std::to_string(endLineNumber);
									endLineNumber++;
									lastIndex = iii - 2;
								}
								lastIndex++;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[lastIndex] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[lastIndex] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[lastIndex] = "LANDING";
								pmt.fightersBlue.mod(nextGroupIndex)->available = false;
								pmt.bombersBlue.mod(k)->escorted = true;
								if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off, proceed to the rendez- vous point.";
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersBlue[jj].groupname)	{
										if(pmt.fightersBlue.getSize() - 1 > jj)
											currGroupName = pmt.fightersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())												
				break;	
			if(!pmt.fightersBlue[nextGroupIndex].available)	{								
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.bombersBlue.getSize() > 0)										
				for(int k = 0; k < pmt.bombersBlue.getSize(); k++)	{
					std::string currBGroupName;														
					position bomberTargetPosit;													
					if(!pmt.bombersBlue[k].available)						
						if((pmt.bombersBlue[k].wayPoints[1].positionX != 0) && (pmt.bombersBlue[k].wayPoints[1].positionY != 0) && (pmt.bombersBlue[k].wayPoints[1].altitude != 0) && (pmt.bombersBlue[k].wayPointTypes[1] != "NoString"))	{
							for(int ji = 0; ji < 20; ji++)	
								if((pmt.bombersBlue[k].wayPointTypes[ji] == "GATTACK_POINT") || (pmt.bombersBlue[k].wayPointTypes[ji] == "GATTACK_TARG"))	{
									bomberTargetPosit = pmt.bombersBlue[k].wayPoints[ji];
									break;
								}
							if(distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], bomberTargetPosit) < (0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius))	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: FIGHTER SWEEP";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", proceed to grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ", patrol there and shoot down any enemy planes You detect.";
								double flightAlt = randAlt(8000, 1000);
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
								pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								triangularPattern TP;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
								}
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = bomberTargetPosit;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5].altitude = flightAlt;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
								squarePattern SP;
								SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
								for(int ija = 6; ija <= 11; ija++)	{
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
								}
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13].altitude = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "LANDING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->available = false;
								if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}	
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersBlue[jj].groupname)	{
										if(pmt.fightersBlue.getSize() - 1 > jj)
											currGroupName = pmt.fightersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())										
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{							
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.jabosBlue.getSize() > 0)															
				for(int k = 0; k < pmt.jabosBlue.getSize(); k++)	{
					std::string currBGroupName;													
					position bomberTargetPosit;													
					if(!pmt.jabosBlue[k].available)						
						if((pmt.jabosBlue[k].wayPoints[1].positionX != 0) && (pmt.jabosBlue[k].wayPoints[1].positionY != 0) && (pmt.jabosBlue[k].wayPoints[1].altitude != 0) && (pmt.jabosBlue[k].wayPointTypes[1] != "NoString"))	{
							for(int ji = 0; ji < 20; ji++)	
								if((pmt.jabosBlue[k].wayPointTypes[ji] == "GATTACK_POINT") || (pmt.jabosBlue[k].wayPointTypes[ji] == "GATTACK_TARG"))	{
									bomberTargetPosit = pmt.jabosBlue[k].wayPoints[ji];
									break;
								}
							if(distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], bomberTargetPosit) < (0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius))	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: FIGHTER SWEEP";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airbase at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", proceed to grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ", patrol there and engage and destroy enemy aircraft You may encounter there.";
								double flightAlt = randAlt(3000, 1000);
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
								pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								triangularPattern TP;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
								}
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = bomberTargetPosit;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5].altitude = flightAlt;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
								squarePattern SP;
								SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
								for(int ija = 6; ija <= 11; ija++)	{
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
								}
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13].altitude = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "LANDING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->available = false;
								if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
										if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
											if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
												pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
											else
												pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
										}
									}	
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersBlue[jj].groupname)	{
										if(pmt.fightersBlue.getSize() - 1 > jj)
											currGroupName = pmt.fightersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())												
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{								
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.jabosBlue.getSize() > 0)															
				for(int k = 0; k < pmt.jabosBlue.getSize(); k++)	{
					std::string currBGroupName;															
					double distBFaBB;																	
					double distToTarget;																
					position bomberTargetPosit;															
					int bomberTargetIndex;																
					if(!pmt.jabosBlue[k].available && !pmt.jabosBlue[k].escorted)						
						if(pmt.jabosBlue[k].wayPoints[1].positionX != 0 && pmt.jabosBlue[k].wayPoints[1].positionY != 0 && pmt.jabosBlue[k].wayPoints[1].altitude != 0 && pmt.jabosBlue[k].wayPointTypes[1] != "NoString")	{
							distBFaBB = distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.jabosBlue[k].wayPoints[0]);
							for(int ji = 0; ji < 20; ji++)	
								if(pmt.jabosBlue[k].wayPointTypes[ji] == "GATTACK_POINT" || pmt.jabosBlue[k].wayPointTypes[ji] == "GATTACK_TARG")	{
									distToTarget = distance(pmt.jabosBlue[k].wayPoints[0], pmt.jabosBlue[k].wayPoints[ji]);
									bomberTargetPosit = pmt.jabosBlue[k].wayPoints[ji];
									bomberTargetIndex = ji;
									break;
								}
							if(((distBFaBB + distToTarget) < (pmt.fightersBlue[nextGroupIndex].actionRadius * 0.8)) && (distBFaBB < (pmt.jabosBlue[k].actionRadius * 0.1)))	{
								currBGroupName = pmt.jabosBlue[k].groupname;
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: ESCORT";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nOur fighter bombers need escort to their target at grid " + removeUnderscores(grid(bomberTargetPosit, "SIDCMission.state")) + ". Take off from the airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", proceed to the rendez- vous point at grid " + removeUnderscores(grid(pmt.jabosBlue[k].wayPoints[0], "SIDCMission.state")) + ", at the altitude of " + std::to_string(pmt.jabosBlue[k].wayPoints[bomberTargetIndex].altitude + 1000) + " meters. The fighter bombers wil be waiting for You there.";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
								briefingIDNo++;
								double newPeriod = ((distBFaBB / 1000) / 400) * 60 + 3;			
								triangularPattern TP;
								TP.setPattern(newPeriod, pmt.jabosBlue[k].wayPoints[1], 300);		
								for(int ii = 2; ii <= 4; ii++)	{
									pmt.jabosBlue.mod(k)->wayPoints[ii] = TP.getPattern(ii - 2);
									pmt.jabosBlue.mod(k)->wayPointTypes[ii] = "NORMFLY";
									pmt.jabosBlue.mod(k)->wayPointSpeed[ii] = 300;
								}
								pmt.jabosBlue.mod(k)->briefingLines[3] = "\n\nAfter You\' ve taken off, wait for the escort fighters over the airfield.";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
								int endLineNumber = 1;
								int lastIndex;
								for(int iii = 4; iii <= bomberTargetIndex + 1; iii++)	{
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[iii - 2] = pmt.jabosBlue[k].wayPoints[iii];
									pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[iii - 2].altitude = pmt.jabosBlue[k].wayPoints[iii].altitude + 500;
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[iii - 2] = pmt.jabosBlue[k].wayPointSpeed[iii];
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[iii - 2] = "ESCORT";
									pmt.fightersBlue.mod(nextGroupIndex)->wayPointActions[iii - 2] = currBGroupName + ' ' + std::to_string(endLineNumber);
									endLineNumber++;
									lastIndex = iii - 2;
								}
								lastIndex++;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[lastIndex] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[lastIndex] = 300;
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[lastIndex] = "LANDING";
								pmt.fightersBlue.mod(nextGroupIndex)->available = false;
								pmt.jabosBlue.mod(k)->escorted = true;
								if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off, proceed to the rendez- vous point.";
									if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
									if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
									if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
									}
								}
								for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
									if(currGroupName == pmt.fightersBlue[jj].groupname)	{
										if(pmt.fightersBlue.getSize() - 1 > jj)
											currGroupName = pmt.fightersBlue[jj + 1].groupname;
										nextGroupIndex = jj + 1;
										break;
									}
							}	
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())											
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{							
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.portTargetsBlue.getSize() > 0)											
				for(int j = 0; j < pmt.portTargetsBlue.getSize(); j++)	{
					bool interceptCondition = false;
					int selectedABIndex = 0;
					std::string currIncomingGroupname = "NoString";
					std::string currAFName = pmt.portTargetsBlue[0].name;
					int currTokenOfAttention = pmt.portTargetsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)							
						if(!pmt.portTargetsBlue[k].tokenOfAttention)	{
							currAFName = pmt.portTargetsBlue[k].name;
							currTokenOfAttention = pmt.portTargetsBlue[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)
						if((currTokenOfAttention < pmt.portTargetsBlue[k].tokenOfAttention) && (!(pmt.portTargetsBlue[k].tokenOfLove)))	{	
							currAFName = pmt.portTargetsBlue[k].name;	
							currTokenOfAttention = pmt.portTargetsBlue[k].tokenOfAttention;
							selectedABIndex = k;
						}																
					if(distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.portTargetsBlue[selectedABIndex].portPosit) < 2000)			
						interceptCondition = true;
					for(int k = 0; k < pmt.portTargetsBlue.getSize(); k++)	{
						if((pmt.portTargetsBlue[k].name == currAFName) && (pmt.portTargetsBlue[k].tokenOfAttention != 0) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.portTargetsBlue[k].portPosit) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available && !interceptCondition)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nTake off from the airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", and proceed to grid " + removeUnderscores(pmt.portTargetsBlue[k].grid) + ". Patrol there and shoot down enemy aircraft that show up.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;															
							if(pmt.bombersBlue.getSize() > 0)											
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.portTargetsBlue[k].portPosit) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 600;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)											
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.portTargetsBlue[k].portPosit) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 600;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.portTargetsBlue[k].portPosit;
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							pmt.portTargetsBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																		
						}
					}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())											
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{							
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(pmt.gunsBlue.getSize() > 0)	
				for(int j = 0; j < pmt.gunsBlue.getSize(); j++)	{
					std::string currStaticID = pmt.gunsBlue[0].staticid;
					int currTokenOfAttention = pmt.gunsBlue[0].tokenOfAttention;
					for(int k = 0; k < pmt.gunsBlue.getSize(); k++)							
						if(!pmt.gunsBlue[k].tokenOfAttention)	{
							currStaticID = pmt.gunsBlue[k].staticid;
							currTokenOfAttention = pmt.gunsBlue[k].tokenOfAttention;
							break;
						}
					for(int k = 0; k < pmt.gunsBlue.getSize(); k++)
						if((currTokenOfAttention < pmt.gunsBlue[k].tokenOfAttention) && (!(pmt.gunsBlue[k].tokenOfLove)))	{		
							currStaticID = pmt.gunsBlue[k].staticid;	
							currTokenOfAttention = pmt.gunsBlue[k].tokenOfAttention;
						}
					for(int k = 0; k < pmt.gunsBlue.getSize(); k++)
						if((pmt.gunsBlue[k].staticid == currStaticID) && (pmt.gunsBlue[k].tokenOfAttention != 0) && (distance(pmt.fightersBlue[nextGroupIndex].wayPoints[0], pmt.gunsBlue[k].makePosit()) < 0.9 * pmt.fightersBlue[nextGroupIndex].actionRadius) && pmt.fightersBlue[nextGroupIndex].available)	{
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: CAP";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "\n\nInteligence reports suggest that our artillery may be targetted by enemy air power. Tako off from the airfield at grid " + removeUnderscores(grid(pmt.fightersBlue[nextGroupIndex].wayPoints[0], "SIDCMission.state")) + ", proceed to grid " + removeUnderscores(pmt.gunsBlue[k].grid) + ", patrol there and engage and destroy enemy aircraft You encounter.";
							pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
							briefingIDNo++;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionX = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionX + 2000;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].positionY = pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[0].positionY;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[1].altitude = 500;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[1] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[1] = 300;
							triangularPattern TP;
							TP.setPattern(1, pmt.fightersBlue[nextGroupIndex].wayPoints[1], 300);
							for(int ii = 2; ii <= 4; ii++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ii] = TP.getPattern(ii - 2);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ii] = "NORMFLY";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ii] = 300;
							}
							bool altitudeSet = false;
							double flightAlt;																
							if(pmt.bombersBlue.getSize() > 0)												
								for(int kkk = 0; kkk < pmt.bombersBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.bombersBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")
											if(distance(pmt.bombersBlue[kkk].wayPoints[kkkn], pmt.gunsBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.bombersBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							if(pmt.jabosBlue.getSize() > 0 && !altitudeSet)														
								for(int kkk = 0; kkk < pmt.jabosBlue.getSize(); kkk++)
									for(int kkkn = 0; kkkn < 20; kkkn++)
										if(pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_POINT" || pmt.jabosBlue[kkk].wayPointTypes[kkkn] == "GATTACK_TARG")	
											if(distance(pmt.jabosBlue[kkk].wayPoints[kkkn], pmt.gunsBlue[k].makePosit()) < 500)	{
												flightAlt = pmt.jabosBlue[kkk].wayPoints[kkkn].altitude + 500;
												if(flightAlt > pmt.fightersBlue[nextGroupIndex].serviceCeiling)
													flightAlt = pmt.fightersBlue[nextGroupIndex].serviceCeiling * 0.9;
												altitudeSet = true;
												break;
											}
							pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "Flight altitude: " + std::to_string(flightAlt);
							position flightAltPosit = pmt.gunsBlue[k].makePosit();
							flightAltPosit.altitude = flightAlt;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[5] = flightAltPosit;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[5] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[5] = 350;
							squarePattern SP;
							SP.setPattern(10, pmt.fightersBlue[nextGroupIndex].wayPoints[5], 350);
							for(int ija = 6; ija <= 11; ija++)	{
								pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[ija] = SP.getPattern(ija - 6);
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[ija] = "HUNTING";
								pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[ija] = 350;
							}
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[12] = pmt.fightersBlue[nextGroupIndex].wayPoints[7];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[12] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[12] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[13] = pmt.fightersBlue[nextGroupIndex].wayPoints[9];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[13] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[13] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[14] = pmt.fightersBlue[nextGroupIndex].wayPoints[10];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[14] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[14] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[15] = pmt.fightersBlue[nextGroupIndex].wayPoints[8];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[15] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[15] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[16] = pmt.fightersBlue[nextGroupIndex].wayPoints[6];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[16] = "HUNTING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[16] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[17] = pmt.fightersBlue[nextGroupIndex].wayPoints[4];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[17] = "NORMFLY";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[17] = 350;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18] = pmt.fightersBlue[nextGroupIndex].wayPoints[0];
							pmt.fightersBlue.mod(nextGroupIndex)->wayPoints[18].altitude = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointTypes[18] = "LANDING";
							pmt.fightersBlue.mod(nextGroupIndex)->wayPointSpeed[18] = 300;
							pmt.fightersBlue.mod(nextGroupIndex)->available = false;
							pmt.gunsBlue.mod(k)->tokenOfLove = true;
							if(pmt.fightersBlue[nextGroupIndex].groupname == pplog.getGroupName())	{
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "\n\nHome base: " + pplog.getAFName() + '.';
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[3] = "\n\nYour plane will be a member of flight number " + std::to_string(pplog.getFlightNo()) + ", at position number " + std::to_string(pplog.getPlaneNo()) + '.';
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() == 1))	{
									if(nextGroupIndex == pmt.fightersBlue.getSize() - 1)
										pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
									if(nextGroupIndex < pmt.fightersBlue.getSize() - 1)	{
										if(pmt.fightersBlue[nextGroupIndex].groupname != pmt.fightersBlue[nextGroupIndex + 1].groupname)
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off climb to " + std::to_string(flightAlt) + " meters.";
										else
											pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "After You\' ve taken off and formed up, climb to " + std::to_string(flightAlt) + " meters. Make sure the rest of the formation can keep up with You.";
									}
								}
								if((pplog.getFlightNo() == 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the group leader.";
								if((pplog.getFlightNo() != 1) && (pplog.getPlaneNo() != 1))
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[4] = "Take off, form up and follow the flight leader.";	
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[5] = "\n\nPilot information:";
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[6] = "Name: " + pplog.getName();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[7] = "Rank: " + pplog.getRank();
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[8] = "Flight hours: " + std::to_string(pplog.getFHours());
								pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[9] = "Aerial victories: " + std::to_string(pplog.getAtAKills());
								if((pplog.getBALine() != "NoString") && (pplog.getBALine() != "No planes or no airfields left."))	{
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[10] = "\nAdditional information:";
									pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[11] = pplog.getBALine();
								}
							}
							for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
								if(currGroupName == pmt.fightersBlue[jj].groupname)	{
									if(pmt.fightersBlue.getSize() - 1 > jj)
										currGroupName = pmt.fightersBlue[jj + 1].groupname;
									nextGroupIndex = jj + 1;
									break;
								}										
							break;																
						}
					if(nextGroupIndex == pmt.fightersBlue.getSize())											
						break;
				}
			if(nextGroupIndex == pmt.fightersBlue.getSize())											
				break;
			if(!pmt.fightersBlue[nextGroupIndex].available)	{						
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: NO MISSION AVAILABLE";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Your airfield has been either destroyed or captured by enemy forces.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "If there' s no airfield You can relocate to, You probably lost the war.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
							break;
					}	
			}
			if(previousGroupIndex == nextGroupIndex)	{												
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[0] = "Mission: FREE FLIGHT";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[1] = "Either Your squadron is too far from the zone of operations,";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingLines[2] = "or the end of the war is drawing near. Enjoy a free flight.";
				pmt.fightersBlue.mod(nextGroupIndex)->briefingNo = briefingIDNo;
				briefingIDNo++;
				for(int jj = pmt.fightersBlue.getSize() - 1; jj >= 0 ; jj--)
					if(currGroupName == pmt.fightersBlue[jj].groupname)	{
						if(pmt.fightersBlue.getSize() - 1 > jj)
							currGroupName = pmt.fightersBlue[jj + 1].groupname;
							nextGroupIndex = jj + 1;
								break;
					}
			}
			if(nextGroupIndex == pmt.fightersBlue.getSize() || nextGroupIndex == 0)											
				break;
		}
	}	
}



void saveBriefings(mainTables& pmt, int pmissionNo)	{
	seArray<std::string, 20> briefings;
	briefings.add("[Info]");
	briefings.add("<Name>");
	briefings.add("Info");
	briefings.add("<Slide>");
	briefings.add("");
	briefings.add("<Caption>");
	briefings.add("Self Inflicted Dynamic Campaign mission No. " + std::to_string(pmissionNo));
	briefings.add("<Slide>");
	briefings.add("");
	briefings.add("<Caption>");
	briefings.add(makeMainBriefingLine(pmt));
	for(int i = 0; i < pmt.bombersRed.getSize(); i++)
		if(pmt.bombersRed[i].briefingNo != 0 && pmt.bombersRed[i].getBriefingLimit() != -1)	{
			briefings.add('[' + std::to_string(pmt.bombersRed[i].briefingNo) + ']');
			briefings.add("<Name>");
			briefings.add(pmt.bombersRed[i].briefingLines[0]);
			briefings.add("<Description>");
			for(int j = 0; j <= pmt.bombersRed[i].getBriefingLimit(); j++)
				briefings.add(pmt.bombersRed[i].briefingLines[j]);
		}
	for(int i = 0; i < pmt.bombersBlue.getSize(); i++)
		if(pmt.bombersBlue[i].briefingNo != 0 && pmt.bombersBlue[i].getBriefingLimit() != -1)	{
			briefings.add('[' + std::to_string(pmt.bombersBlue[i].briefingNo) + ']');
			briefings.add("<Name>");
			briefings.add(pmt.bombersBlue[i].briefingLines[0]);
			briefings.add("<Description>");
			for(int j = 0; j <= pmt.bombersBlue[i].getBriefingLimit(); j++)
				briefings.add(pmt.bombersBlue[i].briefingLines[j]);
		}
	for(int i = 0; i < pmt.jabosRed.getSize(); i++)
		if(pmt.jabosRed[i].briefingNo != 0 && pmt.jabosRed[i].getBriefingLimit() != -1)	{
			briefings.add('[' + std::to_string(pmt.jabosRed[i].briefingNo) + ']');
			briefings.add("<Name>");
			briefings.add(pmt.jabosRed[i].briefingLines[0]);
			briefings.add("<Description>");
			for(int j = 0; j <= pmt.jabosRed[i].getBriefingLimit(); j++)
				briefings.add(pmt.jabosRed[i].briefingLines[j]);
		}
	for(int i = 0; i < pmt.jabosBlue.getSize(); i++)
		if(pmt.jabosBlue[i].briefingNo != 0 && pmt.jabosBlue[i].getBriefingLimit() != -1)	{
			briefings.add('[' + std::to_string(pmt.jabosBlue[i].briefingNo) + ']');
			briefings.add("<Name>");
			briefings.add(pmt.jabosBlue[i].briefingLines[0]);
			briefings.add("<Description>");
			for(int j = 0; j <= pmt.jabosBlue[i].getBriefingLimit(); j++)
				briefings.add(pmt.jabosBlue[i].briefingLines[j]);
		}
	for(int i = 0; i < pmt.fightersRed.getSize(); i++)
		if(pmt.fightersRed[i].briefingNo != 0 && pmt.fightersRed[i].getBriefingLimit() != -1)	{
			briefings.add('[' + std::to_string(pmt.fightersRed[i].briefingNo) + ']');
			briefings.add("<Name>");
			briefings.add(pmt.fightersRed[i].briefingLines[0]);
			briefings.add("<Description>");
			for(int j = 0; j <= pmt.fightersRed[i].getBriefingLimit(); j++)
				briefings.add(pmt.fightersRed[i].briefingLines[j]);
		}
	for(int i = 0; i < pmt.fightersBlue.getSize(); i++)
		if(pmt.fightersBlue[i].briefingNo != 0 && pmt.fightersBlue[i].getBriefingLimit() != -1)	{
			briefings.add('[' + std::to_string(pmt.fightersBlue[i].briefingNo) + ']');
			briefings.add("<Name>");
			briefings.add(pmt.fightersBlue[i].briefingLines[0]);
			briefings.add("<Description>");
			for(int j = 0; j <= pmt.fightersBlue[i].getBriefingLimit(); j++)
				briefings.add(pmt.fightersBlue[i].briefingLines[j]);
		}
	std::ofstream os("SIDCMission.briefing");
	for(int k = 0; k < briefings.getSize(); k++)
		os << briefings[k] + '\n';
}




